# $Log: not supported by cvs2svn $
# Revision 1.163  2013/11/13 shang
# fixed an important bug that rescan bad device should not be put behind reading config,
# instead it should be run before doing the selections in reading config, otherwise, the bad device left from
# previous config will affect the selection, for example, lattice nux36nuy19 h.defaultDP, reading h.defaultDP makes S36A:P1 button un-selectable
# because it is bad for fast orbit correction, however, it is ok for workstaion orbit correction; but switching to h.default
# could not select it because it was left as bad device; its state is changed after reading h.default. So that the selection display is wrong
# for h.default after reading h.defaultDP.
#
# Revision 1.162  2013/04/08 shang
# commented out the default button for change lattice because it is dangerous to change the default lattice, and we had an occasion
# that it was pressed by a non-familiar use who did not know what it really meant and this caused our orbit correction went wrong
# (almost dumped the beam). Since we have another software for changing the default lattice, this button is not needed in this 
# application.
#
# Revision 1.161  2011/08/26 16:10:49  shang
# splited the count button into "count_bpm" and "count_corr" for booster applications because booster bpm and correctors are shown
# in the same sector widget, however, user would like to count bpm and corrector separately.
#
# Revision 1.160  2011/08/25 21:52:19  shang
# modified so that variable names are consistent with the PV names for non-numeric sectors which will be much easier for outside application programming, and added procedures for updating booster orbit correction configration database.
#
# Revision 1.159  2011/08/01 14:31:34  shang
# corrected the nameFlag for booster in APSRescanBadOrbitDevices which starts with S instead of B.
#
# Revision 1.158  2011/07/29 17:29:12  shang
# made the APSRescanBadOrbitDevices also work for booster bpms.
#
# Revision 1.157  2011/06/13 18:59:18  shang
# added color0 option to APSSRSectorButtons so that user can define the check button color.
#
# Revision 1.156  2010/12/21 17:59:43  lemery
# Fixed procedure name in error message.
#
# Revision 1.155  2010/01/29 22:17:03  soliday
# Updated to deal with an issue related to the sector buttons being defined
# as unchecked before they are created.
#
# Revision 1.154  2010/01/29 17:12:13  shang
# increased the status window height and increase the sector selection widget size so that all characters and buttons can be shown due to the increased
# font size and widget size of new tcl version.
#
# Revision 1.153  2010/01/29 17:04:55  soliday
# Fixed an issue with the selection boxes when switching from one mode
# where the box is disabled to another where it isn't.
#
# Revision 1.152  2009/10/30 20:00:45  shang
# moved searching the configuration list inside of generating/updating configuration database, so that it does no search for adding new configs and this makes writing config can be done within one second. And added bpm pv type choice for rf controllow.
#
# Revision 1.151  2009/10/23 19:39:57  shang
# added nameTypeList argument to APSReadOrbitCorrectionConfig proc so that it can also read configurations for bpm only or corrector only.
#
# Revision 1.150  2009/10/19 17:00:31  soliday
# Fixed a problem related to reading variables that don't exist.
#
# Revision 1.149  2009/09/23 18:37:10  soliday
# Updated the APSSRSectorUnsetMissing function to verify that the nameFlag variable
# exists before reading it.
#
# Revision 1.148  2009/09/23 15:56:59  soliday
# Updated because of changes in Tcl/Tk 8.5. The checkbuttons look and behave
# differently. My changes restore the old look and behavior and will still work
# if using an older version of Tcl/Tk.
#
# Revision 1.147  2009/01/22 22:51:33  shang
# now it displays bpms with different colors by their electronics type.
#
# Revision 1.146  2008/10/30 20:47:39  shang
# Improved the speed of updating configuration database
#
# Revision 1.145  2008/08/08 18:46:19  shang
# modified to set the despike flag to zero for xray bpms per Louis' request.
#
# Revision 1.144  2008/07/07 19:51:35  shang
# added P0s to rf controllaw
#
# Revision 1.143  2008/02/06 17:44:46  soliday
# Removed calls to setfacl because it is no longer needed.
#
# Revision 1.142  2008/01/17 16:33:51  soliday
# Put setfacl commands inside of catch statements. I don't think the commands
# are needed anymore with the new file servers but I am not sure.
#
# Revision 1.141  2007/07/27 21:06:02  shang
# modified APSWriteSRConfig to return to the directory before it is called.
#
# Revision 1.140  2007/04/10 19:37:17  shang
# modified the updating description database procedure to ignore the non [hv].* configuration
#
# Revision 1.139  2007/04/03 14:44:04  shang
# now uses --> to connect the config and description
#
# Revision 1.138  2007/04/03 14:38:17  shang
# fixed a typo and modified the write config to be able to update the description database for rf orbitcontrollaw.
#
# Revision 1.137  2007/04/03 14:22:18  shang
# fixed a bug in APSUpdateConfigDescriptionDatabase to accept linkConfig opt
#
# Revision 1.136  2007/04/02 14:46:47  shang
# now removes the description database file if there are no active configs.
#
# Revision 1.135  2007/03/30 22:27:09  shang
# removed setfacl command for description database file because it returns error if not setting by owner.
#
# Revision 1.134  2007/03/30 21:50:09  shang
# removed the empty lines in the config description database file.
#
# Revision 1.133  2007/03/30 21:43:31  shang
# added -nowarnings to processing the description database file.
#
# Revision 1.132  2007/03/30 19:27:04  shang
# fixed a bug in obtaining itemList from description database file.
#
# Revision 1.131  2007/03/30 19:21:48  shang
# added missing choiceList of configuration names in the latest change.
#
# Revision 1.130  2007/03/30 19:15:33  shang
# modified the configuration database which now contains all the configurations and modified
# the description to contains the configuration name so that the tcl code for combining configuration name
# and its description is no longer needed.
#
# Revision 1.129  2007/03/29 20:42:05  shang
# changed the default keep days for a new config from -1 (forever) to 180.
#
# Revision 1.128  2006/10/10 22:08:17  shang
# fixed a typo/
#
# Revision 1.127  2006/10/10 22:04:25  shang
# added KeepDays, CreationTime, CreationDate parameters to config
#
# Revision 1.126  2006/09/21 20:09:40  soliday
# Updated because of PV name changes.
#
# Revision 1.125  2006/08/28 18:48:47  shang
# modified to update the description database file only as needed.
#
# Revision 1.124  2006/07/19 05:44:49  borland
# Fixed problem in last change.
#
# Revision 1.123  2006/07/19 05:38:16  borland
# Fixed problem with missing configList variable when updating database.
#
# Revision 1.122  2006/07/10 15:57:38  shang
# modified the updating description database to remove the configures that no-longer exist and
# use the description database for listing when "P" button is pressed in the configuration GUI.
# This processes much faster.
#
# Revision 1.121  2006/07/10 15:18:45  shang
# added APSUpdateConfigDescriptionDatabase and update the description when a new configuration is created or existing configuration is modified.
#
# Revision 1.120  2006/03/30 16:26:38  shang
# increased the tab frame height to be able to display all elements on linux since
# linux tcl seems to have bigger font size.
#
# Revision 1.119  2006/03/07 16:51:27  shang
# replaced the radio button of "SVD analysis" by a button to do the SVD analysis directly
# after "SVD analysis" is pressed so that "compute" button will only be used for compute irm;
# and modified to display the signular value plots update to largest singular to be used.
#
# Revision 1.118  2006/01/27 22:59:35  shang
# added displaying condition number and number of singular values used when read
# configuration button is pressed.
#
# Revision 1.117  2006/01/19 21:45:29  emery
# Fixed oversight in previous change. Check the length of glob command result
# before running "file delete" on it.
#
# Revision 1.116  2006/01/19 21:27:36  emery
# Added -nocomplain argument to glob $path/* to prevent tcl error
# return when a directory that is about to be deleted was empty
# in the first place.
#
# Revision 1.115  2005/03/22 00:39:32  emery
# Changed maindir variable to mainDir in procedure to re-generate
# tests file.
#
# Revision 1.114  2004/06/25 05:50:43  emery
# Added test of existence of ${config}DeleteVectors variable before
# using variable. This variable isn't defined when APS*GenerateOrbCorrFiles
# procedures are called from outside the GUI, say, as in a pem.
# Perhaps an argument deleteVectors should be added to the procedures.
# Removed the u,v,s options from sddspseuodinverse when no SVD analysis
# is requested. This should save some time.
#
# Revision 1.113  2004/06/08 17:17:10  emery
# Changed mainDir to maindir inside loop over directories to
# regenerate OC auxiliary files.
#
# Revision 1.112  2004/06/08 16:43:43  emery
# Untabified some tabs.
#
# Revision 1.111  2004/03/30 19:07:40  shang
# added "SVD analysis"
#
# Revision 1.110  2004/03/01 23:33:35  shang
# removed the statements "APSSetVarAndUpdate ${rootname}ConfigStatus [llength $column]"
# in APSSRWriteConfig proc
#
# Revision 1.109  2004/03/01 22:44:08  shang
# added defaultReflectiveMemoryDown and defaultFBiocDown configuration choices for
# "make default" button
#
# Revision 1.108  2004/02/03 00:42:49  shang
# increases the height of list window for configuration selection
#
# Revision 1.107  2004/02/02 22:44:08  shang
# the configurations are now listed in reversed order.
#
# Revision 1.106  2004/02/02 22:13:13  shang
# added APSGetVariableNameOfSRSectorButtons, APSWriteSelectionArrayConfig and
# APSReadSelectionArrayConfig procedures for non-number sector systems and modified
# APSSRSectorButtons proc to be able to accept a list of sectors.
#
# Revision 1.105  2004/01/28 18:01:26  borland
# Now sets the frequency test range for rf/BP5 controllaw by reading the
# present frequency and adding +/-100Hz.
#
# Revision 1.104  2004/01/28 17:58:21  borland
# *** empty log message ***
#
# Revision 1.103  2003/12/09 18:02:08  shang
# renamed proc APSBoosterPlaneObritConfig by APSBoosterPlaneOrbitConfig
#
# Revision 1.102  2003/12/09 00:14:21  shang
# fixed the bug in APSBoosterPlaneObritConfig that the application variable is not set.
#
# Revision 1.101  2003/12/03 12:58:03  emery
# Added all bpms for rf frequency controllaw.
# Corrected the name for procedure APSSRFRFreqGenerateOrbCorrFiles.
# Removed corrector list processing in APSSRFRFreqGenerateOrbCorrFiles
# since correctors are not relevant for rf frequency controllaw.
# Added list of C:H1 and C:V1 correctors.
#
# Revision 1.100  2003/10/21 16:27:17  shang
# changed the message from "RT orbit feedback control" to "SRFB Orbit Feedback Control"
# to be consistent with the application name.
#
# Revision 1.99  2003/10/21 16:08:08  shang
# added regenerating compenstation files and controllaw files procedures for each
# DC configuration when RTFB default configuration changes. Tested with Louis Emery.
#
# Revision 1.98  2003/09/30 16:49:45  shang
# changed the choices for install default RTfeedback configuration
#
# Revision 1.97  2003/07/08 10:08:16  emery
# Fixed make default command in APSSRInstallOrbCorrFiles.
#
# Revision 1.96  2003/07/08 01:30:14  shang
# added four choices to the make default link
#
# Revision 1.95  2003/05/23 17:35:01  emery
# Changed the logic for the separation of bpms from other nametypes
# in APSWriteSRConfig.
#
# Revision 1.94  2003/05/21 18:25:36  shang
# changed the printout message
#
# Revision 1.93  2003/05/21 18:22:07  shang
# removed the warning messages from sddsxref
#
# Revision 1.92  2003/05/21 18:12:41  shang
# fixed a bug in writing config proc
#
# Revision 1.91  2003/05/21 18:05:23  shang
# added ElectronicsType column to config file
#
# Revision 1.90  2003/04/04 19:51:34  shang
# added C:P0 PVs
#
# Revision 1.89  2002/11/12 16:16:24  shang
# disable the button for B2C9V (booster vertical corrector)
#
# Revision 1.88  2002/10/09 02:14:37  shang
# removed the APSSRSectorUnsetMissing statement in APSReadSRConfig{} where the
# missingList is passed from previous config, which unselect those pvs which are
# in current config file.
#
# Revision 1.87  2002/10/07 16:55:14  soliday
# Restored my changes and fixed a few bugs.
#
# Revision 1.86  2002/10/05 19:51:18  shang
# fixed the bug by removing the disabling button state statements in APSRescanBadOrbitDevices
#
# Revision 1.85  2002/10/05 14:18:19  soliday
# Improved the look and feel
#
# Revision 1.84  2002/10/05 13:51:30  soliday
# Updated APSReadOrbitCorrectionConfig
#
# Revision 1.83  2002/10/05 13:27:44  soliday
# Changed the way nonexistance BPMs are displayed.
#
# Revision 1.82  2002/10/04 00:21:05  shang
# added displaying lattice for read and write configuration
#
# Revision 1.81  2002/10/03 22:40:15  shang
# modified to make it work for booster configuration too
#
# Revision 1.80  2002/07/25 23:55:18  emery
# Added output boxes for the lattice selected in the read write and generate
# widget frames.
#
# Revision 1.79  2002/02/20 02:24:39  emery
# Fixed the previous version of searching of lattice links.
#
# Revision 1.78  2002/02/20 01:44:17  emery
# Modified search of lattice links for new directory
# structure of default lattices.
#
# Revision 1.77  2002/01/24 17:32:48  sereno
# Added sectorCount variable (default 40) to various procedures related to
# APSSRSectorButtons so the procedure can be used to create usefull booster
# widgets where the sector count (quadrant count) is 4.  N. Sereno
#
# Revision 1.76  2002/01/19 05:34:08  emery
# Made ${rootnameComp}RTDir a global.
#
# Revision 1.75  2002/01/19 05:28:22  emery
# Set a default for the RTdir for compensation.
#
# Revision 1.74  2001/12/05 05:17:15  emery
# Added argument okForDCOrbitCorrection to APSGetBMXRayBPMList.
#
# Revision 1.73  2001/10/27 03:28:25  borland
# Allow the user to specify "plain" or "DP" BPM PVs, and "plain", "DP", or
# "dynamic" corrector PVs.  The selection is saved in the config file and
# also loaded from the config file.  If the config file doesn't have this
# data, plain PVs are assumed.
#
# Revision 1.72  2001/08/25 02:55:25  emery
# Assigned global variables for the rt feedback configurations needed
# for FF compensation when only DC orbit correction tab
# widgets are created.  Previously when all tabs existed, all globals
# were defined.
#
# Revision 1.71  2001/08/24 21:38:39  emery
# Added FastDCOrbitCorrection to list of applications in
# APSSRGetBadOrbitDevices and APSRescanBadOrbitDevices.
#
# Revision 1.70  2001/08/24 21:35:03  emery
# Added FastDCOrbitCorrection to list of applications in APSSRConfigPlaneOrbitCorrection.
#
# Revision 1.69  2001/06/25 21:51:28  emery
# Added helpful message when an error occurs in a processing command
# containing sddspseudoinverse.
#
# Revision 1.68  2001/05/15 18:30:28  emery
# Replaced instance of file delete irmDC with file delete irmFF.
# File irmDC is no longer used.
#
# Revision 1.67  2001/05/09 13:55:46  emery
# Foxed the RF frequency limits for the RF frequency controllaw tests.
#
# Revision 1.66  2001/05/09 13:03:40  emery
# Changed in RF mode PV suffix ErrorCC to RfErrorM
#
# Revision 1.65  2001/05/09 12:50:06  emery
# Replace AdjustedCC to RfErrorCC for the RF frequency controllaw
#
# Revision 1.64  2001/05/09 12:41:11  emery
# Added setfacl -m mask:rwx command for new path created.
#
# Revision 1.63  2001/04/21 04:13:40  emery
# Implemented the secotr-wide selection buttons in the vertical
# orientation of sector buttons.
#
# Revision 1.62  2001/04/21 03:12:57  emery
# Added option to APSSRSectorButtons to allow sector-wide
# toggling selection by adding a row of sector buttons
# below the itemlist. Working for the horizontal mode.
#
# Revision 1.61  2001/03/20 21:13:16  emery
# Replaced the "Generate compensation files" area
# according to new formalism where the new FF matrix
# is simply a direct response matric with RT bpms
# and DC correctors.
#
# Revision 1.60  2001/03/20 03:06:51  emery
# Calls to APSSRSectorButtons are now with a command string
# with one of missingList and missingListVar as arguments
# but not both to avoid situations where missingListVar is
# evaluated as an empty string inside APSSRSectorButtons.
# Also the check button command arguments in APSSRSectorButtons
# have the addition options "-sector $n -item $item -nameFlag $nameFlag"
# in both H and V orientations.
#
# Revision 1.59  2001/02/06 19:44:27  soliday
# Fixed some tcl warning messages found with procheck
#
# Revision 1.58  2001/01/14 23:13:45  emery
# Added \" \" around quantity $missingListVar to ensure
# passing of at least a null string in a long -command argrument.
#
# Revision 1.57  2000/12/11 22:01:14  emery
# Fixed bug in APSSRGenerateOrbCorrFiles where the test on
# variable compensationConfigFile was improperly formed.
#
# Revision 1.56  2000/12/04 22:51:16  emery
# Added compensation matrix for horizontal and vertical
# orbit correction.
#
# Revision 1.55  2000/11/02 18:11:39  soliday
# Fixed a bug with BPMMissingList
#
# Revision 1.54  2000/11/02 08:32:04  emery
# Set specific missing lists and corList for each rootname
# types in proc APSReadOrbitCorrectionConfig.
# In proc APSReadSRConfig in the switch AND case
# check to see whether variable ${rootname}$item
# exists before executing the [set ${rootname}$item]
# command. This prevents a tcl error when running the
# read(AND) button.
#
# Revision 1.53  2000/11/02 06:46:53  emery
# Replaced an inappropriate IDBPMEqnList with BMBPMEqnList inside
# a BM code structure.
# Fixed syntax at set itemLabelList [list A4 B5 B4]
#
# Revision 1.52  2000/11/01 15:45:47  emery
# Added A:P4 and B:P4 to B:P5 in dispersion correction.
#
# Revision 1.51  2000/10/30 14:36:35  borland
# Attempting to write a file with a mismatch between the configuration name
# and the plane will now generate a warning message.
#
# Revision 1.50  2000/10/29 15:27:19  borland
# Modified APSGetMissingBPMList for backward compatibility.
#
# Revision 1.49  2000/10/28 11:40:42  emery
# Rewrote procedures APSGetMissingBPMList APSGet*XRay*List
# to make use of /home/helios/oagData/sr/BPMStatus/config.sdds.
# Added switches to run APSGetMissingBPMList with planes
# corresponding to application rootnames.
#
# Revision 1.48  2000/10/27 01:19:57  emery
# Defined a root directory for RTfeedback application.
#
# Revision 1.47  2000/10/19 16:27:30  borland
# Now looks for Nonexistent[HV] data in good BPM files before Nonexistent data.
#
# Revision 1.46  2000/10/17 19:11:30  borland
# Copied APSSRFreqGenerateOrbCorrFiles from BP5 controllaw configuration
# tool.  Modified necessary routines to support BP5 controllaw configuration
# in an integrated fashion.
#
# Revision 1.45  2000/10/17 16:08:54  borland
# Added new procedures to allow setting up separate H/V configuration control using
# tabnotebook environment.  Integrated with the new method for keeping track of
# good/bad components.
#
# Revision 1.44  2000/08/29 14:55:31  emery
# Fix bug in APSSRGenerateOrbCorrFiles where
# the variable equationCmd may get the strings sddsprocess -pipe
# appended twice if both BM and ID equations are requested.
#
# Revision 1.43  2000/07/06 19:04:27  emery
# removed chmod and file attribute -permissions commands.
#
# Revision 1.42  2000/06/14 19:23:25  emery
# Changed the permission argument in the APSMakeLink commands
# from 664 to 775 involving directories.
#
# Revision 1.41  2000/05/19 19:55:00  emery
# Changed chmod argument to permissions in APSMakeLink commands.
#
# Revision 1.40  2000/01/18 16:04:58  borland
# Now reads the new StatusOtherRF.sdds file when determining which BPMs
# are missing.
#
# Revision 1.39  2000/01/04 18:51:19  borland
# Now has separate good-bpm for horizontal and vertical.
#
# Revision 1.37  1999/11/02 15:55:58  borland
# Added some sdds close statements that are needed.
#
# Revision 1.36  1999/09/15 13:46:32  emery
# Added an eval command to sddsprocess in APSGetIDXRayBPMList
# and APSGetBMXRayBPMList
#
# Revision 1.35  1999/09/15 13:43:17  emery
# Added sddsOutput argument to APSGetIDXRayBPMList
# and APSGetBMXRayBPMList
#
# Revision 1.34  1999/09/13 19:36:58  emery
# Added despike variable to config file. Added despike
# value selection to weight dialog box.
#
# Revision 1.33  1999/09/07 22:00:22  emery
# Added APSGetBMXRayBPMList APSGetBMXRayEqnList to prepare
# matrix elements for BM Xray bpm sources.
#
# Revision 1.32  1999/08/16 22:00:50  borland
# Added -configName option to APSWriteOrbitCorrectionConfig so that it can
# check for blank config name.  Added includeBMs to parse args list of same.
#
# Revision 1.31  1999/08/11 16:38:57  emery
# Added BM Xray bpms.
#
# Revision 1.30  1999/08/03 16:25:03  emery
# Write-configuration directory cleared when the "write..."
# frame is swapped in.
#
# Revision 1.29  1999/05/19 20:10:42  soliday
# Fixed bug in APSPickFileFromDir that might display the wrong type.
#
# Revision 1.28  1999/04/19 18:25:01  borland
# Added options for -weight to sddspseudoinverse.
#
# Revision 1.27  1999/04/19 18:11:25  borland
# New version supporting ID P1 and P2 bpms plus weights.
#
# Revision 1.26  1999/03/05 20:53:29  soliday
# Increased the speed of APSPickFileFromDir by over 10 times.
#
# Revision 1.25  1999/02/25 17:09:09  soliday
# Replaced exec date commands with clock commands
#
# Revision 1.24  1998/09/09 17:16:46  borland
# P0's are now considered "missing" if the have installation phase of 0 or 1.
# Also, now disable check buttons for missing elements.
#
# Revision 1.23  1998/09/03 20:01:43  borland
# Added checks for probable invalid configurations: no monitors, no correctors,
# H/V correctors together, H correctors in V config, etc.
#
# Revision 1.22  1998/09/03 19:33:32  borland
# Now removes missing BPMs prior to counting.
#
# Revision 1.21  1998/09/03 19:29:39  borland
# Now uses APSSRGetInstalledBPMList to get list of missing BPMs.
#
# Revision 1.20  1998/08/28 16:37:23  borland
# Now supports P0 BPMs, with missing list for BPMs read from oagData files.
# Also added some comments.
#
# Revision 1.19  1998/07/27 19:29:50  borland
# Now uses -log 1 option on all APSMakeLink calls.  Added missing -confirm 1
# option to one APSMakeLink call.
#
# Revision 1.18  1998/06/16 21:08:12  borland
# Increased frame with for orbit correction file widgets.
#
# Revision 1.17  1998/05/29 04:06:06  borland
# APSSRConfigOrbitCorrection now accepts -buttonOrientation option, allowing
# the checkbuttons to be arrayed horizontally or vertically.  Related routines
# (for corrector and monitor button arrays) now accept the -orientation option.
#
# Revision 1.16  1998/04/09 22:13:56  borland
# Added more "Are you sure?" type queries when user tries to change default
# files.
#
# Revision 1.15  1998/03/27 16:59:37  emery
# Shortened the singular value entry box so that there will be room for the
# make default button.
#
# Revision 1.14  1998/03/23 19:16:03  emery
# Added option to remove DC vectors (sddspseudoinverse
# option) in the inverse computation frame.
#
# Revision 1.13  1998/03/11 23:05:36  borland
# Added h/v sensivity to listing of configurations that come up when the
# P button is pressed.  The H/V switch now appears in several widget frames.
#
# Revision 1.12  1998/03/09 22:36:25  borland
# Added listing of config descriptions when file choosing is done
#
# Revision 1.11  1998/03/04 18:21:24  borland
# Added "Are you sure?" query for changing default file.
#
# Revision 1.10  1998/03/03 22:51:11  borland
# Now reports condition number after computing inverse.
#
# Revision 1.9  1998/03/03 22:42:09  borland
# Added chmod argument to call to generate inverse matrix.
#
# Revision 1.8  1998/03/03 00:46:12  borland
# Moved default config installation to matrix computation frame.
#
# Revision 1.7  1998/03/02 01:48:18  borland
# Supports horizontal and vertical formats for check button grid
# with labels for items as well as sectors.
#
# Revision 1.6  1998/01/11 19:06:27  borland
# Added buttons to generate filenames for good component files.
# Removed "make default" button from "generate controllaw files.." panel.
#
# Revision 1.5  1998/01/11 18:16:25  borland
# Added APSCountSRConfig and buttons for orbit correction config to
# invoke this new procedure.  Gives the number of items selected.
#
# Revision 1.4  1998/01/10 20:50:39  borland
# Added config name generation (G) button for config name entry on
# matrix generation panel.  Changed title of this panel to Compute matrix.
#
# Revision 1.3  1998/01/10 20:43:53  borland
# Fixed +/- buttons.  Fixed G button (to generate new config directory).
#
# Revision 1.2  1998/01/09 16:57:31  borland
# Change the way names are done for H and V directories.  The h. or v.
# comes at the beginning.  Also bug fixes.
#
# Revision 1.1  1997/12/29 23:33:49  borland
# New routines for configuration of SR equipment.  Special routine for
# orbit correction, but basic routines will configure anything with
# 40 sectors times N named items.
#
#

# Procedures in this file
# APSSRConfigOrbitCorrection---essentially creates an entire application for
#   handling SR orbit correction configuration.
# APSSRConfigPlaneOrbitCorrection---creates a frame for SR orbit correction
#   config for the h or v plane.
# APSSRInstallOrbCorrFiles---changes the default orbit correction files, which
#   are the ones used by the brief and expert OC screens.
# APSFileSelectWidget---A customized file selection widget that supports path
#   components in a list.  Used for selection of configurations.
# APSPickFileFromDir---Another customized file selection widget.  Lists filenames
#   along with the Description data (SDDS files only).
# APSSRGenerateOrbCorrFiles---Generates and/or installs the inverse matrices for
#   orbit correction.
# APSIncrementConfigFilename---Increments the generation index on a configuration
#   name.
# APSSRWriteOrbitCorrectionConfig---Writes corrector and monitor selection data 
#   to disk.
# APSSRWritePlaneOrbitCorrectionConfig---Writes corrector and monitor selection data
#   for h or v plane to disk.  Used with APSSRConfigPlaneOrbitCorrection.
# APSCountSRConfig---Counts the number of items of a specified type that are
#   enabled by the configuration checkbuttons.
# APSWriteSRConfig---Writes to disk a general configuration grid based on the
#   configuration checkbuttons.  Used by APSSRWriteOrbitCorrectionConfig, for
#   example.
# APSReadOrbitCorrectionConfig---Reads an orbit correction configuration from
#   disk and sets checkbuttons accordingly.
# APSReadSRConfig---Reads a generation configuration grid from disk and
#   sets checkbuttons accordingly.  Used by APSReadOrbitCorrectionConfig,
#   for example.
# APSSRMonitorCheckButtons---Makes check-button grid for SR BPMs.
# APSSRCorrectorCheckButtons---Makes checkbutton grid for one plane of
#   SR correctors.
# APSSRSectorUnsetMissing---Unsets the checkbuttons for missing components.
# APSSRSectorButtons---Makes a general checkbutton grid for 40 sectors and
#   a specified number of items per sector.  Used by APSSRCorrectorCheckButtons
#   and APSSRMonitorCheckButtons.
# APSSRSectorGlobalButtons---Makes +All, -All, and Count buttons for a
#   checkbutton grid made by APSSRSectorButtons.
# APSSetSRSectorButtons---Sets or unsets all checkbuttons in an grid.
# APSSRSectorPositionButtons---Makes buttons for each "position" in a
#   checkbutton grid.  E.g., all A:P1's.
# APSSRSectorTogglePosition---Used by APSSRSectorPositionButtons to
#   toggle a "position" in a checkbutton grid.
# APSGetMissingBPMList---Figures out which BPMs are missing (i.e.,
#   which P0's) and returns a list of them.
# APSSRGetBadOrbitDevices---Gets lists of bad bpms or correctors 
#   from the new configuration files. 
# APSSRFreqGenerateOrbCorrFiles---Copied from BP5 correction configuration
#   application for use here in integrated application

# This procedure is obsolete as it is 
# superceded by APSSRConfigPlaneOrbitCorrection
proc APSSRConfigOrbitCorrection {widget args} {
    set parent ""
    set rootname sconfig
    set fileFrame 1
    set buttonOrientation vertical
    set includeP0s 0
    set includeIDs 0
    set includeBMs 0
    APSStrictParseArguments {parent rootname fileFrame buttonOrientation includeP0s includeIDs includeBMs}

    set BPMSuffixList [list A:P1 A:P2 A:P3 A:P4 B:P5 B:P4 B:P3 B:P2 B:P1]
    if $includeP0s {
        set BPMSuffixList [concat A:P0 $BPMSuffixList B:P0 C:P0]
    }
    if $includeIDs {
        set BPMSuffixList [concat $BPMSuffixList ID:P1 ID:P2]
    }
    if $includeBMs {
        set BPMSuffixList [concat $BPMSuffixList BM:P1 BM:P2]
    }
    switch -regexp $rootname {
        rf -
        h {
            set BPMMissingList [APSGetMissingBPMList -plane h]
        }
        v {
            set BPMMissingList [APSGetMissingBPMList -plane v]
        }
        default {
            set BPMMissingList [APSGetMissingBPMList -plane h]
        }
    }
    # Make a frame grid with three vertical areas.  "top" will contain the
    # checkbutton grids, and bot will contain the controls (read, write, etc.)
    APSFrameGrid $widget -parent $parent -yList {status top bot}

    # Make a dedicated scrolled status area for this configuration.
    global ${rootname}ConfigStatus
    set ${rootname}ConfigStatus ""
    APSScrolledStatus .scrolled -parent $parent$widget.status \
      -textVariable ${rootname}ConfigStatus \
      -width 110 -height 3 -lineLimit 1000 -label ""
    APSFrame .but -parent $parent$widget.top

    # Make the checkbutton grids
    set w $parent$widget.top.but.frame
    if [string compare $buttonOrientation vertical]==0 {
        set pOption "-side left"
    } else {
        set pOption "-side top"
    }
    APSSRMonitorCheckButtons .smbut -parent $w -rootname $rootname \
      -orientation $buttonOrientation \
      -packOption $pOption -includeP0s $includeP0s \
      -includeIDs $includeIDs -includeBMs $includeBMs
    APSSRCorrectorCheckButtons .shbut -parent $w -rootname ${rootname} \
      -plane H -orientation $buttonOrientation \
      -packOption $pOption 
    APSSRCorrectorCheckButtons .svbut -parent $w -rootname ${rootname} \
      -plane V -orientation $buttonOrientation \
      -packOption $pOption 

    if $fileFrame {
        # Make frames for read, write, etc. controls.  Will go into a 
        # widget swap frame.
        set frameHeight 150
        set frameWidth 900
        set w $parent$widget.bot.fileops.frame
        APSWidgetSwapFrame .fileops -parent $parent$widget.bot -label "" \
          -contextHelp "File operations frame for orbit correction configuration" \
          -widgetList "$w.lattice $w.read $w.good $w.write $w.refmat $w.matrix"  \
          -labelList [list Lattice... Read... Good... Write... {Reference matrices...} {Generate controllaw files...}] \
          -commandList [list {} {} {} "APSSetVarAndUpdate ${rootname}WriteDir \"\"" {} {}] \
          -height $frameHeight -width $frameWidth \
          -buttonSize small -buttonPosition 0
        pack propagate $parent$widget.bot.fileops.frame 0
        pack $parent$widget.bot.fileops -side top

        # Make lattice selection frame.
        global ${rootname}Lattice ${rootname}MainDir ${rootname}LatSubDir
        set ${rootname}Lattice default
        set ${rootname}MainDir /home/helios/oagData/sr/orbitControllaw
        set ${rootname}LatSubDir lattices
        APSFrame .lattice -parent $w -label "Lattice" -noPack 1 \
          -width $frameWidth -height $frameHeight -contextHelp \
          "Use this frame to specify the lattice directory name and main directory area.  You may also change the default lattice from here."
        set w0 $w.lattice.frame
        APSLabeledEntry .maindir -parent $w0 -label "Main directory: " \
          -textVariable ${rootname}MainDir -width 80 -contextHelp \
          "Enter the name of the main directory for the orbit correction system."
        APSFileSelectWidget .lattice -parent $w0 -label "Lattice: " \
          -pathVariableList [list ${rootname}MainDir ${rootname}LatSubDir] -mode directory -width 76 \
          -variable ${rootname}Lattice -incrementButtons 0 -contextHelp \
          "Enter the name of the lattice with which to work."
       #comment out this default button because it is dangerous to change the default lattice and it is not needed in this application, since we have another software for SR managers to change the default lattice. We had an occasion that it was pressed by a non-familiar person which caused the orbit correction failure and almost dumped the beam.
       # APSButton .default -parent $w0.lattice -text D -size small \
       #   -contextHelp "Makes the named file into the default lattice." \
        #  -command "APSMakeLink -confirm 1 -confirmMessage {Change default lattice? Are you sure?} -local 1 -log 1 -permissions 00775 -filename \[subst \$${rootname}MainDir/\$${rootname}LatSubDir/\$${rootname}Lattice\] -linkname \[subst \$${rootname}MainDir/\$${rootname}LatSubDir/default\]; set ${rootname}Lattice default"

        # Make configuration-read frame.
        global ${rootname}ReadFile ${rootname}ReadDescription ${rootname}Plane
        global ${rootname}FilterEnd1
        set ${rootname}Plane h
        set ${rootname}ReadFile h.default
        set ${rootname}ReadDescription ""
        set ${rootname}FilterEnd1 .*
        APSFrame .read -parent $w -label "Read configuration" -noPack 1 \
          -width $frameWidth -height $frameHeight -contextHelp \
          "Use this frame to read combined monitor and corrector configurations."
        set w0 $w.read.frame
        APSLabeledOutput .lattice -parent $w0 -label "Lattice: " -width 60 \
          -textVariable ${rootname}Lattice -contextHelp \
          "Shows the lattice of the configuration for which this read widget applies."
        APSFileSelectWidget .file -parent $w0 -variable ${rootname}ReadFile -label "Config: " \
          -pathVariableList [list ${rootname}MainDir ${rootname}LatSubDir ${rootname}Lattice] \
          -mode directory -filterVariableList \
          [list ${rootname}Plane ${rootname}FilterEnd1] -width 76 \
          -incrementButtons 1 -contextHelp \
          "Enter the name of the configuration file to read."
        APSLabeledOutput .descrip -parent $w0 -label "Description: " -width 76 \
          -textVariable ${rootname}ReadDescription -contextHelp \
          "Shows the description of the last-read configuration file."
        APSRadioButtonFrame .rb1 -parent $w0 -packOption "-side left" -label "Plane: " \
          -variable ${rootname}Plane -buttonList {H V} -valueList {h v} \
          -orientation horizontal -contextHelp \
          "Choose plane with which you are dealing.  Determines what configurations are viewable and what configuration names are generated."
        APSButton .io0 -parent $w0 -text Read(replace) -size small -command \
          "APSReadOrbitCorrectionConfig -rootname $rootname -filename \$${rootname}MainDir/\$${rootname}LatSubDir/\$${rootname}Lattice/\$${rootname}ReadFile/config -logic replace -includeP0s $includeP0s -includeIDs $includeIDs -includeBMs $includeBMs" \
          -contextHelp "Press to read data to replace the existing configuration, using the named configuration file."
        APSButton .io1 -parent $w0 -text Read(or) -size small -command \
          "APSReadOrbitCorrectionConfig -rootname $rootname -filename \$${rootname}MainDir/\$${rootname}LatSubDir/\$${rootname}Lattice/\$${rootname}ReadFile/config -logic or -includeP0s $includeP0s -includeIDs $includeIDs -includeBMs $includeBMs" \
          -contextHelp "Press to read data to or with the existing configuration, using the named configuration file."
        APSButton .io2 -parent $w0 -text Read(and) -size small -command \
          "APSReadOrbitCorrectionConfig -rootname $rootname -filename \$${rootname}MainDir/\$${rootname}LatSubDir/\$${rootname}Lattice/\$${rootname}ReadFile/config -logic and -includeP0s $includeP0s -includeIDs $includeIDs -includeBMs $includeBMs" \
          -contextHelp "Press to read data to and with the existing configuration, using the named configuration file."
        APSButton .io3 -parent $w0 -text Read(not) -size small -command \
          "APSReadOrbitCorrectionConfig -rootname $rootname -filename \$${rootname}MainDir/\$${rootname}LatSubDir/\$${rootname}Lattice/\$${rootname}ReadFile/config -logic not -includeP0s $includeP0s -includeIDs $includeIDs -includeBMs $includeBMs" \
          -contextHelp "Press to read data specifying elements to turn off, using the named configuration file."

        # Make the write-configuration frame
        global ${rootname}WriteDir 
        APSFrame .write -parent $w -label "Write configuration" -noPack 1 \
          -width $frameWidth -height $frameHeight -contextHelp \
          "Use this frame to write combined monitor and corrector configurations."
        set w0 $w.write.frame
        APSLabeledOutput .lattice -parent $w0 -label "Lattice: " -width 60 \
          -textVariable ${rootname}Lattice -contextHelp \
          "Shows the lattice of the configuration for which this write widget applies."
        #set ${rootname}WriteDir h.[clock format [clock seconds] -format %Y-%m%d].00
	set ${rootname}WriteDir ""
        APSFileSelectWidget .file -parent $w0 -variable ${rootname}WriteDir \
          -pathVariableList [list ${rootname}MainDir ${rootname}LatSubDir ${rootname}Lattice] \
          -label "Config: " -noSelect 0 -mode directory -incrementButtons 1 -width 76 -contextHelp \
          "Enter the name of the configuration to write." \
          -filterVariableList [list ${rootname}Plane ${rootname}FilterEnd1]
        APSButton .genname -parent $w0.file -text G -size small -command \
          "set ${rootname}WriteDir \[APSNextGenerationedName -directory \$${rootname}MainDir/\$${rootname}LatSubDir/\$${rootname}Lattice -name \$${rootname}Plane.\[clock format \[clock seconds\] -format %Y-%m%d\].00 -newFile 1 -separator .\]"
        APSLabeledEntry .descrip -parent $w0 -label "Description: " -width 76 \
          -textVariable ${rootname}WriteDescription -contextHelp \
          "Use to enter a description for the configuration to be written."
        APSRadioButtonFrame .rb1 -parent $w0 -packOption "-side left" -label "Plane: " \
          -variable ${rootname}Plane -buttonList {H V} -valueList {h v} \
          -orientation horizontal -contextHelp \
          "Choose plane with which you are dealing.  Determines what configurations are viewable and what configuration names are generated."
        APSButton .io -parent $w0 -text Write -size small -command \
          "APSSRWriteOrbitCorrectionConfig -interactive 1 -rootname $rootname -filename \$${rootname}MainDir/\$${rootname}LatSubDir/\$${rootname}Lattice/\$${rootname}WriteDir/config -description \$${rootname}WriteDescription -includeP0s $includeP0s -includeIDs $includeIDs -includeBMs $includeBMs -configName \$${rootname}WriteDir" \
          -contextHelp "Press to write data, using the named configuration file."

        # Make frame for read/write/apply of "good" component files
        global ${rootname}GoodHMonFile ${rootname}GoodVMonFile ${rootname}GoodHCorrFile ${rootname}GoodVCorrFile ${rootname}GoodDir
        APSFrame .good -parent $w -label "Good component files" -noPack 1 \
          -width $frameWidth -height $frameHeight -contextHelp \
          "Use this frame to mask the configuration using files that give lists of good monitors, horizontal correctors, and vertical correctors.  These files can be created using the read and write operations of this screen."
        set w0 $w.good.frame 
        set ${rootname}GoodDir goodComponents
        set ${rootname}GoodHMonFile hmon.default
        set ${rootname}GoodVMonFile vmon.default
        set ${rootname}GoodHCorrFile hc.default
        set ${rootname}GoodVCorrFile vc.default
        foreach Plane {H V} plane {h v} {
            APSFileSelectWidget .${plane}mon -parent $w0 -variable ${rootname}Good${Plane}MonFile \
              -pathVariableList [list ${rootname}MainDir ${rootname}GoodDir] \
              -label "${Plane}. Mon.:" -mode file -width 72 -incrementButtons 1 \
              -filter "${plane}mon.*" 
            APSButton .apply -parent $w0.${plane}mon -text A -size small \
              -contextHelp "Applies the file to the present configuration.  Beware of applying a file in the wrong slot---e.g., a monitor file in a corrector slot or vice-versa." \
              -command "APSReadSRConfig -rootname $rootname -filename \[subst \$${rootname}MainDir/\$${rootname}GoodDir/\$${rootname}Good${Plane}MonFile\] -logic and -nameTypeList Monitor -knownSuffixes \{$BPMSuffixList\} -missingList \{$BPMMissingList\}"
            APSButton .write -parent $w0.${plane}mon -text W -size small \
              -contextHelp "Writes the present $Plane monitor configuration to the named file." \
              -command "APSWriteSRConfig -interactive 1 -rootname $rootname -filename \[subst \$${rootname}MainDir/\$${rootname}GoodDir/\$${rootname}Good${Plane}MonFile\] -nameTypeList Monitor -suffixLists \{\{$BPMSuffixList\}\}"
            APSButton .default -parent $w0.${plane}mon -text D -size small \
              -contextHelp "Makes the named file into the default good ${Plane} monitor list." \
              -command "APSMakeLink -confirm 1 -confirmMessage {Change default good ${Plane} monitor list? Are you sure?} -local 1 -log 1 -permissions 00664 -filename \[subst \$${rootname}MainDir/\$${rootname}GoodDir/\$${rootname}Good${Plane}MonFile\] -linkname \[subst \$${rootname}MainDir/\$${rootname}GoodDir/${plane}mon.default\]; set ${rootname}Good${Plane}MonFile ${plane}mon.default"
            APSButton .genname -parent $w0.${plane}mon -text G -size small -command \
              "set ${rootname}Good${Plane}MonFile \[APSNextGenerationedName -directory \$${rootname}MainDir/\$${rootname}GoodDir -name ${plane}mon.\[clock format \[clock seconds\] -format %Y-%m%d\].00 -newFile 1 -separator .\]" \
              -contextHelp "Generates a unique, unused name for the good ${Plane} monitor list."
        }

        APSFileSelectWidget .hcorr -parent $w0 -variable ${rootname}GoodHCorrFile \
          -pathVariableList [list ${rootname}MainDir ${rootname}GoodDir] \
          -label "H. Corr:" -mode file -width 72 -incrementButtons 1 \
          -filter "hc.*"
        APSButton .apply -parent $w0.hcorr -text A -size small \
          -contextHelp "Applies the file to the present configuration.  Beware of applying a file in the wrong slot---e.g., a monitor file in a corrector slot or vice-versa." \
          -command "APSReadSRConfig -rootname $rootname -filename \[subst \$${rootname}MainDir/\$${rootname}GoodDir/\$${rootname}GoodHCorrFile\] -logic and -nameTypeList Corrector -knownSuffixes {A:H1 A:H2 A:H3 A:H4 B:H4 B:H3 B:H2 B:H1 C:H1} -missingList {S1A:H3 S39B:H1 S40A:H3}"
        APSButton .write -parent $w0.hcorr -text W -size small \
          -contextHelp "Writes the present horizontal corrector configuration to the named file." \
          -command "APSWriteSRConfig -interactive 1 -rootname $rootname -filename \[subst \$${rootname}MainDir/\$${rootname}GoodDir/\$${rootname}GoodHCorrFile\] -nameTypeList Corrector -suffixLists {{A:H1 A:H2 A:H3 A:H4 B:H4 B:H3 B:H2 B:H1 C:H1}}"
        APSButton .default -parent $w0.hcorr -text D -size small \
          -contextHelp "Makes the named file into the default good horizontal corrector list." \
          -command "APSMakeLink -confirm 1 -confirmMessage {Change default good horizontal corrector list? Are you sure?} -local 1 -log 1 -permissions 00664 -filename \[subst \$${rootname}MainDir/\$${rootname}GoodDir/\$${rootname}GoodHCorrFile\] -linkname \[subst \$${rootname}MainDir/\$${rootname}GoodDir/hc.default\]; set ${rootname}GoodHCorrFile hc.default"
        APSButton .genname -parent $w0.hcorr -text G -size small -command \
          "set ${rootname}GoodHCorrFile \[APSNextGenerationedName -directory \$${rootname}MainDir/\$${rootname}GoodDir -name hc.\[clock format \[clock seconds\] -format %Y-%m%d\].00 -newFile 1 -separator .\]" \
          -contextHelp "Generates a unique, unused name for the good horizontal corrector list."

        APSFileSelectWidget .vcorr -parent $w0 -variable ${rootname}GoodVCorrFile \
          -pathVariableList [list ${rootname}MainDir ${rootname}GoodDir] \
          -label "V. Corr:" -mode file -width 72 -incrementButtons 1 \
          -filter "vc.*"
        APSButton .apply -parent $w0.vcorr -text A -size small \
          -contextHelp "Applies the file to the present configuration.  Beware of applying a file in the wrong slot---e.g., a monitor file in a corrector slot or vice-versa." \
          -command "APSReadSRConfig -rootname $rootname -filename \[subst \$${rootname}MainDir/\$${rootname}GoodDir/\$${rootname}GoodVCorrFile\] -logic and -nameTypeList Corrector -knownSuffixes {A:V1 A:V2 A:V3 A:V4 B:V4 B:V3 B:V2 B:V1 C:V1} -missingList {S1A:V3 S39B:V1 S40A:V3}"
        APSButton .write -parent $w0.vcorr -text W -size small \
          -contextHelp "Writes the present vertical corrector configuration to the named file." \
          -command "APSWriteSRConfig -interactive 1 -rootname $rootname -filename \[subst \$${rootname}MainDir/\$${rootname}GoodDir/\$${rootname}GoodVCorrFile\] -nameTypeList Corrector -suffixLists {{A:V1 A:V2 A:V3 A:V4 B:V4 B:V3 B:V2 B:V1 C:V1}}"
        APSButton .default -parent $w0.vcorr -text D -size small \
          -contextHelp "Makes the named file into the default good vertical corrector list." \
          -command "APSMakeLink -confirm 1 -confirmMessage {Change default good vertical corrector list? Are you sure?} -local 1 -log 1 -permissions 00664 -filename \[subst \$${rootname}MainDir/\$${rootname}GoodDir/\$${rootname}GoodVCorrFile\] -linkname \[subst \$${rootname}MainDir/\$${rootname}GoodDir/vc.default\]; set ${rootname}GoodVCorrFile vc.default"
        APSButton .genname -parent $w0.vcorr -text G -size small -command \
          "set ${rootname}GoodVCorrFile \[APSNextGenerationedName -directory \$${rootname}MainDir/\$${rootname}GoodDir -name vc.\[clock format \[clock seconds\] -format %Y-%m%d\].00 -newFile 1 -separator .\]" \
          -contextHelp "Generates a unique, unused name for the good vertical corrector list."

        # Make the reference matrix selection frame
        global ${rootname}RefMatrix 
        set ${rootname}RefMatrix(h) h.default
        set ${rootname}RefMatrix(v) v.default
        APSFrame .refmat -parent $w -label "Reference matrices" -noPack 1 \
          -width $frameWidth -height $frameHeight -contextHelp \
          "Use this frame to select the names of the reference matrix files.  These are used together with configuration files to generate the inverse matrices for orbit correction."
        set w0 $w.refmat.frame
        global ${rootname}refMatrices
        set ${rootname}refMatrices refMatrices
        foreach plane {h v} {
            APSFileSelectWidget .${plane}ref -parent $w0 -mode file \
              -label "[string toupper $plane] plane: " -width 76 \
              -variable ${rootname}RefMatrix($plane) \
              -pathVariableList [list ${rootname}MainDir ${rootname}LatSubDir ${rootname}Lattice ${rootname}refMatrices] \
              -contextHelp \
              "Enter the name of the reference response matrix file for the $plane plane."
            APSButton .default -parent $w0.${plane}ref -text D -size small \
              -contextHelp "Makes the named file into the default $plane-plane reference matrix." \
              -command "APSMakeLink -confirm 1 -confirmMessage {Change reference matrix? Are you sure?} -local 1 -log 1 -permissions 00664 -filename \[subst \$${rootname}MainDir/\$${rootname}LatSubDir/\$${rootname}Lattice/\$${rootname}refMatrices/\$${rootname}RefMatrix($plane)\] -linkname \[subst \$${rootname}MainDir/\$${rootname}LatSubDir/\$${rootname}Lattice/\$${rootname}refMatrices/$plane.default\]; set ${rootname}RefMatrix($plane) $plane.default"
        }

        # Make the frame for computing the matrix and installing it.
        global ${rootname}Plane ${rootname}SingValues ${rootname}SVDanalysis ${rootname}SetupOutputDir 
        global ${rootname}DeleteModes 
	global ${rootname}TikhonovFilter ${rootname}TikhonovSVN ${rootname}TikhonovBeta ${rootname}TikhonovType
        APSFrame .matrix -parent $w -label "Compute matrix" -noPack 1 \
          -width $frameWidth -height $frameHeight -contextHelp \
          "Use this frame to generate the matrix for orbit correction from an existing configuration."
        set w0 $w.matrix.frame
        set ${rootname}SingValues 320
        set ${rootname}SVDanalysis 0
        set ${rootname}DeleteModes ""
	set ${rootname}TikhonovFilter 0
	set ${rootname}TikhonovSVN 0
	set ${rootname}TikhonovBeta 0
	set ${rootname}TikhonovType SVN
        APSFileSelectWidget .file -parent $w0 -variable ${rootname}WriteDir \
          -pathVariableList [list ${rootname}MainDir ${rootname}LatSubDir ${rootname}Lattice] \
          -filter "h.* v.*" \
          -filterVariableList [list ${rootname}Plane ${rootname}FilterEnd1] \
          -label "Config: " -noSelect 0 -mode directory \
          -incrementButtons 1 -width 76 -contextHelp \
          "Enter the name of the configuration to use." 
        APSButton .genname -parent $w0.file -text G -size small -command \
          "set ${rootname}WriteDir \[APSNextGenerationedName -directory \$${rootname}MainDir/\$${rootname}LatSubDir/\$${rootname}Lattice -name \$${rootname}Plane.\[clock format \[clock seconds\] -format %Y-%m%d\].00 -newFile 1 -separator .\]"

        frame $w0.f1 
        pack $w0.f1 -fill x
        APSLabeledEntry .le1 -parent $w0.f1 -packOption "-side left" -textVariable ${rootname}SingValues \
          -label "Number of singular values: " -width 8 -contextHelp \
          "Enter the number of singular values to keep."
        APSRadioButtonFrame .rb1 -parent $w0.f1 -packOption "-side left" -label "Plane: " \
            -variable ${rootname}Plane -buttonList {H V} -valueList {h v} \
            -orientation horizontal -contextHelp \
            "Choose plane for which to compute the matrix."
        APSButton .svd -parent $w0.f1 -packOption "-side left" -text "SVD Analysis" -size  small \
            -command "APSSRGenerateOrbCorrFiles -rootname $rootname -generate 1 -configFile \$${rootname}MainDir/\$${rootname}LatSubDir/\$${rootname}Lattice/\$${rootname}WriteDir/config -plane \$${rootname}Plane -referenceMatrix \$${rootname}MainDir/\$${rootname}LatSubDir/\$${rootname}Lattice/refMatrices/\$${rootname}RefMatrix(\$${rootname}Plane) -outputRoot \$${rootname}MainDir/\$${rootname}LatSubDir/\$${rootname}Lattice/\$${rootname}WriteDir/ -singularValues \$${rootname}SingValues -SVDanalysis 1" \
            -contextHelp \
            "Removes DC vectors from singular values decomposition. May help in horizontal plane convergence. Not recommended for vertical plane." 
        APSButton .gen -parent $w0.f1 -text Compute -size small -packOption "-side left" -command \
	    "APSSRGenerateOrbCorrFiles -rootname $rootname -generate 1 -configFile \$${rootname}MainDir/\$${rootname}LatSubDir/\$${rootname}Lattice/\$${rootname}WriteDir/config -plane \$${rootname}Plane -referenceMatrix \$${rootname}MainDir/\$${rootname}LatSubDir/\$${rootname}Lattice/refMatrices/\$${rootname}RefMatrix(\$${rootname}Plane) -outputRoot \$${rootname}MainDir/\$${rootname}LatSubDir/\$${rootname}Lattice/\$${rootname}WriteDir/ -singularValues \$${rootname}SingValues -SVDanalysis 0 -tikhonovFilter \$${rootname}TikhonovFilter -tikhonovSVN \$${rootname}TikhonovSVN -tikhonovBeta \$${rootname}TikhonovBeta -tikhonovType \$${rootname}TikhonovType"
        APSButton .default -parent $w0.f1 -text "Make Default" -size small -packOption "-side left" \
          -contextHelp "Makes the named configuration into the default corrector configuration for chosen plane." \
          -command "APSSRInstallOrbCorrFiles -rootname $rootname"
        APSLabeledEntry .deletemodes -parent $w0 -textVariable ${rootname}DeleteModes \
          -label "Mode to delete: " \
          -contextHelp "a list of modes to be deleted from SVD analysis" -width 80
	APSRadioButtonFrame .tik -parent $w0 -label "Use tikhonov filter?" -buttonList {Yes No} \
	    -valueList {1 0} -variable ${rootname}TikhonovFilter -orientation horizontal
	APSRadioButtonEntryFrame .par -parent $w0.tik -orientation horizontal \
	    -label "Tikhonov filter type:" -packOption "-side right"  \
	    -variable ${rootname}TikhonovType -buttonList {SVN_Number Beta}  -orientation horizontal \
	    -valueList {SVN Beta} -commandList [list "set ${rootname}TikhonovBeta 0" "set ${rootname}TikhonovSVN 0"] \
	    -entryVariableList [list ${rootname}TikhonovSVN ${rootname}TikhonovBeta] \
	    -entryWidth 10
	if {0} {
	APSLabeledEntryFrame .alpha -parent $w0.tik  -orientation horizontal  \
	    -label "  Tikhonov parameters: SVN/Beta:" -variableList [list ${rootname}TikhonovSVN ${rootname}TikhonovBeta] -width 15 \
	    -contextHelp "provide the SVN number or beta (fractional alpha) of the tikhonov filter, the singular value of the provided SVN number will be used as alpha of the tikhonov filter."
	}
    }
    APSSwapInWidget $widget.bot.fileops -parent $parent -swapIn $w.read
}

proc APSSRInstallOrbCorrFiles {args} {
    set rootname ""
    set application ""
    set booster 0
    APSStrictParseArguments {rootname application booster}
    global ${rootname}MainDir ${rootname}LatSubDir ${rootname}Lattice
    global ${rootname}WriteDir ${rootname}Plane ${rootname}ConfigStatus
    
    # verify the agreement between ${rootname}Plane and the correctors
    # present in the lattice configuration file
    set Plane [string toupper [set ${rootname}Plane]]
    set configFile [subst \$${rootname}MainDir/\$${rootname}LatSubDir/\$${rootname}Lattice/\$${rootname}WriteDir]/config
    set irmFile [subst \$${rootname}MainDir/\$${rootname}LatSubDir/\$${rootname}Lattice/\$${rootname}WriteDir]/irm
    if ![file exist $configFile] {
        return -code error "$configFile does not exist, please create it first!"
    }
    if $booster {
        set plane [set ${rootname}Plane]
        set DefaultType ${plane}.default
        if ![APSYesNoPopUp "Are you sure to install [set ${rootname}WriteDir] to $DefaultType?"] {
            return
        }
        APSMakeLink -local 1 -log 1 -permissions 00775 \
          -filename [subst \$${rootname}MainDir/\$${rootname}LatSubDir/\$${rootname}Lattice/\$${rootname}WriteDir] \
          -linkname [subst \$${rootname}MainDir/\$${rootname}LatSubDir/\$${rootname}Lattice/$DefaultType]
        return
    }
    global DefaultType cancel
    set DefaultType [set ${rootname}Plane].default
    if {$application=="RTFeedback"} {
        set choices [list [set ${rootname}Plane].default [set ${rootname}Plane].defaultXR]
    } else {
        set choices [list [set ${rootname}Plane].default [set ${rootname}Plane].defaultXR \
                         [set ${rootname}Plane].defaultDP [set ${rootname}Plane].defaultXRDP \
                         [set ${rootname}Plane].defaultXRDP.fullSVs ]
    }
    APSDialogBox .default -name "choose default type" -width 50 \
      -okCommand {set cancel 0} -cancelCommand {set cancel 1}
    APSLabel .info -parent .default.userFrame -text "Please choose the default type to make link to"
    APSRadioButtonFrame .choice -parent .default.userFrame -buttonList $choices \
      -valueList $choices -variable DefaultType -orientation horizontal -label ""
    tkwait window .default
    if $cancel {
        return
    }
    set PVType [exec sdds2stream $configFile -par=PVType]
    set bpmType [lindex $PVType 0]
    set corrType [lindex $PVType 1]
    if [string match "*XR*" $DefaultType] {
        if [catch {exec sddsprocess $configFile -pipe=out \
                     -match=par,NameType=MonitorNames \
                     -match=col,Name=*BM*,Name=*ID*,| -nowarnings \
                     | sdds2stream -pipe -rows=bar } rows] {
            return -code error $rows
        }
        if !$rows {
            return -code error "Wrong type chosed -- there are no Xray BPMs in config file.!"
        }
    }
    if [string match "*DP*" $DefaultType] {
        if {$bpmType!="DP" || $corrType != "DP" } {
            return -code error "Cannot make link to DP default: the bpm or corrector type is not DP!"
        }
        if {![APSMultipleChoice [APSUniqueName .] \
                -question "Change a default DP orbit correction files? Are you sure?" -returnList {1 0} \
                -labelList {Yes No}]} {
            return
        }
	if [regexp "XRDP$" $DefaultType] {
	    #check the singular values
	    if [file exist $irmFile] {
		set NSV [exec sdds2stream -par=NumberOfSingularValuesUsed $irmFile]
		if {$NSV<50 || $NSV>60} {
		    if {![APSMultipleChoice [APSUniqueName .] \
			      -question "The SV number of chosen config is $NSV (not within 50-60 range), install it as XRDP may cause orbit motion, are you sure to install it as XRDP?" -returnList {1 0} \
			      -labelList {Yes No}]} {
			return
		    }
		}
	    }
	}
    } else {
        if {$bpmType=="DP" || $corrType == "DP" } {
            return -code error "Cannot make link to default: the bpm or corrector type is DP type!"
        }
        if {![APSMultipleChoice [APSUniqueName .] \
                -question "Change default orbit correction files? Are you sure?" -returnList {1 0} \
                -labelList {Yes No}]} {
            return
        }
    }
    APSMakeLink -local 1 -log 1 -permissions 00775 \
        -filename [subst \$${rootname}MainDir/\$${rootname}LatSubDir/\$${rootname}Lattice/\$${rootname}WriteDir] \
        -linkname [subst \$${rootname}MainDir/\$${rootname}LatSubDir/\$${rootname}Lattice/$DefaultType]
    
    APSSetVarAndUpdate ${rootname}ConfigStatus "[subst \$${rootname}WriteDir] installed as $DefaultType."
    set ${rootname}WriteDir $DefaultType
  
    if {$application=="RTFeedback"} {
        set plane [string tolower $Plane]
        global ${rootname}SingValues ${rootname}SVDanalysis 
	global ${rootname}TikhonovFilter ${rootname}TikhonovSVN ${rootname}TikhonovBeta ${rootname}TikhonovType
        global BPMLimit XBPMLimit corrLimit rangeErrorLimit S35DCCTLimitH S35DCCTLimitV 
        global dialogBoxResponse PVSuffix
        set S35DCCTLimitH 15
        set S35DCCTLimitV 15
        set BPMLimit 10
        set XBPMLimit 0.5
        set corrLimit 149.5
        set rangeErrorLimit 10
        set PVSuffix msAve
        set answer [APSMultipleChoice [APSUniqueName .] -question "If you made a change in RTFB BPMs in $plane.default,\nyou must\n\n1) press the \"Load Response Matrix\" button in \"SRFB Orbit Feedback Control\" application, and wait for completion.\n\n2) regenerate the compensation files and the controllaw files for each DC configuration. Press \"Regenerate\" to regenerate all necessary files, or \"Cancel\" to return. \n\nThe regeneration procedure takes about one minute.\n\nIf you did not make any BPM changes, you may press \"Cancel\"."  \
                      -labelList {Regenerate Cancel} -returnList {Regenerate Cancel} ]
        switch $answer {
            Cancel {
                APSSetVarAndUpdate ${rootname}ConfigStatus "The DC configurations did not change."
                return
            }
            Regenerate {
                set mainDir /home/helios/oagData/sr/orbitControllaw/lattices/default
                foreach dir [list $plane.default $plane.defaultDP $plane.defaultXR $plane.defaultXRDP \
                               $plane.defaultXRDP.fullSVs $plane.BPLDVerificationDP] {
                    if {![file exist $mainDir/$dir] || ![file exist $mainDir/$dir/config]} {
                        continue
                    }
                    APSSetVarAndUpdate ${rootname}ConfigStatus "Regenerate compensation files for $dir..."
                    if [catch {APSSRGenerateOrbCorrFiles -rootname $rootname -generate 1 \
                                 -configFile $mainDir/$dir/config -plane $plane \
                                 -referenceMatrix $mainDir/refMatrices/$plane.default \
                                 -outputRoot $mainDir/$dir -singularValues [set ${rootname}SingValues] \
                                 -SVDanalysis [set ${rootname}SVDanalysis] \
				   -tikhonovFilter [set ${rootname}TikhonovFilter] \
				   -tikhonovSVN [set ${rootname}TikhonovSVN] \
				   -tikhonovBeta [set ${rootname}TikhonovBeta] \
				   -tikhonovType [set ${rootname}TikhonovType] \
                                 -compensationConfigFile [subst \$${rootname}MainDir/\$${rootname}LatSubDir/\$${rootname}Lattice]/$DefaultType/config } result] {
                        return -code error $result
                    }
                }
                APSSetVarAndUpdate ${rootname}ConfigStatus "Regenerate controllaw files for DC configuration..."
                set dialogBoxResponse ""
                set win [APSUniqueName .]
                APSDialogBox $win -cancelCommand "set dialogBoxResponse cancel"  \
                  -okCommand "set dialogBoxResponse ok"  -name "Controllaw test file limits" 
                
                set w $win.userFrame
                APSLabeledEntry .le0 -parent $w -label "bpm limit (mm)" \
                  -textVariable BPMLimit -width 10
                APSLabeledEntry .le1 -parent $w -label "Xray bpm limit (mm)" \
                  -textVariable XBPMLimit -width 10
                APSLabeledEntry .le2 -parent $w -label "corrector limit (A)" \
                  -textVariable corrLimit -width 10
                APSLabeledEntry .le3 -parent $w -label "Range Error limit (A)" \
                  -textVariable rangeErrorLimit -width 10
                APSLabeledEntry .currLimitH -parent $w -label "S35DCCT lower limit (mA) for H plane" \
                  -textVariable S35DCCTLimitH -width 10 \
                  -contextHelp "Enter the lower limit of S35DCCT readback below which the sddscontrollaw correction iteration is skipped."
                APSLabeledEntry .currLimitV -parent $w -label "S35DCCT lower limit (mA) for V plane" \
                  -textVariable S35DCCTLimitV -width 10 \
                  -contextHelp "Enter the lower limit of S35DCCT readback below which the sddscontrollaw correction iteration is skipped."
                APSRadioButtonFrame .pvSuffix -parent $w -label "bpm PV type" \
                  -variable PVSuffix -valueList {ms msAve mswAve} \
                  -buttonList {ms msAve mswAve} -orientation horizontal -contextHelp \
                  "Select the memory/scanner PV type (i.e. bpm data type)."
                tkwait window $win
                update
                foreach dir [list $plane.default $plane.defaultDP $plane.defaultXR $plane.defaultXRDP \
                               $plane.defaultXRDP.fullSVs $plane.BPLDVerificationDP] {
                    if {![file exist $mainDir/$dir] || ![file exist $mainDir/$dir/config]} {
                        continue
                    }
                    if [catch {APSGenerateControllawFiles -regenerateFiles 1 \
                                 -dataDir $mainDir -directory $dir \
                                 -PVSuffix $PVSuffix -BPMLimit $BPMLimit -XBPMLimit $XBPMLimit \
                                 -corrLimit $corrLimit -rangeErrorLimit $rangeErrorLimit \
                                 -S35DCCTLimitH $S35DCCTLimitH -S35DCCTLimitV $S35DCCTLimitV \
                             } result] {
                        return -code error "GenerateFiles: $result"
                    }
                }
                APSSetVarAndUpdate ${rootname}ConfigStatus "Regenerate files done"
            }
        }
    }
}

proc APSUpdateTimeRegion {args} {
    set rootname ""
    APSParseArguments {rootname}
    global ${rootname}RefMatrix ${rootname}TimeRegion
    set refmatrix [set ${rootname}RefMatrix]
    
    if [regexp {region0} $refmatrix] {
        set ${rootname}TimeRegion region0
    } elseif [regexp {region1} $refmatrix] {
        set ${rootname}TimeRegion region1
    }  elseif [regexp {region2} $refmatrix] {
        set ${rootname}TimeRegion region2
    }  elseif [regexp {region3} $refmatrix] {
        set ${rootname}TimeRegion region3
    }  elseif [regexp {region4} $refmatrix] {
        set ${rootname}TimeRegion region4
    }  elseif [regexp {region5} $refmatrix] {
        set ${rootname}TimeRegion region5
    }  elseif [regexp {region6} $refmatrix] {
        set ${rootname}TimeRegion region6
    }  elseif [regexp {region7} $refmatrix] {
        set ${rootname}TimeRegion region7
    }  elseif [regexp {region8} $refmatrix] {
        set ${rootname}TimeRegion region8
    }  elseif [regexp {region9} $refmatrix] {
        set ${rootname}TimeRegion region9
    }  else {
        set ${rootname}TimeRegion ""
    }
}

proc APSFileSelectWidget {widget args} {
    set parent ""
    set variable ""
    set contextHelp ""
    set pathVariableList ""
    set filter *
    set filterVariableList ""
    set mode normal
    set incrementButtons 0
    set noPack 0
    set noSelect 0
    set label "File: "
    set width 20
    APSStrictParseArguments {parent variable contextHelp pathVariableList filter filterVariableList mode incrementButtons noPack noSelect label width}
    APSLabeledEntry $widget -parent $parent -label $label -contextHelp \
      $contextHelp -textVariable $variable -width $width
    if !$noSelect {
        if [string compare $mode normal] {
            APSButton .pick -parent $parent$widget -text P -size small -command \
              "set $variable \[APSPickFileFromDir [APSUniqueName .] -pathVariableList \[ list $pathVariableList \] -filter \"$filter\" -type $mode -default \$$variable -filterVariableList \[ list $filterVariableList \] \]"
        } else {
            APSButton .filesel -parent $parent$widget -size small -text F \
              -command "set $variable \[APSFileSelectDialog [APSUniqueName .] -path \[file dirname \$$variable\]\]" \
          }
    }
    if $incrementButtons {
        APSButton .plus -parent $parent$widget -size small  -text + \
          -command "APSIncrementConfigFilename -variable $variable" 
        APSButton .minus -parent $parent$widget -size small  -text - \
          -command "APSIncrementConfigFilename -variable $variable -amount -1" 
    }
}

proc APSPickFileFromDir {widget args} {
    set pathVariableList ""
    set directory .
    set filter *
    set filterVariableList ""
    set type file
    set default ""
    APSStrictParseArguments {pathVariableList filterVariableList type filter default directory}
    if [llength $filterVariableList] {
        set filter ""
        foreach item $filterVariableList {
            global $item
            set filter "${filter}[subst \$$item]"
        }
    }
    if [llength $pathVariableList] {
        set directory ""
        foreach item $pathVariableList {
            global $item
            set directory $directory/[subst \$$item]
        }
    }
    if {![file exists $directory] || ![file isdirectory $directory]} {
        return -code error "Not a directory : $directory"
    }
    set descDatabase 0
   
    if [regexp {(.*)[hv]} $filter plane] {
        if [file exist $directory/${plane}configDesc.sdds] {
            set descDatabase 1
        }
    } 
    if $descDatabase {
        set itemList [split [exec sdds2stream $directory/${plane}configDesc.sdds -col=Description] \n]
        set choiceList [exec sdds2stream $directory/${plane}configDesc.sdds -col=Filename]
    } else {
        set oldDir [pwd]
        cd $directory
        set fileList [lsort -decreasing [eval glob -nocomplain $filter]]
        cd $oldDir
        if [llength $fileList]==0 {
            return -code error "No files in directory: $directory"
        }
        set choiceList ""
        set itemList ""
        if {$type == "directory"} {
            foreach filename $fileList {
                set isDir [file isdirectory [file join $directory $filename]]
                if {$isDir} {
                    lappend choiceList $filename
                    if {[file type [file join $directory $filename]] == "link"} {
                        set link [file readlink [file join $directory $filename]]
                        # check for second level of link of type
                        # public/default -> ../etax10cm
                        if {[file type [file join $directory $link]]  == "link"} {
                            set link [file tail [file readlink [file join $directory $link]]]
                        }
                        lappend itemList "$filename -> $link"
                    } else {
                        if {[catch {
                            set fd [sdds open $directory/$filename/config.collapsed]
                            set description [sdds getColumn $fd Description]
                            sdds close $fd}]} {
                            lappend itemList $filename
                        } else {
                            lappend itemList "$filename -> [lindex $description 0]"
                        }
                    }
                }
            }
        } else {
            foreach filename $fileList {
                set isDir [file isdirectory [file join $directory $filename]]
                if {!$isDir} {
                    lappend choiceList $filename
                    if {[file type [file join $directory $filename]] == "link"} {
                        lappend itemList "$filename -> [file readlink [file join $directory $filename]]"
                    } else {
                        if {[catch {
                            set fd [sdds open $directory/$filename/config.collapsed]
                            set description [sdds getColumn $fd Description]
                            sdds close $fd}]} {
                            lappend itemList $filename
                        } else {
                            lappend itemList "$filename -> [lindex $description 0]"
                        }
                    }
                }
            }
        } 
    }
    if ![llength $choiceList] {
        return -code error "No choices in directory: $directory"
    }
    set value [APSChooseItemFromList -name ChoiceList -height 30 \
                 -itemList $itemList -returnList $choiceList -multiItem 0]
    if ![string length $value] {
        return $default
    }
    return $value
}

proc APSSRGenerateOrbCorrFiles {args} {
    set configFile ""
    set outputRoot ""
    set referenceMatrix ""
    set plane h
    set generate 0
    set install 0
    set rootname ""
    set singularValues 320
    set SVDanalysis 0
    set tikhonovFilter 0
    set tikhonovSVN 0
    set tikhonovBeta 0
    set tikhonovType SVN
    set compensationConfigFile ""
    set deleteVectors ""
    APSStrictParseArguments {configFile plane outputRoot referenceMatrix generate install rootname singularValues SVDanalysis compensationConfigFile deleteVectors tikhonovFilter tikhonovSVN tikhonovBeta tikhonovType}
    
    if {!$generate && !$install} return
    if {$tikhonovFilter} {
	if {$tikhonovType=="SVN" && !$tikhonovSVN} {
	    return -code error "APSSRGenerateOrbCorrFiles(0a): tikhonov SVN number not provided!"
	}
	if {$tikhonovType=="Beta" && !$tikhonovBeta} {
	    return -code error "APSSRGenerateOrbCorrFiles(0b): tikhonov beta value not provided!"
	}
    }
    if ![string length $rootname] {
        return -code error "APSSRGenerateOrbCorrFiles(0): programming error: no variable rootname"
    }

    if {![string length $configFile] || ![file exists $configFile]} {
        return -code error "APSSRGenerateOrbCorrFiles(1): supply a configuration file, or one that exists ($configFile was given)."
    }
    set configFile [APSResolveLink $configFile]

    if {[string length $compensationConfigFile] && ![file exists $compensationConfigFile]} {
        return -code error "APSSRGenerateOrbCorrFiles(1a): supply a configuration file for the compensation matrix, or one that exists ($compensationConfigFile was given)."
    }

    if {![string length $referenceMatrix] || ![file exists $referenceMatrix]} {
        return -code error "APSSRGenerateOrbCorrFiles(2): supply a reference matrix file, or one that exists ($referenceMatrix was given)."
    }
    set referenceMatrix [APSResolveLink $referenceMatrix]
    set origRefMatrix $referenceMatrix

    if ![string length $outputRoot] {
        return -code error "APSSRGenerateOrbCorrFiles(3): supply an output rootname."
    }

    global ${rootname}ConfigStatus
    set ${rootname}ConfigStatus "Working..."
    update
    if [catch {exec sddsprocess $configFile -pipe=out \
                 -match=parameter,NameType=CorrectorNames \
                 -filter=column,Flag,1,1 \
                 | sddscombine -merge -pipe \
                 | sdds2stream -pipe -column=Name} correctorNames] {
        return -code error "APSSRGenerateOrbCorrFiles(4): $correctorNames"
    }
    if [string length $compensationConfigFile] {
        if [catch {exec sddsprocess $compensationConfigFile -pipe=out \
                     -match=parameter,NameType=MonitorNames \
                     -filter=column,Flag,1,1 \
                     | sddscombine -merge -pipe \
                     | sdds2stream -pipe -column=Name} RTmonitorNames] {
            return -code error "APSSRGenerateOrbCorrFiles(4a): $RTmonitorNames"
        }
    }
    set tmpRoot /tmp/[APSTmpString]
    APSAddToTempFileList $tmpRoot.monFlags 
    if [catch {exec sddsprocess $configFile -pipe=out \
                 -match=parameter,NameType=MonitorNames \
                 -filter=column,Flag,1,1 \
                 | sddscombine -pipe -merge \
                 | tee $tmpRoot.monFlags \
                 | sdds2stream -pipe -column=Name} monitorNames] {
        return -code error "APSSRGenerateOrbCorrFiles(5): $monitorNames"
    }
    # row filter for reference matrix.
    set monitorNameMatchOption ""
    set IDBPMList ""
    set BMBPMList ""
    foreach item $monitorNames {
        switch -regexp $item {
            ID {
                lappend IDBPMList $item
            }
            BM {
                lappend BMBPMList $item
            }
        }
        if [string length $monitorNameMatchOption] {
            append monitorNameMatchOption ",BPMName=$item,|"
        } else {
            set monitorNameMatchOption "-match=column,BPMName=$item"
        }
    }
    if [string length $compensationConfigFile] {
        set RTmonitorNameMatchOption ""
        foreach item $RTmonitorNames {
            if [string length $RTmonitorNameMatchOption] {
                append RTmonitorNameMatchOption ",BPMName=$item,|"
            } else {
                set RTmonitorNameMatchOption "-match=column,BPMName=$item"
            }
        }
    }
    # create more monitors, i.e. add rows to response matrix
    set equationCmd ""
    if [llength $IDBPMList] {
        set IDBPMsKnownList [APSGetIDXRayBPMList -plane $plane]
        set IDBPMEqnList    [APSGetIDXRayEqnList -plane $plane]
        lappend equationCmd sddsprocess -pipe
        foreach item $IDBPMList {
            set index [lsearch -exact $IDBPMsKnownList $item]
            if $index==-1 {
                return -code error "APSSRGenerateOrbCorrFiles(7): no information on $item"
            }
            set equation [lindex $IDBPMEqnList $index]
            if ![string length $equation] {
                return -code error "APSSRGenerateOrbCorrFiles(8): no equation defined for $item."
            }
            lappend equationCmd "-define=column,$item,$equation"
        }
    }
    if [llength $BMBPMList] {
        set BMBPMsKnownList [APSGetBMXRayBPMList -plane $plane]
        set BMBPMEqnList    [APSGetBMXRayEqnList -plane $plane]
        if ![string length $equationCmd] {
            lappend equationCmd sddsprocess -pipe
        }
        foreach item $BMBPMList {
            set index [lsearch -exact $BMBPMsKnownList $item]
            if $index==-1 {
                return -code error "APSSRGenerateOrbCorrFiles(9): no information on $item"
            }
            set equation [lindex $BMBPMEqnList $index]
            if ![string length $equation] {
                return -code error "APSSRGenerateOrbCorrFiles(10): no equation defined for $item."
            }
            lappend equationCmd "-define=column,$item,$equation"
        }
    }
    if { [llength $IDBPMList] || [llength $BMBPMList] } {
        set tmpMatrix /tmp/[APSTmpString]
        if [catch {eval exec sddstranspose $referenceMatrix -pipe=out  \
                     | $equationCmd \
                     | sddstranspose -pipe=in $tmpMatrix \
                     -newColumnNames=OldColumnNames -oldColumnNames=BPMName} result] {
            return -code error "APSSRGenerateOrbCorrFiles(11): $result"
        }
        set referenceMatrix $tmpMatrix
    }
    set inverseOptions "-largestSingularValues=$singularValues"
    if $tikhonovFilter {
	if {$tikhonovType=="SVN"} {
	    if $tikhonovSVN {
		lappend inverseOptions "-tikhonov=SVN=[expr abs($tikhonovSVN)]"
	    }
	} elseif $tikhonovBeta {
	    lappend inverseOptions "-tikhonov=beta=[expr abs($tikhonovBeta)]"
	}
    }
    if [lsearch -exact [APSGetSDDSNames -fileName $tmpRoot.monFlags -class column] Weight]!=-1 {
        lappend inverseOptions "-weights=$tmpRoot.monFlags,name=Name,value=Weight"
    }
    if ![string length $compensationConfigFile] {
        if $SVDanalysis {
            set tmpOutput /tmp/[APSTmpString]
            APSAddToTmpFileList -ID APSSRGenerateOrbCorrFiles -fileList $tmpOutput
            if [catch {eval exec sddsconvert $referenceMatrix -pipe=out \
                         -retain=column,BPMName,[join $correctorNames ,] \
                         | sddsprocess -pipe $monitorNameMatchOption \
                         | sddspseudoinverse -pipe=in $tmpOutput $inverseOptions \
                         -umatrix=$outputRoot/u \
                         -vmatrix=$outputRoot/v \
                         -sfile=$outputRoot/s \
                     } result] {
                return -code error "APSSRGenerateOrbCorrFiles(svd): Error possibly caused by non-existent inverse. Check your configuration.\nProcessing command returns:\n$result"
            }
            set convertOption -retain=col,OldColumnNames
            for {set i 0} {$i<$singularValues} {incr i} {
                append convertOption ,SV[format %03d $i]
            }
            if [catch {exec sddsconvert $outputRoot/v $tmpOutput.v $convertOption} result] {
                return -code error "APSSRGenerateOrbCorrFiles(svd): $result:`"
            }
            # execution is blocked until the user makes the choice of
            # vectors in tksddsplot and quits.
            set returnList [exec tksddsplot $tmpOutput.v -col=OldColumnNames,SV* -sep \
                              -enum=interval=20 -selectFrames]
            set deleteVectors ""
            set index 0
            foreach selected $returnList {
                if {!$selected} {
                    lappend deleteVectors $index
                }
                incr index
            }
            global ${rootname}DeleteModes
            set ${rootname}DeleteModes $deleteVectors
            APSSetVarAndUpdate ${rootname}ConfigStatus "SVD analysis done."
            return
        }
        global ${rootname}DeleteModes
        if ![string length $deleteVectors] {
            if {[info exists ${rootname}DeleteModes] && 
                [llength [set ${rootname}DeleteModes]]} {
                set deleteVectors [set ${rootname}DeleteModes]
            }
        }
        # When the procedure is called from pem, say, there may
        # be no request to delete modes, and the variable
        # ${rootname}DeleteModes may not even be defined.
        # This variable is defined and set in the GUI.
        # Perhaps the variable should be in the arguments list
        # instead of a global.
        if [llength $deleteVectors] {
            lappend inverseOptions -deleteVectors=[join $deleteVectors ,]
        }
        if [catch {eval exec sddsconvert $referenceMatrix -pipe=out \
                     -retain=column,BPMName,[join $correctorNames ,] \
                     | sddsprocess -pipe $monitorNameMatchOption \
                     | tee $outputRoot/rm \
                     | sddspseudoinverse -pipe $inverseOptions \
                     | sddsconvert -pipe -rename=column,OldColumnNames=ControlName \
                     | sddsprocess -pipe=in $outputRoot/irm \
                     -print=parameter,ConfigurationFile,$configFile \
                     -print=parameter,ReferenceMatrix,$origRefMatrix} result] {
            return -code error "APSSRGenerateOrbCorrFiles(12): Error possibly caused by non-existent inverse. Check your configuration.\nProcessing command returns:\n$result"
        }
        catch {exec sdds2headlessdata $outputRoot/rm $outputRoot/rm.dat -col=S* -order=column}
        catch {exec sdds2headlessdata $outputRoot/irm $outputRoot/irm.dat -col=S* -order=column}
        catch {file delete -force $outputRoot/irm~}
        if [catch {exec sdds2stream -param=ConditionNumber $outputRoot/irm} condNumber] {
            return -code error "APSSRGenerateOrbCorrFiles(13): error getting condition number"
        }
        set ${rootname}ConfigStatus "[exec date] Done.  Condition number is $condNumber."
    } else {
        # get response matrix use bpms of RT system and 
        # correctors of DC correction.
        if [catch {eval exec sddsconvert $referenceMatrix -pipe=out \
                     -retain=column,BPMName,[join $correctorNames ,] \
                     | sddsprocess -pipe=in $outputRoot/rmFF \
                     $RTmonitorNameMatchOption \
                     -print=parameter,ConfigurationFile,$configFile \
                     -print=parameter,ReferenceMatrix,$origRefMatrix} result] {
            return -code error "APSSRGenerateOrbCorrFiles(14): $result"
        }
        set ${rootname}ConfigStatus "[exec date] Done."
    }
    update
}

proc APSIncrementConfigFilename {args} {
    set variable ""
    set amount 1
    APSStrictParseArguments {variable amount}
    global $variable
    set filename [subst \$$variable]
    set index [string last . $filename]
    if $index!=-1 {
        set filename0 [string range $filename 0 $index]
        scan [string range $filename [expr $index+1] [expr $index+2]] "%ld" counter
        set filename1 [string range $filename [expr $index+3] end]
        incr counter $amount
        if $counter<0 {
            set counter 0
        }
        set $variable ${filename0}[format %02ld $counter]${filename1}
    }
}

proc APSSRWriteOrbitCorrectionConfig {args} {
    set rootname ""
    set filename ""
    set description ""
    set interactive 0
    set includeP0s 0
    set includeIDs 0
    set includeBMs 0
    set configName ""
    APSStrictParseArguments {rootname filename description interactive includeP0s includeIDs includeBMs configName}

    if ![string length [string trim $configName]] {
        return -code error "APSSRWriteOrbitCorrectionConfig: supply a configuration name"
    }

    set path [file dirname $filename]
    set pathPart [file tail $path]

    APSSRSectorUnsetMissing -rootname $rootname -missingList {S1A:H3 S39B:H1 S40A:H3}
    APSSRSectorUnsetMissing -rootname $rootname -missingList {S1A:V3 S39B:V1 S40A:V3}
    set BPMList [list A:P1 A:P2 A:P3 A:P4 B:P5 B:P4 B:P3 B:P2 B:P1]
    if $includeP0s {
        set BPMList [concat A:P0 $BPMList B:P0 C:P0]
    }
    if $includeIDs {
        set BPMList [concat $BPMList ID:P1 ID:P2]
    }
    if $includeBMs {
        set BPMList [concat $BPMList BM:P1 BM:P2]
    }
    if {$includeBMs || $includeIDs || $includeP0s} {
        switch -regexp $rootname {
            rf -
            h {
                APSSRSectorUnsetMissing -rootname $rootname \
                  -missingList [APSGetMissingBPMList -plane h]
            }
            v {
                APSSRSectorUnsetMissing -rootname $rootname \
                  -missingList [APSGetMissingBPMList -plane v]
            }
            default {
                APSSRSectorUnsetMissing -rootname $rootname \
                  -missingList [APSGetMissingBPMList -plane h]
            }
        }
    }
    if $interactive {
        set corCount(h) [APSCountSRConfig -rootname $rootname \
                           -itemList {A:H1 A:H2 A:H3 A:H4 B:H4 B:H3 B:H2 B:H1 C:H1} \
                           -missingList {S1A:H3 S39B:H1 S40A:H3}]
        set corCount(v) [APSCountSRConfig -rootname $rootname \
                           -itemList {A:V1 A:V2 A:V3 A:V4 B:V4 B:V3 B:V2 B:V1 C:V1} \
                           -missingList {S1A:V3 S39B:V1 S40A:V3}]

        set confirm 0
        set confirmQuery ""
        if {!$corCount(h) && !$corCount(v)} {
            set confirm 1
            append confirmQuery "\nNo correctors chosen."
        } else {
            set otherPlane v
            foreach plane {h v} {
                if [string match $plane.* $pathPart] {
                    if !$corCount($plane) {
                        set confirm 1
                        append confirmQuery "\nNo $plane correctors chosen for apparent $plane configuration."
                    }
                    if $corCount($otherPlane) {
                        set confirm 1
                        append confirmQuery "\n$otherPlane correctors chosen for apparent $plane configuration."
                    }
                }
                set otherPlane h
            }
        }
        if [APSCountSRConfig -rootname $rootname -itemList $BPMList]==0 {
            set confirm 1
            append confirmQuery "\nNo monitors chosen."
        }
        if {$confirm &&
            [APSMultipleChoice [APSUniqueName .] -question "Possible problem: $confirmQuery" \
               -labelList {Continue Cancel} -returnList {1 0}]==0} {
            return
        }
    }
    
    if ![file exists $path] {
        exec  mkdir $path
        #catch {exec setfacl -m mask:rwx $path}
    } else {
        if {$interactive && \
              [APSMultipleChoice [APSUniqueName .] -question "That configuration exists.  Overwrite?" \
                 -labelList {Yes No} -returnList {1 0}]==0} {
            return
        }
        set filesToDelete [glob -nocomplain $path/*]
        if [llength $filesToDelete] {
            if [catch {eval file delete -force -- $filesToDelete} result] {
                return -code error "APSSRWriteOrbitCorrectionConfig: $result"
            }
        }
    }
    APSWriteSRConfig -rootname $rootname -filename $filename \
      -nameTypeList {Monitor Corrector} -interactive $interactive \
      -suffixLists [list $BPMList \
                      {A:H1 A:H2 A:H3 A:H4 B:H4 B:H3 B:H2 B:H1 C:H1 \
                         A:V1 A:V2 A:V3 A:V4 B:V4 B:V3 B:V2 B:V1 C:V1} ] \
      -description $description
    catch {exec sddscollapse $filename $filename.collapsed}
}

proc APSCountSRConfig {args} {
    set rootname ""
    set sectorCount 40
    set itemList ""
    set missingList ""
    set sectorList ""
    APSStrictParseArguments {rootname sectorCount itemList missingList sectorList}

    if [llength $missingList] {
        APSSRSectorUnsetMissing -rootname $rootname -missingList $missingList
    }

    global ${rootname}ConfigStatus
    set count 0
    for {set sector 1} {$sector<=$sectorCount} {incr sector} {
	if [llength $sectorList] {
	    set sector1 [lindex $sectorList [expr $sector-1]]
	} else {
	    set sector1 S$sector
	}
        foreach item $itemList {
            set nameFlag ${rootname}${sector1}$item
            global $nameFlag
            if [set $nameFlag] {
                incr count
            }
        }
    }
    return $count
}

proc APSWriteSRConfig {args} {
    set rootname ""
    set sectorCount 40
    set filename ""
    set PVTypeList ""
    set nameTypeList ""
    set suffixLists ""
    set description ""
    set interactive 0
    set booster 0
    set sectorList ""
    set updateDatabase 1
    APSStrictParseArguments {rootname sectorCount filename PVTypeList nameTypeList updateDatabase \
                               suffixLists description interactive booster sectorList}
    global env
    if ![string length $filename] {
        return -code error "APSWriteSRConfig: No filename specified for orbit configuration"
    }
    set oldDir [pwd]
    if {$interactive && [file exists $filename] && \
          [APSMultipleChoice [APSUniqueName .] -question "$filename exists.  Overwrite?" \
             -labelList {Yes No} -returnList {1 0}]==0} {
        return 
    }
    global keepDays
    set keepDays 180
    if [llength $sectorList] {
	set sectorCount [llength $sectorList]
    }
    
    if $interactive {
        APSDialogBox .default -name "How many days do you want to keep this configuration?" -width 50 \
            -okCommand {set cancel 0} -cancelCommand {set cancel 1} -cancelButton 0
        APSLabeledEntry .info -parent .default.userFrame -label "Enter number of days to keep or -1 for keeping forever" -textVariable keepDays
        tkwait window .default
    }
    set origname $filename
    set filename ${filename}.tmp
    #update config description database
    set newConfig [file dir $origname]
    set rootDir [file dir $newConfig]
    set newConfig [file tail $newConfig]
    APSAddToTmpFileList -ID APSWriteConfig -fileList "$filename $filename.bpm $filename.corr $filename.bpm.type"
    set createTime [clock seconds]
    set createDate [clock format $createTime -format "%a %b %d %H:%M:%S %Y"]
    if [catch {sdds open ${filename} w} fid] {
        return -code error "APSWriteSRConfig: Unable to open file $filename: $fid"
    }
    if [catch {sdds defineColumn $fid Name -type SDDS_STRING
        sdds defineColumn $fid Flag -type SDDS_SHORT 
        sdds defineColumn $fid Weight -type SDDS_DOUBLE
        sdds defineColumn $fid Despike -type SDDS_LONG
        sdds defineParameter $fid Description -type SDDS_STRING
        sdds defineParameter $fid NameType -type SDDS_STRING
        sdds defineParameter $fid PVType -type SDDS_STRING
        sdds defineParameter $fid KeepDays -type SDDS_LONG
        sdds defineParameter $fid CreationTime -type SDDS_LONG -units seconds
        sdds defineParameter $fid CreationDate -type SDDS_STRING
        sdds defineParameter $fid User -type SDDS_STRING
        sdds defineParameter $fid Host -type SDDS_STRING
        sdds defineParameter $fid Time -type SDDS_LONG -units seconds
        sdds defineParameter $fid TimeStamp -type SDDS_STRING
	#if [string length $rampTimeRegion] {
	    #sdds defineParameter $fid RampStartTime -type SDDS_DOUBLE
	    #sdds defineParameter $fid RampEndTime -type SDDS_DOUBLE
	    #sdds defineParameter $fid BpmN -type SDDS_DOUBLE
         #   sdds defineParameter $fid TimeRegion -type SDDS_STRING
	#}
        sdds writeLayout $fid} result] {
        catch {sdds close $fid}
        return -code error "APSWriteSRConfig: problem defining SDDS elements: $result"
    }
    set nameTypeIndex -1
    global ${rootname}ConfigStatus  
    if [llength $PVTypeList]!=[llength $nameTypeList] {
        set PVTypeList [APSReplicateItem -item unknown -number [llength $nameTypeList]]
    }
    foreach nameType $nameTypeList PVType $PVTypeList {
        incr nameTypeIndex
        set flags ""
        set names ""
        set weights ""
        set despikeFlags ""
        for {set sector 1} {$sector<=$sectorCount} {incr sector} {
	    if [llength $sectorList] {
		set sector1 [lindex $sectorList [expr $sector -1]]
	    } else {
		set sector1 S$sector
	    }
            foreach suffix [lindex $suffixLists $nameTypeIndex] {
                set nameFlag ${rootname}${sector1}$suffix
                set weightVar ${rootname}${sector1}${suffix}Weight
                set despikeVar ${rootname}${sector1}${suffix}Despike
                global $nameFlag $weightVar $despikeVar
                if [set $nameFlag] {
                    lappend flags 1
                    lappend names ${sector1}$suffix
                    if [info exists $weightVar] {
                        lappend weights [set $weightVar]
                    } else {
                        lappend weights 1.0
                    }
                    if [regexp {(BM)|(ID)} $nameFlag] {
                        lappend despikeFlags 0
                    } else {
                        if [info exists $despikeVar] {
                            lappend despikeFlags [set $despikeVar]
                        } else {
                            lappend despikeFlags 1
                        }
                    }
                }
            }
        }
        if [llength $flags]==0 continue
        APSSetVarAndUpdate ${rootname}ConfigStatus "[exec date] [llength $flags] $nameType"
        if [catch {sdds startPage $fid [expr 360*20] 
            sdds setParameter $fid Description $description
            sdds setParameter $fid PVType $PVType 
            sdds setParameter $fid KeepDays $keepDays
            sdds setParameter $fid CreationTime $createTime
            sdds setParameter $fid CreationDate $createDate
            sdds setParameter $fid NameType ${nameType}Names
            sdds setParameter $fid User $env(USER)
            sdds setParameter $fid Host $env(HOST)
            sdds setParameter $fid Time $createTime
            sdds setParameter $fid TimeStamp $createDate } result] {
            catch {sdds close $fid}
            return -code error "APSWriteSRConfig: SDDS problem: $result"
        }
	#if [string length $rampTimeRegion] {
	   # sdds setParameter $fid RampStartTime $startRamp
	    #sdds setParameter $fid RampEndTime $endRamp
	   # sdds setParameter $fid BpmN $BPMTime
         #   sdds setParameter $fid TimeRegion $rampTimeRegion
	#}
       # foreach column {names flags weights} {
       #     APSSetVarAndUpdate ${rootname}ConfigStatus [llength $column]
       # }
        if [catch {eval sdds setColumn $fid Name $names
            eval sdds setColumn $fid Flag $flags 
            eval sdds setColumn $fid Weight $weights
            eval sdds setColumn $fid Despike $despikeFlags
            sdds writePage $fid} result] {
            catch {sdds close $fid}
            return -code error "APSWriteSRConfig: SDDS problem: $result"
        }
    }
    if [catch {sdds close $fid} result] {
        return -code error "APSWriteSRConfig: SDDS problem: $result"
    }
    global ${rootname}ConfigStatus
    if !$booster {
        set bpmconfig /home/helios/oagData/sr/BPMStatus/config.sdds
        if [catch {exec sddsprocess $filename -match=par,NameType=MonitorNames $filename.bpm
            exec sddsprocess $filename -match=par,NameType=MonitorNames,! $filename.other \
                     -print=col,ElectronicsType,\"\"
            exec sddsxref $filename.bpm $bpmconfig -match=Name=DeviceName \
                     -take=ElectronicsType $filename.bpm.type
            exec sddscombine $filename.bpm.type $filename.other $origname -overwrite} result] {
            return -code error "APSWriteSRConfig: $result"
        }
    } else {
	exec mv $filename $origname
    }
   
    if $updateDatabase {
	set ${rootname}ConfigStatus "[exec date] Update config description database..."
	if [catch {APSUpdateConfigDescriptionDatabase -newConfig $newConfig \
		       -dataDir $rootDir -booster $booster } result] {
	    return -code error "APSWriteSRConfig: $result"
	}
	set ${rootname}ConfigStatus "[exec date] Update config description database done"
    }
    cd $oldDir
    set ${rootname}ConfigStatus "[exec date] Wrote configuration to $origname"
    update
}

proc APSReadOrbitCorrectionConfig {args} {
    set rootname ""
    set filename ""
    set logic replace
    set includeP0s 0
    set includeIDs 0
    set includeBMs 0
    #booster=1 means for booster
    set booster 0  
    set sectorCount 40
    set nameTypeList {Corrector Monitor}
    set application DCOrbitCorrection
    APSStrictParseArguments {rootname filename logic includeP0s includeIDs includeBMs \
                               booster sectorCount nameTypeList application}
    global ${rootname}BadBPMList
    if {![info exists ${rootname}BadBPMList]} {
        set ${rootname}BadBPMList ""
    }
    if !$booster {
        #SR
        set BPMList [list A:P1 A:P2 A:P3 A:P4 B:P5 B:P4 B:P3 B:P2 B:P1]
        if $includeP0s {
            set BPMList [concat A:P0 $BPMList B:P0 C:P0]
        }
        if $includeIDs {
            set BPMList [concat $BPMList ID:P1 ID:P2]
        }
        if $includeBMs {
            set BPMList [concat $BPMList BM:P1 BM:P2]
        }
        switch -regexp $rootname {
            rf {
                set BPMMissingList [APSGetMissingBPMList -plane h]
                set missingList "S1A:H3 S39B:H1 S40A:H3 $BPMMissingList"
                set corList "A:H1 A:H2 A:H3 A:H4 B:H4 B:H3 B:H2 B:H1 C:H1"
            }
            h {
                set BPMMissingList [APSGetMissingBPMList -plane h]
                set missingList "S1A:H3 S39B:H1 S40A:H3 $BPMMissingList [set ${rootname}BadBPMList]"
                set corList "A:H1 A:H2 A:H3 A:H4 B:H4 B:H3 B:H2 B:H1 C:H1"
            }
            v {
                set BPMMissingList [APSGetMissingBPMList -plane v]
                set missingList "S1A:V3 S39B:V1 S40A:V3 $BPMMissingList [set ${rootname}BadBPMList]"
                set corList "A:V1 A:V2 A:V3 A:V4 B:V4 B:V3 B:V2 B:V1 C:V1"
            }
            default {
                set BPMMissingList [APSGetMissingBPMList -plane h]
                set missingList "S1A:V3 S39B:V1 S40A:V3 S1A:H3 S39B:H1 \
                               S40A:H3 $BPMMissingList"
                set corList "A:H1 A:H2 A:H3 A:H4 B:H4 B:H3 B:H2 B:H1 C:H1\
                               A:V1 A:V2 A:V3 A:V4 B:V4 B:V3 B:V2 B:V1 C:V1"
            }
        }
	set sectorList ""
    } else {
        set BPMList {P1 P2 }
        switch -regexp $rootname {
            h {
                set corList H
            }
            v {
                set corList V
            }
            default {
                set corList {H V}
            }
        }
        set missingList B2C9V
	set sectorList ""
	for {set b 1} {$b<5} {incr b} {
	    for {set c 0} {$c<10} {incr c} {
		lappend sectorList B${b}C$c
	    }
	}
    }
    set suffixList [concat $BPMList $corList]
    if [catch {APSReadSRConfig -rootname $rootname -filename $filename -logic $logic \
                 -nameTypeList $nameTypeList -sectorList $sectorList \
                 -knownSuffixes $suffixList -booster $booster \
                 -missingList $missingList -application $application } description] {
        return -code error $description
    }
    global ${rootname}ReadDescription
    set ${rootname}ReadDescription $description
}

proc APSReadSRConfig {args} {
    set rootname ""
    set sectorCount 40
    set filename ""
    set logic replace
    set nameTypeList ""
    set knownSuffixes ""
    set missingList ""
    set booster 0
    set sectorList ""
    set application DCOrbitCorrection
    APSStrictParseArguments {rootname sectorCount filename logic nameTypeList knownSuffixes missingList \
                           booster sectorList application}
    
    if ![string length $nameTypeList] {
        return -code error "APSReadSRConfig: nameTypeList argument not given or invalid"
    }
    if ![string length $filename] {
        return -code error "APSReadSRConfig: No filename specified for orbit configuration"
    }
    if ![file exists $filename] {
        return -code error "APSReadSRConfig: File $filename not found."
    }
    set tmpRoot /tmp/[APSTmpString]
    set selectionFiles ""
    foreach nameType $nameTypeList {
        APSAddToTempFileList $tmpRoot.${nameType}1
        APSAddToTempFileList $tmpRoot.${nameType}2
        APSAddToTempFileList $tmpRoot.${nameType}
        if [catch {exec sddsprocess $filename $tmpRoot.${nameType}1 -nowarning \
                     -match=parameter,NameType=${nameType}Names \
                     "-test=parameter,n_rows 0 >" \
                     -filter=column,Flag,1,1 
            exec sddsprocess $filename $tmpRoot.${nameType}2 -nowarning \
                     -match=parameter,NameType=Not${nameType}Names \
                     "-test=parameter,n_rows 0 >" \
                     -filter=column,Flag,0,0 
            exec sddscombine -merge $tmpRoot.${nameType}1 $tmpRoot.${nameType}2 \
                     $tmpRoot.$nameType} result] {
            return -code error "Problem making list of included $nameType items: $result"
        }
        lappend selectionFiles $tmpRoot.$nameType
        if [catch {exec sdds2stream $tmpRoot.$nameType -parameter=PVType} result] {
            set result plain
        }
        switch $nameType {
            Monitor {
                global ${rootname}BPMPVType 
                set ${rootname}BPMPVType $result
            }
            Corrector {
                global ${rootname}CorrectorPVType 
                set ${rootname}CorrectorPVType $result
            }
        }
    }
    APSAddToTempFileList $tmpRoot.selections
    global ${rootname}Plane 
    APSRescanBadOrbitDevices -rootname $rootname -plane [set ${rootname}Plane] -application $application
    if [catch {eval exec sddscombine $selectionFiles -merge -pipe=out \
		   | tee $tmpRoot.selections \
		   | sdds2stream -pipe=in -column=Name} onNameList] {
	return -code error "Problem getting name list: $onNameList"
    }
    
    if [lsearch -exact [APSGetSDDSNames -class column -fileName $tmpRoot.selections] Weight]!=-1 {
        if [catch {APSGetSDDSColumns -fileName $tmpRoot.selections \
                     -columnList Weight -variableList WeightList} result] {
            return -code error "Problem getting weight data: $result"
        }
    } else {
        set WeightList [APSReplicateItem -number [llength $onNameList] -item 1.0]
    }
    if [lsearch -exact [APSGetSDDSNames -class column -fileName $tmpRoot.selections] Despike]!=-1 {
        if [catch {APSGetSDDSColumns -fileName $tmpRoot.selections \
                     -columnList Despike -variableList DespikeList} result] {
            return -code error "Problem getting despike data: $result"
        }
    } else {
        set DespikeList ""
        foreach item $onNameList {
            if [regexp {(BM)|(ID)} $item] {
                lappend DespikeList 0
            } else {
                lappend DespikeList 1
            }
        }            
    }
    if [catch {eval exec sdds2stream $filename -parameter=Description | tail -1} readDescription] {
        set readDescription ""
    }
    global ${rootname}ConfigStatus ${rootname}CBWidget
    set ${rootname}ConfigStatus "Read configuration from $filename"
    update
    set dir [file dir $filename]
    if ![file exist $dir/irm] {
        set ${rootname}ConfigStatus "Warning: the irm of [file tail $dir] does not exist!"
    } else {
        if [catch {exec sdds2stream -par=ConditionNumber $dir/irm} result] {
            set ${rootname}ConfigStatus "$result!"
        } else {
            set ${rootname}ConfigStatus "The condition number is $result"
        }
        if [catch {exec sdds2stream -par=NumberOfSingularValuesUsed $dir/irm} singular] {
            set ${rootname}ConfigStatus "$singular!"
        } else {
            set ${rootname}ConfigStatus "The number of singular values is $singular."
        }
    }
    update
    switch -exact [lsearch [list replace or and not] $logic] {
        1 {
            # or
            foreach item $onNameList weight $WeightList despike $DespikeList {
                set nameFlag ${rootname}${item}
                set weightVar ${rootname}${item}Weight
                set despikeVar ${rootname}${item}Despike
                global $nameFlag ${rootname}${item}Weight ${rootname}${item}Despike
                #set $nameFlag 1
                if {[set $nameFlag] != 1} {
                    [set ${rootname}CBWidget($item)] invoke
                }
                set ${rootname}${item}Weight $weight
                set ${rootname}${item}Despike $despike
            }
        }
        2 {
            # and
            for {set sector 1} {$sector<=$sectorCount} {incr sector} {
		if [llength $sectorList] {
		    set sector1 [lindex $sectorList [expr $sector -1]]
		} else {
		    set sector1 S$sector
		}
                foreach item $knownSuffixes {
                    set name ${sector1}$item
                    if [lsearch $onNameList $name]==-1 {
                        set nameFlag ${rootname}${name} 
                        global $nameFlag
                        if {[info exists $nameFlag]} {
                            if {[set $nameFlag] != 0} {
                                [set ${rootname}CBWidget($name)] invoke
                            }
                            #set $nameFlag 0
                        }
                    }
                }
            }
        }
        3 {
            # not
            foreach item $onNameList {
                set nameFlag ${rootname}${item}
                global $nameFlag
                #set $nameFlag 0
                if {[set $nameFlag] != 0} {
                    [set ${rootname}CBWidget($item)] invoke
                }
            }
        }
        default {
            # replacement
            APSSetSRSectorButtons -mode all-off -rootname ${rootname} -sectorList $sectorList \
              -sectorCount $sectorCount -itemList $knownSuffixes
            foreach item $onNameList weight $WeightList despike $DespikeList {
                set nameFlag ${rootname}${item} 
                set weightVar ${rootname}${item}Weight
                set despikeVar ${rootname}${item}Despike
                global $nameFlag ${rootname}${item}Weight ${rootname}${item}Despike
                #set $nameFlag 1
                [set ${rootname}CBWidget($item)] invoke
                set ${rootname}${item}Weight $weight
                set ${rootname}${item}Despike $despike
            }
        }
    }
   # APSSRSectorUnsetMissing -rootname $rootname -missingList $missingList
    return $readDescription
}

proc APSSRMonitorCheckButtons {widget args} {
    set rootname ""
    set parent ""
    set orientation vertical
    set packOption "-side left"
    set includeP0s 0
    set includeIDs 0
    set includeBMs 0
    set BP5Only 0
    set sectorControl 0
    set missingList ""
    set missingListVar ""
    set noLabel 0
    APSStrictParseArguments {rootname parent orientation packOption includeP0s includeIDs includeBMs sectorControl missingList missingListVar noLabel BP5Only}
   
    if ![llength $missingList] {
        switch -regexp $rootname {
            rf -
            h {
                set missingList [APSGetMissingBPMList -plane h]
            }   
            v {     
                set missingList [APSGetMissingBPMList -plane v]
            }
            default {
                set missingList [APSGetMissingBPMList -plane h]
            }       
        }
    }
    if $BP5Only {
        # actually, we need to add many bpms for rf frequecny controllaw
        # instead of just B:P5
        set itemList [list A:P0 A:P1 A:P2 A:P3 A:P4 B:P5 B:P4 B:P3 B:P2 B:P1 B:P0]
        set itemLabelList [list A0 A1 A2 A3 A4 B5 B4 B3 B2 B1 B0]
    } else {
        set itemList [list A:P1 A:P2 A:P3 A:P4 B:P5 B:P4 B:P3 B:P2 B:P1]
        set itemLabelList [list A1 A2 A3 A4 B5 B4 B3 B2 B1]
        if $includeP0s {
            set itemList [concat A:P0 $itemList B:P0 C:P0]
            set itemLabelList [concat A0 $itemLabelList B0 C0]
        }
        if $includeBMs {
            set itemList [concat $itemList BM:P1 BM:P2]
            set itemLabelList [concat $itemLabelList D1 D2]
        }
        if $includeIDs {
            set itemList [concat $itemList ID:P1 ID:P2]
            set itemLabelList [concat $itemLabelList I1 I2]
        }
    }
    if $noLabel {
        set label ""
    } else {
        set label Monitors
    }
    if [string length $missingListVar] {
        APSSRSectorButtons .sbbut -parent $parent -rootname ${rootname} \
          -label $label -description "monitors" -orientation $orientation \
          -itemList $itemList -itemLabelList $itemLabelList \
          -sectorControl $sectorControl \
          -packOption $packOption -missingList $missingList \
          -includeWeights 1 -includeDespike 1 -missingListVar $missingListVar \
          -command "APSSRSectorUnsetMissing -rootname ${rootname} -missingListVar $missingListVar"
    } else {
        APSSRSectorButtons .sbbut -parent $parent -rootname ${rootname} \
          -label $label -description "monitors" -orientation $orientation \
          -itemList $itemList -itemLabelList $itemLabelList \
          -packOption $packOption -missingList $missingList \
          -sectorControl $sectorControl \
          -includeWeights 1 -includeDespike 1 -missingListVar $missingListVar \
          -command "APSSRSectorUnsetMissing -rootname ${rootname} -missingList [list $missingList]"
    }
}

proc APSSRCorrectorCheckButtons {widget args} {
    set rootname ""
    set plane H
    set parent ""
    set orientation vertical
    set sectorControl 0
    set packOption "-side left"
    set missingListVar ""
    set missingList ""
    set noLabel 0
    set globalButtons 1
    APSStrictParseArguments {rootname plane parent orientation sectorControl packOption missingList noLabel missingListVar globalButtons}
    set plane [string toupper $plane]

    if $noLabel {
        set label ""
    } else {
        set label "$plane Correctors"
    }

    switch $plane {
        H {
            if ![string length $missingList] {
                set missingList {S1A:H3 S39B:H1 S40A:H3}
            }
            # pass in command string either missingList or missingListVar
            if [string length $missingListVar] {
                APSSRSectorButtons .shbut -parent $parent -rootname ${rootname} -globalButtons $globalButtons \
                  -label $label -description "horizontal correctors" \
                  -itemList {A:H1 A:H2 A:H3 A:H4 B:H4 B:H3 B:H2 B:H1 C:H1} \
                  -itemLabelList {A1 A2 A3 A4 B4 B3 B2 B1 C1} \
                  -sectorControl $sectorControl \
                  -missingList $missingList -missingListVar $missingListVar \
                  -orientation $orientation -packOption $packOption \
                  -command "APSSRSectorUnsetMissing -rootname ${rootname} -missingListVar $missingListVar"
            } else {
                APSSRSectorButtons .shbut -parent $parent -rootname ${rootname} -globalButtons $globalButtons \
                  -label $label -description "horizontal correctors" \
                  -itemList {A:H1 A:H2 A:H3 A:H4 B:H4 B:H3 B:H2 B:H1 C:H1} \
                  -itemLabelList {A1 A2 A3 A4 B4 B3 B2 B1 C1} \
                  -sectorControl $sectorControl \
                  -missingList $missingList -missingListVar $missingListVar \
                  -orientation $orientation -packOption $packOption \
                  -command "APSSRSectorUnsetMissing -rootname ${rootname} -missingList [list $missingList]"
            }
        }
        V {
            if ![string length $missingList] {
                set missingList {S1A:V3 S39B:V1 S40A:V3}
            }
            if [string length $missingListVar] {
                APSSRSectorButtons .svbut -parent $parent -rootname ${rootname} -globalButtons $globalButtons \
                  -label $label -description "vertical correctors" \
                  -itemList {A:V1 A:V2 A:V3 A:V4 B:V4 B:V3 B:V2 B:V1 C:V1} \
                  -itemLabelList {A1 A2 A3 A4 B4 B3 B2 B1 C1} \
                  -sectorControl $sectorControl \
                  -missingList $missingList -missingListVar $missingListVar \
                  -orientation $orientation  -packOption $packOption \
                  -command "APSSRSectorUnsetMissing -rootname ${rootname}  -missingListVar $missingListVar"
            } else {
                APSSRSectorButtons .svbut -parent $parent -rootname ${rootname} -globalButtons $globalButtons \
                  -label $label -description "vertical correctors" \
                  -itemList {A:V1 A:V2 A:V3 A:V4 B:V4 B:V3 B:V2 B:V1 C:V1} \
                  -itemLabelList {A1 A2 A3 A4 B4 B3 B2 B1 C1} \
                  -sectorControl $sectorControl \
                  -missingList $missingList -missingListVar $missingListVar \
                  -orientation $orientation  -packOption $packOption \
                  -command "APSSRSectorUnsetMissing -rootname ${rootname} -missingList [list $missingList]"
            }
        }
    }
}

proc APSSRSectorUnsetMissing {args} {
    set rootname ""
    set missingList ""
    set missingListVar ""
    set sectorList ""
    APSParseArguments {rootname missingList missingListVar sectorList}
    if [string length $missingListVar] {
        global $missingListVar
        set missingList [set $missingListVar]
    }
    global ${rootname}CBWidget
    foreach item $missingList {
        set nameFlag ${rootname}${item}
        global $nameFlag
        if {[info exists $nameFlag] && [set $nameFlag] != 0} {
            [set ${rootname}CBWidget($item)] invoke
        }
        set $nameFlag 0
    }
}

proc APSSRSectorButtonsClicked {args} {
    APSStrictParseArguments {widget var selectcolor}
    global $var
    if {[set $var]} {
        $widget configure -selectcolor $selectcolor
    } else {
        $widget configure -selectcolor \#d9d9d9
    }
}

proc APSSRSectorButtons {widget args} {
    global apsBackground
    set parent "" 
    set rootname ""
    set label "Unknown selections"
    set description "No description"
    set itemList ""
    set command ""
    set sectorCount 40
    set missingList ""
    set missingListVar ""
    set packOption "-side left"
    set orientation vertical
    set itemLabelList ""
    set includeWeights 0
    set includeDespike 0
    set onePerSector 0
    set sectorControl 0
    set sectorList ""
    set color0 ""
    set separateCountButton 0
    set globalButtons 1
    set allButtons 1
    APSStrictParseArguments {parent rootname label description itemList globalButtons \
				 command sectorCount onePerSector sectorControl \
				 missingList missingListVar packOption orientation \
				 itemLabelList includeWeights includeDespike sectorList color0 separateCountButton \
				 allButtons}

    global ${rootname}CBWidget ${rootname}BadBPMList ${rootname}SectorList
    if {![info exists ${rootname}BadBPMList]} {
        set ${rootname}BadBPMList ""
    }
    set monoList [exec sddsprocess /home/helios/oagData/sr/BPMStatus/config.sdds -pipe=out -match=col,ElectronicsType=Monopulse \
                    -nowarnings \
		      | sdds2stream -pipe -col=DeviceName]
    set nbList [exec sddsprocess /home/helios/oagData/sr/BPMStatus/config.sdds -pipe=out -match=col,ElectronicsType=Narrowband \
                  -nowarnings \
                  | sdds2stream -pipe -col=DeviceName]
    set FPGAList [exec sddsprocess /home/helios/oagData/sr/BPMStatus/config.sdds -pipe=out -match=col,ElectronicsType=FPGA \
                    -nowarnings \
                    | sdds2stream -pipe -col=DeviceName]
    set IDList [exec  sddsprocess /home/helios/oagData/sr/BPMStatus/config.sdds -pipe=out -match=col,ElectronicsType=Xray \
                  -match=col,DeviceName=*ID* -nowarnings \
                  | sdds2stream -pipe -col=DeviceName]
    set BMList [exec  sddsprocess /home/helios/oagData/sr/BPMStatus/config.sdds -pipe=out -match=col,ElectronicsType=Xray \
                  -match=col,DeviceName=*BM* -nowarnings \
                  | sdds2stream -pipe -col=DeviceName]
    set liberaList [exec  sddsprocess /home/helios/oagData/sr/BPMStatus/config.sdds -pipe=out -match=col,ElectronicsType=Libera \
                      -nowarnings \
		      | sdds2stream -pipe -col=DeviceName]
#    if ![string match *C0* [set ${rootname}BadBPMList]] {
#        for {set n 1} {$n<23} {incr n} {
#            lappend ${rootname}BadBPMList S${n}C:P0
#        }
#    }
    APSFrame $widget -parent $parent -label $label \
      -packOption $packOption

    set f1 $parent$widget.frame.f1
    set command1 ""
    set maxSectorLen 3
    if [llength $sectorList] {
        set sectorCount [llength $sectorList]
	foreach text $sectorList {
	    set len [string length $text]
	    if {$len>$maxSectorLen} {
		set maxSectorLen $len
	    }
	}
    }
    set ${rootname}SectorList $sectorList
    if [string match $orientation vertical] {
        frame $parent$widget.frame.f1
        eval pack $parent$widget.frame.f1 -side top
        # make vertical column for sector labels
        frame $f1.labels
        pack $f1.labels -side left -expand 1 -fill y
        for {set n $sectorCount} {$n>=0} {incr n -1} {
            if $n {
                if [llength $sectorList] {
                    set text "[lindex $sectorList [expr $n-1]] "
                } else {
                    set text [format "%3d " $n]
                }
                label $f1.labels.sector$n -text $text \
                  -borderwidth 1 -padx 0 -pady 0 -highlightthickness 0
                pack $f1.labels.sector$n -side bottom
            } else {
                if [llength $itemLabelList] {
                    label $f1.labels.sector$n -text "    " \
                      -borderwidth 1 -padx 0 -pady 0 -highlightthickness 0
                    pack $f1.labels.sector$n -side bottom
                }
            }
        }

        # make vertical columns for checkbuttons vs item name
        set index -1
        foreach item $itemList {
            incr index
            set f2 $f1.item$index
            frame $f2
            pack $f2 -side left
            for {set n $sectorCount} {$n>0} {incr n -1} {
		if [llength $sectorList] {
		    set name [lindex $sectorList [expr $n-1]]$item
		} else {
		    set name  S${n}$item
		}
		#set name S${n}$item
                set nameFlag ${rootname}$name
                global $nameFlag 
                if {![info exists $nameFlag]} {
                    set $nameFlag 1
                }
		
                # add default arguments to whatever command is being passed.
                if [string length $command] {
                    set command1 "$command -sector $n -item $item -nameFlag $nameFlag"
                }
		if ![string length $color0] {
		    if {[lsearch -exact $nbList $name]>=0} {
			set color  red
		    } elseif {[lsearch -exact $FPGAList $name]>=0} {
			set color yellow
		    } elseif {[lsearch -exact $monoList $name]>=0} {
			set color blue
		    } elseif [lsearch -exact $BMList $name]>=0 {
			set color "chartreuse"
		    } elseif [lsearch -exact $IDList $name]>=0 {
			set color "dark orange"
		    } elseif [lsearch -exact $liberaList $name]>=0 {
                        set color "violet"
                    } else {
			set color maroon
		    } 
		} else {
		    set color $color0
		}
                if {[set $nameFlag] == 1} {
                    set c $color
                } else {
                    set c \#d9d9d9
                }

                checkbutton $f2.sector$n -text "" -variable $nameFlag \
                  -borderwidth 1 -padx 0 -pady 0 -highlightthickness 0 -fg $color \
                  -command "APSSRSectorButtonsClicked -widget $f2.sector$n -var $nameFlag -selectcolor \"$color\" ; $command1" -selectcolor $c

                set ${rootname}CBWidget\($name\) $f2.sector$n
		
                if {[llength $missingList] && [lsearch $missingList $name]!=-1} {
                    $f2.sector$n configure -state disabled -indicatoron off -borderwidth 0 -pady 1 -padx 1
                } elseif {[llength [set ${rootname}BadBPMList]] && [lsearch [set ${rootname}BadBPMList] $name]!=-1} {
                    $f2.sector$n configure -state disabled -bg $apsBackground -borderwidth 1 -pady 0 -padx 0
                } else {
                    $f2.sector$n configure -state normal -indicatoron on -bg $apsBackground -borderwidth 1 -pady 0 -padx 0
                }
		if $displayOnly {
		    $f2.sector$n configure -state disabled 
		}
		if {0} {
                if [string compare $n$item 20V]==0 {
		    #disable the check button for B2C9V (which is sector 20) since it does not exist
		    set $nameFlag 0
		    $f2.sector$n configure -state disabled -indicatoron off -borderwidth 0 -pady 1 -padx 1
		}
		}
                pack $f2.sector$n -side bottom
                set apsContextHelp($f2.sector$n) $name
                if {$includeWeights || $includeDespike} {
                    set weightVar ${rootname}${name}Weight
                    set despikeVar ${rootname}${name}Despike
                    global $weightVar $despikeVar
                    if ![info exists $weightVar] {
                        set $weightVar 1
                    }
                    if ![info exists $despikeVar] {
                        if [regexp {(BM)|(ID)} $item] {
                            set $despikeVar 0
                        } else {
                            set $despikeVar 1
                        }
                    }
                    if {![llength $missingList] || [lsearch $missingList $name]==-1} {
                        bind $f2.sector$n <ButtonRelease-2> \
                          "APSSRConfigWeightDialog -weight $weightVar -despike $despikeVar -item $name"
                    }
                }
            }
            # item name label
            if [llength $itemLabelList] {
                set itemLabel [lindex $itemLabelList $index]
                label $f2.label -text [join [split [format %3s $itemLabel] ""] \n] \
                  -borderwidth 0 -padx 0 -pady 0 -highlightthickness 0
                pack $f2.label -side bottom
            }
        }
        if {$sectorControl} {
            set index [llength $itemList]
            set f2 $f1.item$index
            frame $f2
            pack $f2 -side left
            for {set n $sectorCount} {$n>0} {incr n -1} {
		if [llength $sectorList] {
		    set name [lindex $sectorList [expr $n-1]]${widget}
		    set sector1 [lindex $sectorList [expr $n-1]]
		} else {
		    set name S${n}${widget}
		    set sector1 S${n}
		}
                set togVar ${rootname}${name}
                global $togVar
                set $togVar 1
                checkbutton $f2.sector$n -text "" -variable $togVar \
                  -borderwidth 1 -padx 0 -pady 0 -highlightthickness 0 \
                  -command "APSSRItemTogglePosition -rootname $rootname -sector $sector1 -itemList [list $itemList] -missingList [list $missingList] -missingListVar \"$missingListVar\" -toggleVar $togVar"
                pack $f2.sector$n -in $f2 -side bottom
                set apsContextHelp($f2.sector$n) \
                  "Toggles all buttons in this sector on or off."
                
            }
            label $f2.label -text "A\nl\n\l" \
              -borderwidth 1 -padx 0 -pady 0 -highlightthickness 0
            pack $f2.label -side bottom
        }
    } else {
        # orientation horizontal
        frame $parent$widget.frame.f1
        pack $parent$widget.frame.f1 -side left
        if [llength $itemLabelList] {
            # make vertical column for labels using item names
            frame $f1.labels
            pack $f1.labels -side left -fill y -expand 1
            set f2 $f1.labels
            # labels for items
            if {$sectorControl} {
                set index [llength $itemList]
                label $f2.item$index -text All \
                  -borderwidth 1 -padx 0 -pady 0 -highlightthickness 0
                pack $f2.item$index -side bottom
            }
            for {set index [llength $itemLabelList]} {$index>0} {} {
                incr index -1
                label $f2.item$index -text [lindex $itemLabelList $index] \
                  -borderwidth 1 -padx 0 -pady 0 -highlightthickness 0
                pack $f2.item$index -side bottom 
            }
            # make vertical columns for checkbuttons vs sector number
            for {set n 1} {$n<=$sectorCount} {incr n} {
                # column for checkbuttons
                frame $f1.sector$n
                pack $f1.sector$n -side left
                set f2 $f1.sector$n
                # make sector buttons
                if {$sectorControl} {
                    set index [llength $itemList]
		    if [llength $sectorList] {
			set name [lindex $sectorList [expr $n-1]]${widget}
			set sector1 [lindex $sectorList [expr $n-1]]
		    } else {
			set name  S${n}${widget}
			set sector1 S${n}
		    }
                    set togVar ${rootname}${name}
                    global $togVar
                    set $togVar 1
                    checkbutton $f2.item$index -text "" -variable $togVar \
                      -borderwidth 1 -padx 0 -pady 0 -highlightthickness 0 \
                      -command "APSSRItemTogglePosition -rootname $rootname -sector $sector1 -itemList [list $itemList] -missingList [list $missingList] -missingListVar \"$missingListVar\" -toggleVar $togVar"
                    pack $f2.item$index -in $f2 -side bottom
                    set apsContextHelp($f2.item$index) \
                      "Toggles all buttons in this sector on or off."
                }
                for {set index [llength $itemList]} {$index>0} {} {
                    incr index -1
                    set item [lindex $itemList $index]
		    if [llength $sectorList] {
			set name [lindex $sectorList [expr $n-1]]$item
		    } else {
			set name  S${n}$item
		    }
                    #set name S${n}$item
                    set nameFlag ${rootname}$name
                    global $nameFlag
                    if {![info exists $nameFlag]} {
                        set $nameFlag 1
                    }
                    if [string length $command] {
                        set command1 "$command -sector $n -item $item -nameFlag $nameFlag"
                    }
		    if ![string length $color0] {
			if {[lsearch -exact $nbList $name]>=0} {
			    set color  red
			} elseif {[lsearch -exact $FPGAList $name]>=0} {
			    set color yellow
			} elseif {[lsearch -exact $monoList $name]>=0} {
			    set color blue
			} elseif [lsearch -exact $BMList $name]>=0 {
			    set color "chartreuse"
			} elseif [lsearch -exact $IDList $name]>=0 {
			    set color "dark orange"
			} else {
			    set color maroon
			}
		    } else {
			set color $color0
		    }
		    
                    if {[set $nameFlag] == 1} {
                        set c $color
                    } else {
                        set c \#d9d9d9
                    }

                    checkbutton $f2.item$index -text "" -variable $nameFlag \
                      -borderwidth 1 -padx 0 -pady 0 -highlightthickness 0 -fg $color \
                      -command "APSSRSectorButtonsClicked -widget $f2.item$index -var $nameFlag -selectcolor \"$color\" ; $command1" -selectcolor $c
                    set ${rootname}CBWidget\($name\) $f2.item$index
		    
		    if {[llength $missingList] && [lsearch $missingList $name]!=-1} {
			$f2.item$index configure -state disabled -indicatoron off -borderwidth 0 -pady 1 -padx 1
		    } elseif {[llength [set ${rootname}BadBPMList]] && [lsearch [set ${rootname}BadBPMList] $name]!=-1} {
			$f2.item$index configure -state disabled -bg $apsBackground -borderwidth 1 -pady 0 -padx 0
		    } else {
			$f2.item$index configure -state normal -indicatoron on -bg $apsBackground -borderwidth 1 -pady 0 -padx 0
		    }
		    if {0} {
		    if [string compare $n$item 20V]==0 {
			#disable the check button for B2C9V (which is sector 20) since it does not exist
			set $nameFlag 0
			$f2.item$index configure -state disabled -indicatoron off -borderwidth 0 -pady 1 -padx 1
		    }
		    }
                    pack $f2.item$index -side bottom
                    set apsContextHelp($f2.item$index) $name
                    if {$includeWeights || $includeDespike} {
                        set weightVar ${rootname}${name}Weight
                        set despikeVar ${rootname}${name}Despike
                        global $weightVar $despikeVar
                        if ![info exists $weightVar] {
                            set $weightVar 1
                        }
                        if ![info exists $despikeVar] {
                            if [regexp {(BM)|(ID)} $item] {
                                set $despikeVar 0
                            } else {
                                set $despikeVar 1
                            }
                        }
                        if {![llength $missingList] || [lsearch $missingList $name]==-1} {
                            bind $f2.item$index <ButtonRelease-2> \
                              "APSSRConfigWeightDialog -weight $weightVar -despike $despikeVar -item $name"
                        }
                    }
                }
                if [llength $sectorList] {
                    set text [lindex $sectorList [expr $n -1]]
		    set len [string length $text]
		    set n1 [expr $maxSectorLen - $len]
		    set text1 ""
		    for {set x 0} {$x<$n1} {incr x} {
			append text1 "\n"
		    }
		    for {set x 0} {$x<$len} {incr x} {
			append text1 "[format %s [string index $text $x]]"
			if {$x<[expr $len-1]} {
			    append text1 "\n"
			}
		    }
		    set text $text1
                } else {
                    if $n>9 {
                        set text [format "\n%1d\n%1d" [expr int($n/10)] [expr $n-int($n/10)*10]]
                    } else {
                        set text [format "\n\n%1d" $n]  
                    }
                }
                label $f2.label -text $text \
                  -borderwidth 0 -padx 0 -pady 0 -highlightthickness 0
               # if $n>9 {
                #     label $f2.label -text \
               #       [format "\n%1d\n%1d" [expr int($n/10)] [expr $n-int($n/10)*10]] \
                #      -borderwidth 0 -padx 0 -pady 0 -highlightthickness 0
               # } else {
               #     label $f2.label -text \
               #       [format "\n\n%1d" $n] \
                #      -borderwidth 0 -padx 0 -pady 0 -highlightthickness 0
                #}
                pack $f2.label -side bottom
            }
        }
    }
    # Position toggle buttons
    if $allButtons {
	APSSRSectorPositionButtons .frametog -parent $parent$widget.frame -sectorWidget $widget \
	    -rootname $rootname -sectorCount $sectorCount -sectorControl $sectorControl -sectorList $sectorList \
	    -description $description -itemList $itemList -missingList $missingList \
	    -missingListVar $missingListVar -orientation $orientation  -maxSectorLen $maxSectorLen
    }
    # Global buttons
    if $globalButtons {
	APSSRSectorGlobalButtons .frameButtonsSB -parent $parent$widget.frame  \
	    -rootname $rootname -sectorCount $sectorCount \
	    -description $description -itemList $itemList -missingList $missingList \
	    -missingListVar $missingListVar -orientation $orientation -sectorList $sectorList -separateCountButton $separateCountButton
    }
    
    APSSRSectorUnsetMissing -rootname $rootname -sectorCount $sectorCount \
      -missingList $missingList -missingListVar $missingListVar -sectorList $sectorList
}


proc APSSRSectorGlobalButtons {widget args} {
    set parent ""
    set rootname ""
    set sectorCount 40
    set description ""
    set itemList ""
    set missingList ""
    set missingListVar ""
    set orientation vertical
    set sectorList ""
    set separateCountButton 0
    APSStrictParseArguments {parent rootname sectorCount description itemList missingList orientation missingListVar sectorList separateCountButton}

    set f2 $parent$widget
    frame $f2
    if [string compare $orientation vertical]==0 {
        set side1 top
        set side2 left
    } else {
        set side1 left
        set side2 top
    }
    pack $f2 -side $side1
    APSButton .allon -parent $f2 -text "+All" \
	-command "APSSetSRSectorButtons -mode all-on -rootname $rootname -sectorCount $sectorCount -itemList [list $itemList] -missingList [list $missingList] -missingListVar \"$missingListVar\" -sectorList [list $sectorList]" \
      -size small -packOption "-side $side2" -contextHelp \
      "Sets all $description buttons on."
    APSButton .alloff -parent $f2 -text "-All" \
	-command "APSSetSRSectorButtons -mode all-off -rootname $rootname -sectorCount $sectorCount -itemList [list $itemList] -missingList [list $missingList] -missingListVar \"$missingListVar\" -sectorList [list $sectorList]" \
      -size small -packOption "-side $side2" -contextHelp \
      "Sets all $description buttons off."
    if !$separateCountButton {
	APSButton .count -parent $f2 -text "Count" -size small -packOption "-side $side2" -command \
	    "set ${rootname}ConfigStatus \"$description count is \[APSCountSRConfig -rootname $rootname -sectorCount $sectorCount -sectorList [list $sectorList] -itemList [list $itemList] -missingList [list $missingList] \]\"" \
      -contextHelp "Counts the number of $description buttons that are on."
    } else {
	#booster itemlist contains both bpm and correctors
	set bpmList ""
	set corrList ""
	foreach item $itemList {
	    if [regexp {P} $item] {
		lappend bpmList $item
	    } elseif {[regexp {H} $item] || [regexp {V} $item]} {
		lappend corrList $item
	    }
	}
	if {![llength $bpmList] || ![llength $corrList]} {
	    return -code error "No bpm or correctors provided, no need separate count button."
	}
	APSButton .count1 -parent $f2 -text "Count_bpm" -size small -packOption "-side $side2" -command \
	    "set ${rootname}ConfigStatus \"$description BPM count is \[APSCountSRConfig -rootname $rootname -sectorCount $sectorCount -sectorList [list $sectorList] -itemList [list $bpmList] -missingList [list $missingList] \]\"" \
      -contextHelp "Counts the number of bpm buttons that are on."
	APSButton .count2 -parent $f2 -text "Count_corr" -size small -packOption "-side $side2" -command \
	    "set ${rootname}ConfigStatus \"$description corrector count is \[APSCountSRConfig -rootname $rootname -sectorCount $sectorCount -sectorList [list $sectorList] -itemList [list $corrList] -missingList [list $missingList] \]\"" \
	    -contextHelp "Counts the number of corrector buttons that are on."
    }
}

proc APSSetSRSectorButtons {args} {
    set mode ""
    set rootname ""
    set sectorCount 40
    set itemList ""
    set missingList ""
    set missingListVar ""
    set sectorList ""
    APSStrictParseArguments {mode rootname sectorCount itemList missingList missingListVar sectorList}

    if [string length $missingListVar] {
        global $missingListVar
        set missingList [set $missingListVar]
    }
    switch $mode {
        all-on {
            set value 1
        }
        all-off {
            set value 0
        }
        default {
            return
        }
    }

    foreach item $itemList {
        set toggleVar ${rootname}S${item}
        global $toggleVar
        set $toggleVar $value
        APSSRSectorTogglePosition -item $item -rootname $rootname  -sectorList $sectorList \
          -sectorCount $sectorCount -missingList $missingList -toggleVar $toggleVar
    }
}

proc APSSRSectorPositionButtons {widget args} {
    set parent ""
    set description ""
    set itemList ""
    set rootname ""
    set sectorCount 40
    set missingList ""
    set missingListVar ""
    set orientation vertical
    set sectorControl 0
    set sectorWidget ""
    set sectorList ""
    set maxSectorLen ""
    APSStrictParseArguments {parent sectorWidget description itemList rootname sectorCount missingList missingListVar orientation sectorControl sectorList maxSectorLen}

    set f2 $parent$widget
    frame $f2
    if [string match $orientation vertical] {
        set side1 top
        set side2 left
    } else {
        set side1 left
        set side2 top
    }
    pack $f2 -side $side1

    if [string match $orientation vertical] {
        label $f2.label -text "All " \
          -borderwidth 1 -padx 0 -pady 0 -highlightthickness 0
    } else {
	set text ""
	if {$maxSectorLen>3} {
	    for {set i 0} {$i<[expr $maxSectorLen -3]} {incr i} {
		append text "\n"
	    }
	    append text "A\nl\nl"
	} else {
	    set text "A\nl\n\l"
	}
        label $f2.label -text $text \
          -borderwidth 1 -padx 0 -pady 0 -highlightthickness 0
    }
    pack $f2.label -side $side2
    
    foreach item $itemList {
        set togVar ${rootname}S${item}
        global $togVar
        if {![info exists $togVar]} {
            set $togVar 1
        }
        set w $f2.$togVar
        checkbutton $f2.$togVar -text "" -variable $togVar \
          -command "APSSRSectorTogglePosition -rootname $rootname -sectorCount $sectorCount -item $item -missingList [list $missingList] -missingListVar \"$missingListVar\" -toggleVar $togVar -sectorList \"$sectorList\"" \
          -borderwidth 1 -padx 0 -pady 0 -highlightthickness 0
        pack $f2.$togVar -in $f2 -side $side2
        set apsContextHelp($f2.$togVar) \
          "Toggles all $description in this position for all sectors on or off."
    }
    if {$sectorControl} {
        # if more than one frame of buttons is created, say one for
        # monitors and on for correctors, then this button in the two
        # frames will share the same variable.
        set widgetPartsList [split $parent .]
        set widgetParts [llength $widgetPartsList]
        set suffix [lindex $widgetPartsList [expr $widgetParts - 2]]
        set togVar ${rootname}S${suffix}
        global $togVar
        if {![info exists $togVar]} {
            set $togVar 1
        }
        set w $f2.$togVar
        if [string length $missingListVar] {
            set command "APSSRSectorsToggle -widget $sectorWidget -rootname $rootname -itemList [list $itemList] -missingList [list $missingList] -missingListVar $missingListVar -toggleVar $togVar -sectorList [list $sectorList]"
      
        } else {
            set command "APSSRSectorsToggle -widget $sectorWidget -rootname $rootname -itemList [list $itemList] -missingList [list $missingList] -toggleVar $togVar -sectorList [list $sectorList]"
        }
        checkbutton $f2.$togVar -text "" -variable $togVar \
          -command $command \
          -borderwidth 1 -padx 0 -pady 0 -highlightthickness 0
        pack $f2.$togVar -in $f2 -side $side2
        $f2.$togVar configure -state disable
       # set apsContextHelp($f2.$togVar) "Does nothing."
    }
}
proc APSSRSectorsToggle {args} {
    set rootname ""
    set sectorCount 40
    set itemList ""
    set missingList ""
    set missingListVar ""
    set toggleVar ""
    set widget ""
    set sectorList ""
    APSStrictParseArguments {widget rootname sectorCount itemList missingList toggleVar missingListVar sectorList}
    global $toggleVar
   
    for {set n 1} {$n<=$sectorCount} {incr n} {
	if [llength $sectorList] {
	    set name [lindex $sectorList [expr $n-1]]${widget}
	} else {
	    set name S${n}${widget}
	}
        set togVar ${rootname}${name}
        global $togVar
        set $togVar [set $toggleVar]
        if [string length $missingListVar] {
            global $missingListVar
            set missingList [set $missingListVar]
        }
    #    foreach item $itemList {
     #       set name S${n}${item}
      #      set nameFlag ${rootname}${name}
       #     global $nameFlag
        #    set $nameFlag [set $togVar]
        #}
    }
   # foreach item $itemList {
    #    set togVar ${rootname}S${item}
    #    global $togVar
     #   set $togVar [set $toggleVar]
   # }
   # APSSRSectorUnsetMissing -rootname $rootname -missingList $missingList
}
proc APSSRSectorTogglePosition {args} {
    set item ""
    set rootname ""
    set sectorCount 40
    set missingList ""
    set missingListVar ""
    set toggleVar ""
    set sectorList ""
    APSStrictParseArguments {item rootname sectorCount missingList toggleVar missingListVar sectorList}
    global $toggleVar ${rootname}CBWidget
    if [string length $missingListVar] {
        global $missingListVar
        set missingList [set $missingListVar]
    }
    for {set sector 1} {$sector<=$sectorCount} {incr sector} {
	if [llength $sectorList] {
	    set name [lindex $sectorList [expr $sector-1]]${item}
	} else {
	    set name S${sector}${item}
	}
        set nameFlag ${rootname}${name}
        global $nameFlag
#        set $nameFlag [set $toggleVar]
        if {[info exists $nameFlag]} {
            if {[set $nameFlag] != [set $toggleVar]} {
                [set ${rootname}CBWidget($name)] invoke
            }
        }
    }
    APSSRSectorUnsetMissing -rootname $rootname -missingList $missingList -sectorList $sectorList
}

proc APSSRItemTogglePosition {args} {
    # similar to APSSRSectorTogglePosition except the loop is over the
    # list of items rather than the list of sectors.
    set sector ""
    set itemList ""
    set rootname ""
    set missingList ""
    set missingListVar ""
    set toggleVar ""
    APSStrictParseArguments {sector itemList rootname missingList toggleVar missingListVar}
    global $toggleVar ${rootname}CBWidget
    if [string length $missingListVar] {
        global $missingListVar
        set missingList [set $missingListVar]
    }
   
    foreach item $itemList {
        set name ${sector}${item}
        set nameFlag ${rootname}${name}
        global $nameFlag
        #set $nameFlag [set $toggleVar]
        if {[set $nameFlag] != [set $toggleVar]} {
            [set ${rootname}CBWidget($name)] invoke
        }
    }
    APSSRSectorUnsetMissing -rootname $rootname -missingList $missingList
}

proc APSGetIDXRayBPMList {args} {
    set plane ""
    set sddsOutput ""
    APSStrictParseArguments {plane sddsOutput}
    set plane [string toupper $plane]
    set BPMDir /home/helios/oagData/sr/BPMStatus
    set teeCmd "cat "
    if [string length $sddsOutput] {
        set teeCmd "tee $sddsOutput "
    }
    switch $plane {
        H -
        V {
            if [catch {eval exec sddsprocess $BPMDir/config.sdds -pipe=out \
                         -filter=column,Nonexistent${plane},0,0 \
                         -match=col,DeviceName=*ID:P? -noWarning \
                         | $teeCmd \
                         | sdds2stream -pipe -column=DeviceName} bpmList] {
                return -code error "APSGetIDXRayBPMList: $bpmList"
            }
        }
        default {
            if [catch {eval exec sddsprocess $BPMDir/config.sdds -pipe=out \
                         -filter=column,NonexistentH,0,0 \
                         -filter=column,NonexistentV,0,0 \
                        -match=col,DeviceName=*ID:P? -noWarning \
                         | $teeCmd \
                         | sdds2stream -pipe -column=DeviceName} bpmList] {
                return -code error "APSGetIDXRayBPMList: $bpmList"
            }
        }
    }
    return $bpmList
}

proc APSGetIDXRayEqnList {args} {
    set plane ""
    APSParseArguments {plane}
    if ![string length $plane] {
        return -code error "APSGetIDXRayEqnList: Argument plane not specified."
    }
    set BPMDir /home/helios/oagData/sr/BPMStatus
    if [catch {exec sddsprocess $BPMDir/config.sdds -pipe=out \
                 -filter=column,Nonexistent[string toupper ${plane}],0,0 \
                 -match=col,DeviceName=*ID:P? -noWarning \
                 | sdds2stream -pipe \
                 -column=ResponseEquation[string toupper ${plane}]} bpmList] {
        return -code error "APSGetIDXRayBPMList: $bpmList"
    }
    return $bpmList
}

proc APSGetBMXRayBPMList {args} {
    set plane ""
    set sddsOutput ""
    # option okForDCOrbitCorrection works only when plane is specified.
    set okForDCOrbitCorrection 0
    APSStrictParseArguments {plane sddsOutput okForDCOrbitCorrection}
    set plane [string toupper $plane]
    set BPMDir /home/helios/oagData/sr/BPMStatus
    set teeCmd "cat "
    if [string length $sddsOutput] {
        set teeCmd "tee $sddsOutput "
    }
    set extraOption ""
    if $okForDCOrbitCorrection {
        set extraOption -filter=column,OkForDCOrbitCorrection${plane},1,1
    }
    switch $plane {
        H -
        V {
            if [catch {eval exec sddsprocess $BPMDir/config.sdds -pipe=out \
                         -filter=column,Nonexistent${plane},0,0 \
                         $extraOption \
                         -match=col,DeviceName=*BM:P? -noWarning \
                         | $teeCmd \
                         | sdds2stream -pipe -column=DeviceName} bpmList] {
                return -code error "APSGetBMXRayBPMList: $bpmList"
            }
        }
        default {
            if [catch {eval exec sddsprocess $BPMDir/config.sdds -pipe=out \
                         -filter=column,NonexistentV,0,0 \
                         -match=col,DeviceName=*BM:P? -noWarning \
                         | $teeCmd \
                         | sdds2stream -pipe -column=DeviceName} bpmList] {
                return -code error "APSGetBMXRayBPMList: $bpmList"
            }
        }
    }
    return $bpmList
}

proc APSGetBMXRayEqnList {args} {
    set plane ""
    APSParseArguments {plane}
    if ![string length $plane] {
        return -code error "APSGetBMXRayEqnList: Argument plane not specified."
    }
    set BPMDir /home/helios/oagData/sr/BPMStatus
    if [catch {exec sddsprocess $BPMDir/config.sdds -pipe=out \
                 -filter=column,Nonexistent[string toupper ${plane}],0,0 \
                 -match=col,DeviceName=*BM:P? -noWarning \
                 | sdds2stream -pipe \
                 -column=ResponseEquation[string toupper ${plane}]} bpmList] {
        return -code error "APSGetBMXRayBPMList: $bpmList"
    }
    return $bpmList
}

proc APSGetMissingBPMList {args} {
    set plane ""
    APSParseArguments {plane}
    set plane [string toupper $plane]
    set BPMDir /home/helios/oagData/sr/BPMStatus
    switch $plane {
        H -
        V {
            if [catch {exec sddsprocess $BPMDir/config.sdds -pipe=out \
                         -filter=col,Nonexistent$plane,1,1 -noWarning \
                         | sdds2stream -pipe -column=DeviceName} missingList] {
                return -code error "APSGetMissingBPMList: $missingList"
            }
        }
        default {
            if [catch {exec sddsprocess $BPMDir/config.sdds -pipe=out \
                         -filter=col,NonexistentH,1,1 \
                         -filter=col,NonexistentV,1,1 -noWarning \
                         | sdds2stream -pipe -column=DeviceName} missingList] {
                return -code error "APSGetMissingBPMList: $missingList"
            }
        }
    }
    #if [catch {file delete -force $tmpFile} result] {
    #    return -code error $result
    #}
    return $missingList
}

proc APSSRConfigWeightDialog {args} {
    set weight ""
    set despike ""
    set item ""
    APSStrictParseArguments {weight despike item}
    global $weight $despike
    set w .srConfigWeightDialog
    if [winfo exists $w] {destroy $w}
    APSDialogBox $w -name "Weight Dialog for $item" \
      -cancelCommand "set $weight [set $weight]; set $despike [set $despike]" 
    APSLabeledEntry .le -parent $w.userFrame -label "Weight: " \
      -textVariable $weight -type real -width 26 -contextHelp \
      "Enter the weight for $item.  Should be a positive real number."
    APSRadioButtonFrame .rb -parent $w.userFrame -label "Despike: " \
      -variable $despike -packOption "-side top" \
      -orientation horizontal -buttonList {N Y} -valueList {0 1} \
      -contextHelp \
      "Set despike flag for use in orbit correction. Xray BPMs usually have the despike flag unset (N) while SR RF bpms have despike flag set (Y)."
}


proc APSSRConfigPlaneOrbitCorrection {widget args} {
    set parent ""
    set plane h
    set rootname sconfig
    set fileFrame 1
    set buttonOrientation vertical
    set application DCOrbitCorrection
    set includeP0s 0
    set includeIDs 0
    set includeBMs 0
    APSStrictParseArguments {parent rootname fileFrame buttonOrientation \
                               plane application includeP0s includeIDs includeBMs}
    if [lsearch -exact [list h v rf] [set plane [string tolower $plane]]]==-1 {
        return -code error "APSSRConfigPlaneOrbitCorrection: unknown plane: $plane"
    }
    if [string match $plane rf] {
        set rfMode 1
        set plane h
    } else {
        set rfMode 0
    }
    set allowedApplications [list DCOrbitCorrection FastDCOrbitCorrection RTFeedback Steering]
    if [lsearch -exact $allowedApplications $application]==-1 {
        return -code error "APSSRConfigPlaneOrbitCorrection: unknown application: $application"
    }

    # Make a dedicated scrolled status area for this configuration.
    global ${rootname}ConfigStatus
    set ${rootname}ConfigStatus ""
    APSFrame $widget -parent $parent -label "" -packOption "-expand true -fill both"
    APSScrolledStatus .scrolled -parent $parent$widget.frame \
      -textVariable ${rootname}ConfigStatus \
      -width 85 -height 6 -lineLimit 1000 -label ""

    # Make the checkbutton grids
    if $rfMode {
        set widgetList [APSTabFrame .devtab -parent $parent$widget.frame -label "" \
                          -labelList "Monitors" -width 1050 -height 440 \
                            -packOption "-expand true -fill both" ]
    } else {
        set widgetList [APSTabFrame .devtab -parent $parent$widget.frame -label "" \
                          -labelList "Monitors Correctors" -width 1050 -height 440 \
                           -packOption "-expand true -fill both" ]
    }
    set missingBPMList \
      [APSSRGetBadOrbitDevices -plane $plane -device BPM -application $application]
    global ${rootname}BadBPMList 
    set ${rootname}BadBPMList $missingBPMList
    APSSRMonitorCheckButtons .smbut -parent [lindex $widgetList 0] -rootname $rootname \
      -orientation $buttonOrientation -BP5Only $rfMode \
      -includeP0s $includeP0s -includeIDs $includeIDs -includeBMs $includeBMs \
      -missingListVar ${rootname}BadBPMList \
      -noLabel 1 -packOption "-side top"

    global ${rootname}BadCORRECTORList
    if !$rfMode {
        set missingCorrList \
          [APSSRGetBadOrbitDevices -plane $plane -device corrector -application $application]
        set ${rootname}BadCORRECTORList $missingCorrList
        APSSRCorrectorCheckButtons .shbut -parent [lindex $widgetList 1] \
          -rootname ${rootname} -plane $plane \
          -orientation $buttonOrientation \
          -missingListVar ${rootname}BadCORRECTORList \
          -noLabel 1 -packOption "-side top"
    } else {
        set missingCorrList ""
        set ${rootname}BadCORRECTORList ""
    }

    if $fileFrame {
        # Make frames for read, write, etc. controls.  Will go into a widget swap frame.
        set frameWidth 800
        set frameHeight 450
        switch -regexp $rootname {
            {[hv]config} {
                set labelList [list Config... Read... Write... \
                                 {Generate controllaw files...} \
                                 {Generate compensation files...} ]
                set commandList [list {} {} \
                                   "APSSetVarAndUpdate ${rootname}WriteDir \"\"" \
                                   {} {}]
            }
            default {
                set labelList [list Config... Read... Write... \
                                 {Generate controllaw files...} ]
                set commandList [list {} {} \
                                   "APSSetVarAndUpdate ${rootname}WriteDir \"\"" \
                                   {}]
            }
        }
        
        set widgetList [APSTabFrame .fileops -parent $parent$widget.frame -label "" \
                          -labelList $labelList \
                          -commandList $commandList \
                          -height $frameHeight -width $frameWidth]
        pack $parent$widget.frame.fileops -side top
        # select the "Read..." tab
        #$parent$widget.frame.fileops.frame.tn select Read...
        $parent$widget.frame.fileops.frame.tn select 1
        set windex 0

        # Make lattice selection frame.
        global ${rootname}Lattice ${rootname}MainDir ${rootname}LatSubDir
        set ${rootname}Lattice default
        switch -regexp $rootname {
            rf {
                set ${rootname}MainDir /home/helios/oagData/sr/rfOrbitControllaw
            }
            fb {
                set ${rootname}MainDir /home/helios/oagData/sr/rtfeedback
            }
            fdc {
                # fast DC orbit correction
                set ${rootname}MainDir /home/helios/oagData/sr/fastOrbitControllaw
            }
            default {
                set ${rootname}MainDir /home/helios/oagData/sr/orbitControllaw
            }
        }
        set ${rootname}LatSubDir lattices
        set widget [lindex $widgetList $windex]
        incr windex
        APSFrame .lattice -parent $widget  -label "Lattice" \
          -width $frameWidth -height $frameHeight -contextHelp \
          "Use this frame to specify the lattice directory name and main directory area.  You may also change the default lattice from here."
        set w0 $widget.lattice.frame
        APSLabeledEntry .maindir -parent $w0 -label "Main directory: " \
          -textVariable ${rootname}MainDir -width 60 -contextHelp \
          "Enter the name of the main directory for the orbit correction system."
        APSFileSelectWidget .config -parent $w0 -label "Lattice: " \
          -pathVariableList [list ${rootname}MainDir ${rootname}LatSubDir] -mode directory -width 60 \
          -variable ${rootname}Lattice -incrementButtons 0 -contextHelp \
          "Enter the name of the lattice with which to work."
        #comment out this default button because it is dangerous to change the default lattice and it is not needed in this application, since we have another software for SR managers to change the default lattice. We had an occasion that it was pressed by a non-familiar person which caused the orbit correction failure and almost dumped the beam.
       # APSButton .default -parent $w0.config -text D -size small \
        #  -contextHelp "Makes the named file into the default lattice." \
          #  -command "APSMakeLink -confirm 1 -confirmMessage {Change default lattice? Are you sure?} -local 1 -log 1 -permissions 00775 -filename \[subst \$${rootname}MainDir/\$${rootname}LatSubDir/\$${rootname}Lattice\] -linkname \[subst \$${rootname}MainDir/\$${rootname}LatSubDir/default\]; set ${rootname}Lattice default"

        global ${rootname}refMatrices ${rootname}RefMatrix
        set ${rootname}RefMatrix $plane.default
        set ${rootname}refMatrices refMatrices
        APSFileSelectWidget .${plane}ref -parent $w0 -mode file \
          -label "Reference matrix: " -width 60 \
          -variable ${rootname}RefMatrix \
          -pathVariableList [list ${rootname}MainDir ${rootname}LatSubDir ${rootname}Lattice ${rootname}refMatrices] \
          -contextHelp \
          "Enter the name of the reference response matrix file for the $plane plane."

        #APSButton .default -parent $w0.${plane}ref -text D -size small \
         # -contextHelp "Makes the named file into the default $plane-plane reference matrix." \
          #-command "APSMakeLink -confirm 1 -confirmMessage {Change reference matrix? Are you sure?} -local 1 -log 1 -permissions 00664 -filename \[subst \$${rootname}MainDir/\$${rootname}LatSubDir/\$${rootname}Lattice/\$${rootname}refMatrices/\$${rootname}RefMatrix\] -linkname \[subst \$${rootname}MainDir/\$${rootname}LatSubDir/\$${rootname}Lattice/\$${rootname}refMatrices/$plane.default\]; set ${rootname}RefMatrix $plane.default"

        # Make configuration-read frame.
        global ${rootname}ReadFile ${rootname}ReadDescription ${rootname}Plane
        global ${rootname}FilterEnd1
        set ${rootname}Plane $plane
        set ${rootname}ReadFile $plane.default
        set ${rootname}ReadDescription ""
        set ${rootname}FilterEnd1 .*
        set widget [lindex $widgetList $windex]
        incr windex
        APSFrame .read -parent $widget -label "Read configuration" \
          -width $frameWidth -height $frameHeight -contextHelp \
          "Use this frame to read combined monitor and corrector configurations."
        set w0 $widget.read.frame
	APSLabeledOutput .lattice -parent $w0 -label "Lattice: " -width 60 \
          -textVariable ${rootname}Lattice -contextHelp \
          "Shows the lattice of the configuration for which this read widget applies."
        APSFileSelectWidget .file -parent $w0 -variable ${rootname}ReadFile -label "Config: " \
          -pathVariableList [list ${rootname}MainDir ${rootname}LatSubDir ${rootname}Lattice] \
          -mode directory -filterVariableList \
          [list ${rootname}Plane ${rootname}FilterEnd1] -width 60 \
          -incrementButtons 1 -contextHelp \
          "Enter the name of the configuration file to read."
        APSLabeledOutput .descrip -parent $w0 -label "Description: " -width 80 -packOption "-side top -anchor w" \
          -textVariable ${rootname}ReadDescription -contextHelp \
          "Shows the description of the last-read configuration file."
        APSFrame .bf -parent $w0 -relief flat -label "" -packOption "-side top -anchor w"
        set w1 $w0.bf.frame
        APSButton .io0 -parent $w1 -text Read(replace) -packOption "-side left -anchor n" -size small -command \
          "APSReadOrbitCorrectionConfig -rootname $rootname -filename \$${rootname}MainDir/\$${rootname}LatSubDir/\$${rootname}Lattice/\$${rootname}ReadFile/config -logic replace -includeP0s $includeP0s -includeIDs $includeIDs -includeBMs $includeBMs  -application $application" \
          -contextHelp "Press to read data to replace the existing configuration, using the named configuration file."
        APSButton .io1 -parent $w1 -text Read(or) -packOption "-side left -anchor n" -size small -command \
          "APSReadOrbitCorrectionConfig -rootname $rootname -filename \$${rootname}MainDir/\$${rootname}LatSubDir/\$${rootname}Lattice/\$${rootname}ReadFile/config -logic or -includeP0s $includeP0s -includeIDs $includeIDs -includeBMs $includeBMs" \
          -contextHelp "Press to read data to or with the existing configuration, using the named configuration file."
        APSButton .io2 -parent $w1 -text Read(and) -packOption "-side left -anchor n" -size small -command \
          "APSReadOrbitCorrectionConfig -rootname $rootname -filename \$${rootname}MainDir/\$${rootname}LatSubDir/\$${rootname}Lattice/\$${rootname}ReadFile/config -logic and -includeP0s $includeP0s -includeIDs $includeIDs -includeBMs $includeBMs" \
          -contextHelp "Press to read data to and with the existing configuration, using the named configuration file."
        APSButton .io3 -parent $w1 -text Read(not) -packOption "-side left -anchor n" -size small -command \
          "APSReadOrbitCorrectionConfig -rootname $rootname -filename \$${rootname}MainDir/\$${rootname}LatSubDir/\$${rootname}Lattice/\$${rootname}ReadFile/config -logic not -includeP0s $includeP0s -includeIDs $includeIDs -includeBMs $includeBMs" \
          -contextHelp "Press to read data specifying elements to turn off, using the named configuration file."
        APSButton .io4 -parent $w1 -text "Refresh good/bad" -packOption "-side left -anchor n" -size small -command \
            "APSRescanBadOrbitDevices -rootname $rootname -plane $plane -application $application"
        if [string compare DCOrbitCorrection $application]==0 {
            # add check buttons for switching allowable devices for the various modes of DC 
            # correction
            global ${rootname}BPMPVType ${rootname}CorrectorPVType 
            set ${rootname}BPMPVType plain
            set ${rootname}CorrectorPVType plain
            APSFrame .switch -parent $w0 -relief flat -label "" -packOption "-side top -anchor w"
            APSRadioButtonFrame .rbsw1 -parent $w0.switch.frame -orientation horizontal \
              -label "BPM PV type" -variable ${rootname}BPMPVType -packOption "-side left" \
              -buttonList "plain DP" -valueList "plain DP" -commandList \
              [list \
                 "APSRescanBadOrbitDevices -rootname $rootname -plane $plane -application $application" \
                 "APSRescanBadOrbitDevices -rootname $rootname -plane $plane -application $application"]
            APSRadioButtonFrame .rbsw2 -parent $w0.switch.frame -orientation horizontal \
              -label "Corrector PV type" -variable ${rootname}CorrectorPVType \
              -buttonList "plain dynamic DP" -valueList "plain dynamic DP" -packOption "-side left" \
              -commandList \
              [list \
                 "APSRescanBadOrbitDevices -rootname $rootname -plane $plane -application $application" \
                 "APSRescanBadOrbitDevices -rootname $rootname -plane $plane -application $application" \
                 "APSRescanBadOrbitDevices -rootname $rootname -plane $plane -application $application"]
        }

        # Make the write-configuration frame
        global ${rootname}WriteDir 
        set widget [lindex $widgetList $windex]
        incr windex
        APSFrame .write -parent $widget -label "Write configuration" \
          -width $frameWidth -height $frameHeight -contextHelp \
          "Use this frame to write combined monitor and corrector configurations."
        set w0 $widget.write.frame
	APSLabeledOutput .lattice -parent $w0 -label "Lattice: " -width 60 \
          -textVariable ${rootname}Lattice -contextHelp \
          "Shows the lattice of the configuration for which this write widget applies."
        #set ${rootname}WriteDir h.[clock format [clock seconds] -format %Y-%m%d].00
	set ${rootname}WriteDir ""
        APSFileSelectWidget .file -parent $w0 -variable ${rootname}WriteDir \
          -pathVariableList [list ${rootname}MainDir ${rootname}LatSubDir ${rootname}Lattice] \
          -label "Config: " -noSelect 0 -mode directory -incrementButtons 1 -width 60 -contextHelp \
          "Enter the name of the configuration to write." \
          -filterVariableList [list ${rootname}Plane ${rootname}FilterEnd1]
        APSButton .genname -parent $w0.file -text G -size small -command \
          "set ${rootname}WriteDir \[APSNextGenerationedName -directory \$${rootname}MainDir/\$${rootname}LatSubDir/\$${rootname}Lattice -name \$${rootname}Plane.\[clock format \[clock seconds\] -format %Y-%m%d\].00 -newFile 1 -separator .\]"
        APSLabeledEntry .descrip -parent $w0 -label "Description: " -width 60 \
          -textVariable ${rootname}WriteDescription -contextHelp \
          "Use to enter a description for the configuration to be written."
       
        APSButton .io -parent $w0 -text Write -size small -command \
          "APSSRWritePlaneOrbitCorrectionConfig -rootname $rootname -interactive 1 -filename \$${rootname}MainDir/\$${rootname}LatSubDir/\$${rootname}Lattice/\$${rootname}WriteDir/config -description \$${rootname}WriteDescription -includeP0s $includeP0s -includeIDs $includeIDs -includeBMs $includeBMs -BP5Only $rfMode -configName \$${rootname}WriteDir -plane $plane" \
          -contextHelp "Press to write data, using the named configuration file."
        
        # Make the frame for computing the matrix and installing it.
        global ${rootname}Plane ${rootname}SingValues ${rootname}SVDanalysis ${rootname}SetupOutputDir 
        global  ${rootname}DeleteModes ${rootname}TikhonovSVN ${rootname}TikhonovBeta ${rootname}TikhonovFilter ${rootname}TikhonovType
        set widget [lindex $widgetList $windex]
        incr windex
        APSFrame .comp -parent $widget -label "Compute matrix" \
          -width $frameWidth -height $frameHeight -contextHelp \
          "Use this frame to generate the matrix for orbit correction from an existing configuration."
        set w0 $widget.comp.frame
        APSLabeledOutput .lattice -parent $w0 -label "Lattice: " -width 60 \
          -textVariable ${rootname}Lattice -contextHelp \
          "Shows the lattice of the configuration for which this generate widget applies."
        set ${rootname}SingValues 320
        set ${rootname}SVDanalysis 0
        set ${rootname}DeleteModes ""
	set ${rootname}TikhonovFilter 0
	set ${rootname}TikhonovSVN 0
	set ${rootname}TikhonovBeta 0
	set ${rootname}TikhonovType SVN
        APSFileSelectWidget .file -parent $w0 -variable ${rootname}WriteDir \
          -pathVariableList [list ${rootname}MainDir ${rootname}LatSubDir ${rootname}Lattice] -filter "h.* v.*" \
          -label "Config: " -noSelect 0 -mode directory -incrementButtons 1 -width 60 -contextHelp \
          "Enter the name of the configuration to use." \
          -filterVariableList [list ${rootname}Plane ${rootname}FilterEnd1] 
        APSButton .genname -parent $w0.file -text G -size small -command \
          "set ${rootname}WriteDir \[APSNextGenerationedName -directory \$${rootname}MainDir/\$${rootname}LatSubDir/\$${rootname}Lattice -name \$${rootname}Plane.\[clock format \[clock seconds\] -format %Y-%m%d\].00 -newFile 1 -separator .\]"

        if $rfMode {
            global ${rootname}BPMPVSuffix
            set ${rootname}BPMPVSuffix msAve
            
            APSRadioButtonFrame .pvsuffix -parent $w0 -label "bpm PV type:" \
              -variable ${rootname}BPMPVSuffix -valueList {ms msAve mswAve} -buttonList {ms msAve mswAve} -orientation horizontal \
              -contextHelp "select the memory/scanner PV type (bpm data type) for rf/p5 controllaw."
            
        }
        frame $w0.f1 
        pack $w0.f1 -fill x
        APSLabeledEntry .le1 -parent $w0.f1 -packOption "-side left" \
          -textVariable ${rootname}SingValues \
          -label "Number of singular values: " -width 8 -contextHelp \
          "Enter the number of singular values to keep."
        if {0} {
        APSRadioButtonFrame .rb2 -parent $w0.f1 -packOption "-side left" \
          -label "SVD analysis: " \
          -variable ${rootname}SVDanalysis -buttonList {N Y} -valueList {0 1} \
          -orientation horizontal -contextHelp \
          "Select \"No\" for immediate calculation of the inverse response matrix using \
 the list of singular values in the entry box \"Vectors to remove\". If the list \
 in \"Vectors to remove\" is empty, then the inverse response matrix (file irm) \
 is calculated as usual. \n\nSelect \"Yes\" to modify the behavior of the \"Compute\" button.\
 The \"Compute\" button will produce plots of the orthogonal vectors of the response \
 matrix. Once the tksddsplot plot has finished loading all the \
 vectors, browse through the plot frame with the \"n\" or \"p\" keys. \
 Select \"No\" in the bottom of tksddsplot widget for vectors that you want \
 to eliminate. After you close the plot, the list of vectors will be listed in \
 the \"Vectors to remove\" entry box. There is no inverse matrix file for \
 orbit correction produced at this point. The next step is to switch the analysis \
 to \"No\" and press compute again. \n\nSelecting \"No\" after a delete list is created\
 in the \"Vectors to remove\", will create the inverse matrix for orbit correction \
 with the vectors selected removed."
        }
        if !$rfMode {
            APSButton .svd -parent $w0.f1 -packOption "-side left" -text "SVD Analysis" -size small \
            -command "APSSRGenerateOrbCorrFiles -rootname $rootname -generate 1 -configFile \$${rootname}MainDir/\$${rootname}LatSubDir/\$${rootname}Lattice/\$${rootname}WriteDir/config -plane \$${rootname}Plane -referenceMatrix \$${rootname}MainDir/\$${rootname}LatSubDir/\$${rootname}Lattice/refMatrices/\$${rootname}RefMatrix -outputRoot \$${rootname}MainDir/\$${rootname}LatSubDir/\$${rootname}Lattice/\$${rootname}WriteDir/ -singularValues \$${rootname}SingValues -SVDanalysis 1" \
            -contextHelp "produce plots of the orthogonal vectors of the response \
                          matrix. Once the tksddsplot plot has finished loading all the \
                          vectors, browse through the plot frame with the \"n\" or \"p\" keys. \
                          Select \"No\" in the bottom of tksddsplot widget for vectors that you want \
                          to eliminate. After you close the plot, the list of vectors will be listed in \
                          the \"Vectors to remove\" entry box."
            APSButton .gen -parent $w0.f1 -text Compute -size small -packOption "-side left" -command \
              "APSSRGenerateOrbCorrFiles -rootname $rootname -generate 1 -configFile \$${rootname}MainDir/\$${rootname}LatSubDir/\$${rootname}Lattice/\$${rootname}WriteDir/config -plane \$${rootname}Plane -referenceMatrix \$${rootname}MainDir/\$${rootname}LatSubDir/\$${rootname}Lattice/refMatrices/\$${rootname}RefMatrix -outputRoot \$${rootname}MainDir/\$${rootname}LatSubDir/\$${rootname}Lattice/\$${rootname}WriteDir/ -singularValues \$${rootname}SingValues -SVDanalysis 0 -tikhonovFilter \$${rootname}TikhonovFilter -tikhonovSVN \$${rootname}TikhonovSVN -tikhonovBeta \$${rootname}TikhonovBeta -tikhonovType \$${rootname}TikhonovType"
        } else {
            
            APSButton .svd -parent $w0.f1 -packOption "-side left" -text "SVD Analysis"  -size small \
              -command "APSSRFreqGenerateOrbCorrFiles -rootname $rootname -generate 1 -configFile \$${rootname}MainDir/\$${rootname}LatSubDir/\$${rootname}Lattice/\$${rootname}WriteDir/config -plane \$${rootname}Plane -referenceMatrix \$${rootname}MainDir/\$${rootname}LatSubDir/\$${rootname}Lattice/refMatrices/\$${rootname}RefMatrix -outputRoot \$${rootname}MainDir/\$${rootname}LatSubDir/\$${rootname}Lattice/\$${rootname}WriteDir/ -singularValues \$${rootname}SingValues -SVDanalysis 1 -bpmSuffix [set ${rootname}BPMPVSuffix]" \
            -contextHelp "produce plots of the orthogonal vectors of the response \
                          matrix. Once the tksddsplot plot has finished loading all the \
                          vectors, browse through the plot frame with the \"n\" or \"p\" keys. \
                          Select \"No\" in the bottom of tksddsplot widget for vectors that you want \
                          to eliminate. After you close the plot, the list of vectors will be listed in \
                          the \"Vectors to remove\" entry box."
            APSButton .gen -parent $w0.f1 -text Compute -size small -packOption "-side left" -command \
              "APSSRFreqGenerateOrbCorrFiles -rootname $rootname -generate 1 -configFile \$${rootname}MainDir/\$${rootname}LatSubDir/\$${rootname}Lattice/\$${rootname}WriteDir/config -plane \$${rootname}Plane -referenceMatrix \$${rootname}MainDir/\$${rootname}LatSubDir/\$${rootname}Lattice/refMatrices/\$${rootname}RefMatrix -outputRoot \$${rootname}MainDir/\$${rootname}LatSubDir/\$${rootname}Lattice/\$${rootname}WriteDir/ -singularValues \$${rootname}SingValues -SVDanalysis 0  -bpmSuffix [set ${rootname}BPMPVSuffix] -tikhonovFilter \$${rootname}TikhonovFilter -tikhonovSVN \$${rootname}TikhonovSVN -tikhonovBeta \$${rootname}TikhonovBeta -tikhonovType \$${rootname}TikhonovType"
        }
        APSButton .default -parent $w0.f1 -text "Make Default" -size small -packOption "-side left" \
          -contextHelp "Makes the named configuration into the default corrector configuration for chosen plane." \
          -command "APSSRInstallOrbCorrFiles -rootname $rootname -application $application"
        APSLabeledEntry .deletemodes -parent $w0 -textVariable ${rootname}DeleteModes \
          -label "Mode to delete: " \
          -contextHelp "Enter the list of vectors to remove from the matrix. A list is created when an analysis is requested." -width 80
	
	APSRadioButtonFrame .tik -parent $w0 -label "Use tikhonov filter?" -buttonList {Yes No} \
	    -valueList {1 0} -variable ${rootname}TikhonovFilter -orientation horizontal
	APSRadioButtonEntryFrame .par -parent $w0.tik -orientation horizontal -label "Tikhonov filter type:"  \
	    -variable ${rootname}TikhonovType -buttonList {SVN_Number Beta} -orientation horizontal \
	    -valueList {SVN Beta} -commandList [list "set ${rootname}TikhonovBeta 0" "set ${rootname}TikhonovSVN 0"] \
	    -entryVariableList [list ${rootname}TikhonovSVN ${rootname}TikhonovBeta] \
	    -entryWidth 10
	if {0} {
	APSLabeledEntryFrame .alpha -parent $w0.tik   -orientation horizontal \
	    -label "  Tikhonov parameters: SVN/Beta:" -variableList [list ${rootname}TikhonovSVN ${rootname}TikhonovBeta] -width 15 \
	    -contextHelp "provide the SVN number or beta (fractional alpha) of the tikhonov filter, the singular value of the provided SVN number will be used as alpha of the tikhonov filter."
	}
        if {$windex == [llength $widgetList]} return
        set widget [lindex $widgetList $windex]
        incr windex
        APSFrame .compensation -parent $widget -label "Compute feedforward matrix" \
          -width $frameWidth -height $frameHeight -contextHelp \
          "Use this frame to generate the feedforward matrix for orbit correction from existing configurations in DC correction and FB correction. The feedforward matrix is composed of the DC reference matrix with DC correctors selected and RT bpms selected. One would get a 160 bpm x 80 corrector matrix typically."
        set w0 $widget.compensation.frame
        APSLabeledOutput .lattice -parent $w0 -label "Lattice: " -width 60 \
          -textVariable ${rootname}Lattice -contextHelp \
          "Shows the lattice of the configuration for which this generate widget applies."
# singular values not relevant anymore for feedforward matrix.
#        set ${rootname}SingValues 320
#        set ${rootname}SVDanalysis 0
        APSFileSelectWidget .file1 -parent $w0 -variable ${rootname}WriteDir \
          -pathVariableList [list ${rootname}MainDir ${rootname}LatSubDir ${rootname}Lattice] -filter "h.* v.*" \
          -label "DC Config: " -noSelect 0 -mode directory -incrementButtons 1 \
          -width 60 -contextHelp \
          "Enter the name of the configuration to use." \
          -filterVariableList [list ${rootname}Plane ${rootname}FilterEnd1] 
        APSButton .genname -parent $w0.file1 -text G -size small -command \
          "set ${rootname}WriteDir \[APSNextGenerationedName -directory \$${rootname}MainDir/\$${rootname}LatSubDir/\$${rootname}Lattice -name \$${rootname}Plane.\[clock format \[clock seconds\] -format %Y-%m%d\].00 -newFile 1 -separator .\]"

        # select corresponding compensation rootname as hfbconfig or vfbconfig for the
        # appropriate rootname. Fast DC orbit corrections uses the same compensation
        # as regular DC correction.
        switch $rootname {
            hfdcconfig -
            hconfig {set rootnameComp hfbconfig}
            vfdcconfig -
            vconfig {set rootnameComp vfbconfig}
            default {set rootnameComp $rootname}
        }
        # need to assign the feedback main directory in both DC orbit correction
        # because the variables [hv]fbconfigMainDir are used in the FF compensation.
        global ${rootnameComp}MainDir ${rootnameComp}Plane \
          ${rootnameComp}FilterEnd1 ${rootnameComp}LatSubDir \
          ${rootnameComp}Lattice ${rootnameComp}RTDir
        set ${rootnameComp}MainDir /home/helios/oagData/sr/rtfeedback
        set ${rootnameComp}Plane $plane
        set ${rootnameComp}FilterEnd1 .*
        set ${rootnameComp}LatSubDir lattices
        set ${rootnameComp}Lattice default
        set ${rootnameComp}RTDir $plane.default

        APSFileSelectWidget .file2 -parent $w0 -variable ${rootnameComp}RTDir \
          -pathVariableList [list ${rootnameComp}MainDir ${rootnameComp}LatSubDir ${rootnameComp}Lattice] -filter "h.* v.*" \
          -label "RT Config: " -noSelect 0 -mode directory -incrementButtons 1 \
          -width 60 -contextHelp \
          "Enter the name of the configuration to use. Note that the configuration is taken from the feedback configuration area of the appropriate plane." \
          -filterVariableList [list ${rootnameComp}Plane ${rootnameComp}FilterEnd1] 
        APSButton .genname -parent $w0.file2 -text G -size small -command \
          "set ${rootnameComp}RTDir \[APSNextGenerationedName -directory \$${rootnameComp}MainDir/\$${rootnameComp}LatSubDir/\$${rootnameComp}Lattice -name \$${rootnameComp}Plane.\[clock format \[clock seconds\] -format %Y-%m%d\].00 -newFile 1 -separator .\]"

        frame $w0.f1 
        pack $w0.f1 -fill x
        APSButton .gen -parent $w0.f1 -text Compute -size small -packOption "-side left" -command \
          "APSSRGenerateOrbCorrFiles -rootname $rootname -generate 1 -configFile \$${rootname}MainDir/\$${rootname}LatSubDir/\$${rootname}Lattice/\$${rootname}WriteDir/config -plane \$${rootname}Plane -referenceMatrix \$${rootname}MainDir/\$${rootname}LatSubDir/\$${rootname}Lattice/refMatrices/\$${rootname}RefMatrix -outputRoot \$${rootname}MainDir/\$${rootname}LatSubDir/\$${rootname}Lattice/\$${rootname}WriteDir/ -singularValues \$${rootname}SingValues -SVDanalysis \$${rootname}SVDanalysis -compensationConfigFile \$${rootnameComp}MainDir/\$${rootnameComp}LatSubDir/\$${rootnameComp}Lattice/\$${rootnameComp}RTDir/config -tikhonovFilter \$${rootname}TikhonovFilter -tikhonovSVN \$${rootname}TikhonovSVN -tikhonovBeta \$${rootname}TikhonovBeta -tikhonovType \$${rootname}TikhonovType"
        APSButton .default -parent $w0.f1 -text "Make Default" -size small -packOption "-side left" \
          -contextHelp "Makes the named configuration into the default corrector configuration for chosen plane." \
          -command "APSSRInstallOrbCorrFiles -rootname $rootname -application $application"

    }
}

proc APSSRWritePlaneOrbitCorrectionConfig {args} {
    set rootname ""
    set filename ""
    set plane h
    set description ""
    set interactive 0
    set includeP0s 0
    set includeIDs 0
    set includeBMs 0
    set BP5Only 0
    set configName ""
    set booster 0
    set sectorCount 40
    set sectorList ""
    #booster=1 for writing booster configuration
    APSStrictParseArguments {rootname filename description interactive includeP0s \
                               includeIDs includeBMs configName  \
                               plane BP5Only booster sectorCount sectorList}

    if [lsearch -exact [list h v] [set plane [string tolower $plane]]]==-1 {
        return -code error "APSSRWritePlaneOrbitCorrectionConfig: invalid plane: $plane"
    }
    
    if ![string length [string trim $configName]] {
        return -code error "APSSRWritePlaneOrbitCorrectionConfig: supply a configuration name"
    }
    if ![string match $plane.* $configName] {
        if !$interactive {
            return -code error "APSSRWritePlaneOrbitCorrectionConfig: configuration name should be $plane.*"
        }
        if [APSMultipleChoice [APSUniqueName .] \
              -question "Configuration name doesn't match the pattern $plane.*, which may cause problems.  What do you want to do?" \
              -labelList [list "Abort (recommended)" "Continue"] \
              -returnList {1 0}] {
            return 
        }
    }

    set path [file dirname $filename]
    set pathPart [file tail $path]

    global ${rootname}BPMPVType ${rootname}CorrectorPVType
    if ![info exists ${rootname}BPMPVType] {
        set ${rootname}BPMPVType plain
        set ${rootname}CorrectorPVType plain
    }
    if $booster {
        set BPMList [list P1 P2]
        switch $plane {
            h {
                set corrList H
            }
            v {
                set corrList V
            }
            default {
                return -code error "APSSRWritePlaneOrbitCorrectionConfig: no such plane: $plane"
            }
        }
	if ![llength $sectorList] {
	    set sectorList ""
	    for {set b 1} {$b<5} {incr b} {
		for {set c 0} {$c<10} {incr c} {
		    lappend sectorList B${b}C$c
		}
	    }
	}
	set sectorCount [llength $sectorList]
        if $interactive {
            set corCount [APSCountSRConfig -rootname $rootname -itemList $corrList -sectorCount $sectorCount -sectorList $sectorList]
            set confirmQuery ""
            set confirm 0
            if {!$corCount} {
                set confirm 1
                append confirmQuery "\nNo correctors chosen."
            }
            if [APSCountSRConfig -rootname $rootname -itemList $BPMList -sectorCount $sectorCount -sectorList $sectorList]==0 {
                set confirm 1
                append confirmQuery "\nNo monitors chosen."
            }
            if {$confirm &&
                [APSMultipleChoice [APSUniqueName .] -question "Possible problem: $confirmQuery" \
                   -labelList {"Cancel (recommended)" Continue} -returnList {0 1}]==0} {
                return
            }
        }
        
        if ![file exists $path] {
            exec mkdir $path
            #catch {exec setfacl -m mask:rwx $path}
        } else {
            if {$interactive && \
                  [APSMultipleChoice [APSUniqueName .] -question "That configuration exists.  Overwrite?" \
                     -labelList {Yes No} -returnList {1 0}]==0} {
                return
            }
            set filesToDelete [glob -nocomplain $path/*]
            if [llength $filesToDelete] {
                if [catch {eval file delete -force -- $filesToDelete} result] {
                    return -code error "APSSRWritePlaneOrbitCorrectionConfig: $result"
                }
            }
        }
        APSWriteSRConfig -rootname $rootname -filename $filename -sectorList $sectorList \
          -nameTypeList {Monitor Corrector} -interactive $interactive \
          -PVTypeList [list [set ${rootname}BPMPVType]  [set ${rootname}CorrectorPVType]] \
          -suffixLists [list $BPMList $corrList] \
          -description $description -sectorCount $sectorCount -booster $booster
        catch {exec sddscollapse $filename $filename.collapsed}
        return
    }
    if $BP5Only {
        set BPMList [list A:P1 A:P2 A:P3 A:P4 B:P5 B:P4 B:P3 B:P2 B:P1]
        if ![file exists $path] {
            exec  mkdir $path
            #catch {exec setfacl -m mask:rwx $path}
        } else {
            if {$interactive && \
                  [APSMultipleChoice [APSUniqueName .] -question "That configuration exists.  Overwrite?" \
                     -labelList {Yes No} -returnList {1 0}]==0} {
                return
            }
            set filesToDelete [glob -nocomplain $path/*]
            if [llength $filesToDelete] {
                if [catch {eval file delete -force -- $filesToDelete} result] {
                    return -code error "APSSRWriteOrbitCorrectionConfig: $result"
                }
            }
        }
        APSWriteSRConfig -rootname $rootname -filename $filename \
          -nameTypeList Monitor -interactive $interactive \
          -PVTypeList [set ${rootname}BPMPVType] \
          -suffixLists [list $BPMList] -description $description
    } else {
        set BPMList [list A:P1 A:P2 A:P3 A:P4 B:P5 B:P4 B:P3 B:P2 B:P1]
        if $includeP0s {
            set BPMList [concat A:P0 $BPMList B:P0 C:P0]
        }
        if $includeIDs {
            set BPMList [concat $BPMList ID:P1 ID:P2]
        }
        if $includeBMs {
            set BPMList [concat $BPMList BM:P1 BM:P2]
        }
        switch $plane {
            h {
                set corrList {A:H1 A:H2 A:H3 A:H4 B:H4 B:H3 B:H2 B:H1 C:H1}
            }
            v {
                set corrList {A:V1 A:V2 A:V3 A:V4 B:V4 B:V3 B:V2 B:V1 C:V1}
            }
            default {
                return -code error "APSSRWritePlaneOrbitCorrectionConfig: no such plane: $plane"
            }
        }
        if $interactive {
            set corCount [APSCountSRConfig -rootname $rootname -itemList $corrList]
            set confirmQuery ""
            set confirm 0
            if {!$corCount} {
                set confirm 1
                append confirmQuery "\nNo correctors chosen."
            }
            if [APSCountSRConfig -rootname $rootname -itemList $BPMList]==0 {
                set confirm 1
                append confirmQuery "\nNo monitors chosen."
            }
            if {$confirm &&
                [APSMultipleChoice [APSUniqueName .] -question "Possible problem: $confirmQuery" \
                   -labelList {"Cancel (recommended)" Continue} -returnList {0 1}]==0} {
                return
            }
        }
        
        if ![file exists $path] {
            exec mkdir $path
            #catch {exec setfacl -m mask:rwx $path}
        } else {
            if {$interactive && \
                  [APSMultipleChoice [APSUniqueName .] -question "That configuration exists.  Overwrite?" \
                     -labelList {Yes No} -returnList {1 0}]==0} {
                return
            }
            set filesToDelete [glob -nocomplain $path/*]
            if [llength $filesToDelete] {
                if [catch {eval file delete -force -- $filesToDelete} result] {
                    return -code error "APSSRWriteOrbitCorrectionConfig: $result"
                }
            }
        }
        APSWriteSRConfig -rootname $rootname -filename $filename \
          -nameTypeList {Monitor Corrector} -interactive $interactive \
          -PVTypeList [list [set ${rootname}BPMPVType]  [set ${rootname}CorrectorPVType]] \
          -suffixLists [list $BPMList $corrList] \
          -description $description
    }
    catch {exec sddscollapse $filename $filename.collapsed}
}

proc APSSRGetBadOrbitDevices {args} {
    set plane h 
    set device corrector
    set application DCOrbitCorrection
    APSStrictParseArguments {plane application device}
    set plane [string toupper $plane]
    set device [string toupper $device]

    if [lsearch -exact [list H V] $plane]==-1 {
        return -code error "APSSRGetBadOrbitDevices: bad plane: $plane"
    }
    set allowedApplications [list DCOrbitCorrection FastDCOrbitCorrection RTFeedback Steering]
    if [lsearch -exact $allowedApplications $application]==-1 {
        return -code error "APSSRGetBadOrbitDevices: bad application: $application"
    }
    switch $device {
        CORRECTOR {
            set configFile /home/helios/oagData/sr/${plane}CorrectorStatus/config.sdds
        }
        BPM {
            set configFile /home/helios/oagData/sr/BPMStatus/config.sdds
            set application ${application}$plane
        }
        default {
            return -code error "APSSRGetBadOrbitDevices: bad device: $device"
        }
    }
    if ![file exists $configFile] {
        return -code error "APSSRGetBadOrbitDevices: not found: $configFile"
    }
    if [catch {sdds load $configFile configData} result] {
        return -code error "APSSRGetBadOrbitDevices: $result"
    }
    set deviceName [lindex $configData(Column.DeviceName) 0]
    if [lsearch -exact $configData(ColumnNames) Nonexistent$plane]==-1 {
        set deviceNonexistent [lindex $configData(Column.Nonexistent) 0]
    } else {
        set deviceNonexistent [lindex $configData(Column.Nonexistent$plane) 0]
    }
    set deviceOk [lindex $configData(Column.OkFor${application}) 0]
    set badList ""
    foreach device $deviceName nonexistent $deviceNonexistent ok $deviceOk {
        if {$nonexistent || !$ok} {
            lappend badList $device
        }
    }
    return $badList
}

proc APSRescanBadOrbitDevices {args} {
    set plane h
    set rootname ""
    set application DCOrbitCorrection
    set booster 0
    APSStrictParseArguments {plane rootname application booster}
    global ${rootname}BPMPVType ${rootname}CorrectorPVType apsBackground
    if ![info exists ${rootname}BPMPVType] {
        set ${rootname}BPMPVType plain
        set ${rootname}CorrectorPVType plain
    }
    set plane [string toupper $plane]
    if [lsearch -exact [list H V] $plane]==-1 {
        return -code error "APSRescanBadOrbitDevices: bad plane: $plane"
    }
    set allowedApplications [list DCOrbitCorrection FastDCOrbitCorrection RTFeedback Steering]
    if [lsearch -exact $allowedApplications $application]==-1 {
        return -code error "APSRescanBadOrbitDevices: bad application: $application"
    }

    foreach deviceType {BPM CORRECTOR} {
        switch $deviceType {
            CORRECTOR {
                set configFile /home/helios/oagData/sr/${plane}CorrectorStatus/config.sdds
                set application0 ${application}
                if {[string compare $application DCOrbitCorrection]==0 && \
                      [lsearch -exact [list dynamic DP] [set ${rootname}CorrectorPVType]]!=-1} {
                    set application0 Fast$application0
                }
            }
            BPM {
		if !$booster {
		    set configFile /home/helios/oagData/sr/BPMStatus/config.sdds
		} else {
		    set configFile /home/helios/oagData/booster/BPMStatus/config.sdds
		}
                set application0 ${application}$plane
                if {[string compare [set ${rootname}BPMPVType] DP]==0 && \
                      [string compare $application DCOrbitCorrection]==0} {
                    set application0 Fast$application0
                }
            }
        }
        if ![file exists $configFile] {
            return -code error "APSRescanBadOrbitDevices: not found: $configFile"
        }
        if [catch {sdds load $configFile configData} result] {
            return -code error "APSRescanBadOrbitDevices: $result"
        }
        set deviceName [lindex $configData(Column.DeviceName) 0]
        if [lsearch -exact $configData(ColumnNames) Nonexistent$plane]==-1 {
            set deviceNonexistent [lindex $configData(Column.Nonexistent) 0]
        } else {
            set deviceNonexistent [lindex $configData(Column.Nonexistent$plane) 0]
        }
        set deviceOk [lindex $configData(Column.OkFor${application0}) 0]
        set badList ""
        global ${rootname}CBWidget
        set knownDevices [array names ${rootname}CBWidget]
        foreach device $deviceName nonexistent $deviceNonexistent ok $deviceOk {
	    if $booster {
		set device [string replace $device 0 0 S]
	    }
            if [lsearch -exact $knownDevices $device]==-1 continue
            set nameFlag ${rootname}${device}
            global $nameFlag
            if {$nonexistent || !$ok} {
                set $nameFlag 0
                if {$nonexistent} {
                    [set ${rootname}CBWidget($device)] configure -state disabled -indicatoron off -borderwidth 0 -pady 1 -padx 1
                } else {
                    [set ${rootname}CBWidget($device)] configure -state disabled -bg $apsBackground -borderwidth 1 -pady 0 -padx 0
                }
                lappend badList $device
            } else {
                set wasDisabled [[set ${rootname}CBWidget($device)] cget -state]
                [set ${rootname}CBWidget($device)] configure -state normal -indicatoron on -bg $apsBackground -borderwidth 1 -pady 0 -padx 0
                if {$wasDisabled == "disabled"} {
                    set $nameFlag 0
                    [set ${rootname}CBWidget($device)] invoke
                }
            }
        }
        global ${rootname}Bad${deviceType}List 
        set ${rootname}Bad${deviceType}List $badList
    }
}

proc APSSRFreqGenerateOrbCorrFiles {args} {
    set configFile ""
    set outputRoot ""
    set referenceMatrix ""
    set plane h
    set generate 0
    set install 0
    set rootname ""
    set singularValues 320
    set SVDanalysis 0
    set tikhonovFilter 0
    set tikhonovSVN 0
    set tikhonovBeta 0
    set tikhonovType SVN
    set deleteVectors ""
    set bpmSuffix mswAve
    APSStrictParseArguments {configFile plane outputRoot referenceMatrix generate install rootname singularValues SVDanalysis
        deleteVectors bpmSuffix tikhonovFilter tikhonovSVN tikhonovBeta tikhonovType}
    
   
    if {!$generate && !$install} return
    if {$tikhonovFilter} {
	if {$tikhonovType=="SVN" && !$tikhonovSVN} {
	    return -code error "APSSRFreqGenerateOrbCorrFiles(0a): tikhonov SVN number not provided!"
	}
	if {$tikhonovType=="Beta" && !$tikhonovBeta} {
	    return -code error "APSSRFreqGenerateOrbCorrFiles(0b): tikhonov beta value not provided!"
	}
    }
    if ![string length $rootname] {
        return -code error "APSSRFreqGenerateOrbCorrFiles: programming error: no variable rootname"
    }
    
    if {![string length $configFile] || ![file exists $configFile]} {
        return -code error "APSSRFreqGenerateOrbCorrFiles: supply a configuration file, or one that exists ($configFile was given)."
    }
    set configFile [APSResolveLink $configFile]

    if {![string length $referenceMatrix] || ![file exists $referenceMatrix]} {
        return -code error "APSSRFreqGenerateOrbCorrFiles: supply a reference matrix file, or one that exists ($referenceMatrix was given)."
    }
    set referenceMatrix [APSResolveLink $referenceMatrix]
    set origRefMatrix $referenceMatrix

    if ![string length $outputRoot] {
        return -code error "APSSRFreqGenerateOrbCorrFiles: supply an output rootname."
    }
    
   # puts stderr "$configFile $referenceMatrix"
    global ${rootname}ConfigStatus
    set ${rootname}ConfigStatus "Working..."
    update
    set correctorNames BRF:S:Hp8657RefFreqAO
    set tmpRoot /tmp/[APSTmpString]
    APSAddToTempFileList $tmpRoot.monFlags 
    
    if [catch {exec sddsprocess $configFile -pipe=out \
                 -match=parameter,NameType=MonitorNames \
                 -filter=column,Flag,1,1 \
                 | sddscombine -pipe -merge \
                 | tee $tmpRoot.monFlags \
                 | sdds2stream -pipe -column=Name} monitorNames] {
        return -code error "APSSRFreqGenerateOrbCorrFiles: $monitorNames"
    }

    #puts stderr "$monitorNames"
    set monitorNameMatchOption ""
    set IDBPMList ""
    foreach item $monitorNames {
        if [string match *ID* $item]!=0 {
            lappend IDBPMList $item
        }
        if [string length $monitorNameMatchOption] {
            set monitorNameMatchOption "$monitorNameMatchOption,BPMName=$item,|"
        } else {
            set monitorNameMatchOption "-match=column,BPMName=$item"
        }
    }
    #puts stderr $monitorNameMatchOption
    set BMBPMList ""
    foreach item $monitorNames {
        if [string match *BM* $item]!=0 {
            lappend BMBPMList $item
        }
        if [string length $monitorNameMatchOption] {
            set monitorNameMatchOption "$monitorNameMatchOption,BPMName=$item,|"
        } else {
            set monitorNameMatchOption "-match=column,BPMName=$item"
        }
    }
    if [llength $IDBPMList] {
        set IDBPMsKnownList [APSGetIDXRayBPMList -plane h]
        set IDBPMEqnList    [APSGetIDXRayEqnList -plane h]
        lappend equationCmd sddsprocess -pipe
        foreach item $IDBPMList {
            set index [lsearch -exact $IDBPMsKnownList $item]
            if $index==-1 {
                return -code error "APSSRFreqGenerateOrbCorrFiles: no information on $item"
            }
            lappend equationCmd "-define=column,$item,[lindex $IDBPMEqnList $index]"
        }
    }
    if [llength $BMBPMList] {
        set BMBPMsKnownList [APSGetBMXRayBPMList -plane h]
        set BMBPMEqnList    [APSGetBMXRayEqnList -plane h]
        lappend equationCmd sddsprocess -pipe
        foreach item $BMBPMList {
            set index [lsearch -exact $BMBPMsKnownList $item]
            if $index==-1 {
                return -code error "APSSRFreqGenerateOrbCorrFiles: no information on $item"
            }
            lappend equationCmd "-define=column,$item,[lindex $BMBPMEqnList $index]"
        }
    }
    if { [llength $IDBPMList] || [llength $BMBPMList] } {
        set tmpMatrix /tmp/[APSTmpString]
        if [catch {eval exec sddstranspose $referenceMatrix -pipe=out  \
                     | $equationCmd \
                     | sddstranspose -pipe=in $tmpMatrix \
                     -newColumnNames=OldColumnNames -oldColumnNames=BPMName} result] {
            return -code error "APSSRFreqGenerateOrbCorrFiles: $result"
        }
        set referenceMatrix $tmpMatrix
    }
    #puts stderr "BM=$BMBPMList ID=$IDBPMList"
    set inverseOptions "-largestSingularValues=$singularValues"
    if $tikhonovFilter {
	if {$tikhonovType=="SVN"} {
	    if $tikhonovSVN {
		lappend inverseOptions "-tikhonov=SVN=[expr abs($tikhonovSVN)]"
	    }
	} elseif $tikhonovBeta {
	    lappend inverseOptions "-tikhonov=beta=[expr abs($tikhonovBeta)]"
	}
    }
    if [lsearch -exact [APSGetSDDSNames -fileName $tmpRoot.monFlags -class column] Weight]!=-1 {
        lappend inverseOptions "-weights=$tmpRoot.monFlags,name=Name,value=Weight"
    }
    #    puts stderr "corr= $correctorNames"
    if $SVDanalysis {
        set tmpOutput /tmp/[APSTmpString]
        APSAddToTmpFileList -ID APSSRGenerateOrbCorrFiles -fileList $tmpOutput
        if [catch {eval exec sddsconvert $referenceMatrix -pipe=out \
                     -retain=column,BPMName,[join $correctorNames ,] \
                     | sddsprocess -pipe $monitorNameMatchOption \
                     | sddspseudoinverse -pipe=in $tmpOutput $inverseOptions \
                     -umatrix=$outputRoot/u \
                     -vmatrix=$outputRoot/v \
                     -sfile=$outputRoot/s \
                 } result] {
            return -code error "APSSRFreqGenerateOrbCorrFiles(svd): Error possibly caused by non-existent inverse. Check your configuration.\nProcessing command returns:\n$result"
        }
        set convertOption -retain=col,OldColumnNames
        for {set i 0} {$i<$singularValues} {incr i} {
            append convertOption ,SV[format %03d $i]
        }
        if [catch {exec sddsconvert $outputRoot/v $tmpOutput.v $convertOption} result] {
            return -code erorr "APSSRFreqGenerateOrbCorrFiles(svd): $result"
        }
        set returnList [exec tksddsplot $tmpOutput.v -col=OldColumnNames,SV* -sep \
                            -enum=interval=20 -selectFrames]
        set deleteVectors ""
        set index 0
        foreach selected $returnList {
            if {!$selected} {
                lappend deleteVectors $index
            }
            incr index
        }
        global ${rootname}DeleteModes
        set ${rootname}DeleteModes $deleteVectors
        APSSetVarAndUpdate ${rootname}ConfigStatus "SVD analysis done."
        return
    }
    global ${rootname}DeleteModes
    if ![llength $deleteVectors] {
        if {[info exists ${rootname}DeleteModes] && 
            [llength [set ${rootname}DeleteModes]]} {
            set deleteVectors [set ${rootname}DeleteModes]
        }
    }
    if [llength $deleteVectors] {
        lappend inverseOptions -deleteVectors=[join $deleteVectors ,]
    }
    if [catch {eval exec sddsconvert $referenceMatrix -pipe=out \
                 -retain=column,BPMName,[join $correctorNames ,] \
                 | sddsprocess -pipe $monitorNameMatchOption \
                 | sddspseudoinverse -pipe $inverseOptions \
                 | sddsconvert -pipe -rename=column,OldColumnNames=Actuators \
                 | sddsprocess -pipe \
                 -print=parameter,ConfigurationFile,$configFile \
                 -print=parameter,ReferenceMatrix,$origRefMatrix \
                 | sddsconvert -pipe=in $outputRoot/irm \
                 -editnames=column,S*,ei/:${bpmSuffix}:x:RfErrorM/ \
             } result] {
        return -code error "APSSRFreqGenerateOrbCorrFiles: Error possibly caused by non-existent inverse. Check your configuration.\nProcessing command returns:\n$result"
    }
    catch {file delete -force $outputRoot/irm~ }
    if [catch {exec sdds2stream -param=ConditionNumber $outputRoot/irm} condNumber] {
        return -code error "APSSRFreqGenerateOrbCorrFiles: error getting condition number"
    }

    # create file for circumference calculation
    set referenceCircumference 1104
    set referenceFrequency 351930276
    # the factor turns out to be about 3 in units of um/Hz
    package require rpn
    set factor [rpn expr "$referenceCircumference $referenceFrequency / 1e6 *"]
    if [catch {exec sddsprocess $outputRoot/irm -pipe=out \
                 -reedit=col,Actuators,100Di/S:circumferenceChange/ \
                 "-redef=col,%s,%s $factor *,select=S*:P*" \
                 | sddsconvert -pipe=in $outputRoot/circumferenceMatrix \
                 -editname=col,S*mswAve*,%/mswAve/msAve/
             } result] {
        return -code error "APSSRFreqGenerateOrbCorrFiles: $result"
    }
    set testFile(ColumnNames) "ControlName MinimumValue MaximumValue SleepTime"
    set testFile(ColumnInfo.MinimumValue) "type SDDS_DOUBLE"
    set testFile(ColumnInfo.MaximumValue) "type SDDS_DOUBLE"
    set testFile(ColumnInfo.SleepTime) "type SDDS_DOUBLE"
    lappend testFile(Column.ControlName) S:injectingStatusBI S35DCCT:currentCC BRF:S:Hp8657RefFreqAO
    if [catch {exec cavget -list=BRF:S:Hp8657RefFreqAO -float=%21.1f -pend=15} freqNow] {
        return -code error "APSSRFreqGenerateOrbCorrFiles: error getting frequency from source: $freqNow"
    }
    if [catch {exec cavget -list=S:MPS:M4A:maxSrCurrentAI -float=%21.1f -pend=15} maxCurrent] {
        return -code error "APSSRFreqGenerateOrbCorrFiles: error getting maximum current from MPS system: $maxCurrent"
    }
    lappend testFile(Column.MinimumValue) -0.5 1.5 [expr $freqNow-100.0]
    lappend testFile(Column.MaximumValue) 0.5 $maxCurrent [expr $freqNow+100.0]
    lappend testFile(Column.SleepTime) 3.0 3.0 3.0
    foreach item $monitorNames {
        lappend testFile(Column.ControlName) ${item}:mswAve:x:RfErrorM
        lappend testFile(Column.MinimumValue) -1.5
        lappend testFile(Column.MaximumValue) 1.5
        lappend testFile(Column.SleepTime) 3.0
    }
    foreach item $monitorNames {
        lappend testFile(Column.ControlName) ${item}:ms.XAVS
        lappend testFile(Column.MinimumValue) -0.5
        lappend testFile(Column.MaximumValue) 1.5
        lappend testFile(Column.SleepTime) 3.0
    }
    set testFile(Column.ControlName) [list $testFile(Column.ControlName)]
    set testFile(Column.MinimumValue) [list $testFile(Column.MinimumValue)]
    set testFile(Column.MaximumValue) [list $testFile(Column.MaximumValue)]
    set testFile(Column.SleepTime) [list $testFile(Column.SleepTime)]
    if {[catch {sdds save $outputRoot/tests testFile} result]} {
        set ${rootname}ConfigStatus "Error: $result"
        bell
        return
    }
    set ${rootname}ConfigStatus "Done.  Condition number is $condNumber ."
    update
}
proc APSBoosterGenerateOrbCorrFiles {args} {
    set configFile ""
    set outputRoot ""
    set referenceMatrix ""
    set plane h
    set generate 0
    set install 0
    set rootname ""
    set singularValues 320
    set tikhonovFilter 0
    set tikhonovSVN 0
    set tikhonovBeta 0
    set tikhonovType SVN
    set SVDanalysis 0
    set deleteVectors ""
    APSStrictParseArguments {configFile plane outputRoot referenceMatrix generate install rootname \
				 singularValues SVDanalysis deleteVectors \
				 tikhonovFilter tikhonovSVN tikhonovBeta tikhonovType}
    
    if {!$generate && !$install} return
    if $tikhonovFilter {
	if {$tikhonovType=="SVN" && !$tikhonovSVN} {
	    return -code error "APSBoosterGenerateOrbCorrFiles(0a): tikhonov SVN number not provided!"
	}
	if {$tikhonovType=="Beta" && !$tikhonovBeta} {
	    return -code error "APSBoosterGenerateOrbCorrFiles(0b): tikhonov beta not provided!"
	}
    }
    
    if ![string length $rootname] {
        return -code error "APSBoosterGenerateOrbCorrFiles: programming error: no variable rootname"
    }

    if {![string length $configFile] || ![file exists $configFile]} {
        return -code error "APSBoosterGenerateOrbCorrFiles: supply a configuration file, or one that exists ($configFile was given)."
    }
    set configFile [APSResolveLink $configFile]

    if {![string length $referenceMatrix] || ![file exists $referenceMatrix]} {
        return -code error "APSBoosterGenerateOrbCorrFiles: supply a reference matrix file, or one that exists ($referenceMatrix was given)."
    }
    set referenceMatrix [APSResolveLink $referenceMatrix]
    set origRefMatrix $referenceMatrix

    if ![string length $outputRoot] {
        return -code error "APSBoosterGenerateOrbCorrFiles: supply an output rootname."
    }
   # puts stderr "$configFile $referenceMatrix"
    global ${rootname}ConfigStatus
    set ${rootname}ConfigStatus "Working..."
    update
    
    set tmpRoot /tmp/[APSTmpString]
    APSAddToTempFileList $tmpRoot.monFlags 
    if [catch {exec sddsprocess $configFile -pipe=out \
                 -match=parameter,NameType=MonitorNames \
                 -filter=column,Flag,1,1 \
                 | sddscombine -pipe -merge \
                 | tee $tmpRoot.monFlags \
                 | sdds2stream -pipe -column=Name} monitorNames] {
        return -code error "APSBoosterGenerateOrbCorrFiles: $monitorNames"
    }
    if [catch {exec sddsprocess $configFile -pipe=out \
                 -match=parameter,NameType=CorrectorNames \
                 -filter=column,Flag,1,1 \
                 | sddscombine -pipe -merge \
                 | sdds2stream -pipe -column=Name} correctorNames] {
        return -code error "APSBoosterGenerateOrbCorrFiles: $correctorNames"
    }
    set monitorNameMatchOption ""
    foreach item $monitorNames {
        if [string match *ID* $item]!=0 {
            lappend IDBPMList $item
        }
        if [string length $monitorNameMatchOption] {
            set monitorNameMatchOption "$monitorNameMatchOption,BPMName=$item,|"
        } else {
            set monitorNameMatchOption "-match=column,BPMName=$item"
        }
    }
    set inverseOptions "-largestSingularValues=$singularValues"
    if $tikhonovFilter {
	if {$tikhonovType=="SVN"} {
	    if $tikhonovSVN {
		lappend inverseOptions "-tikhonov=SVN=[expr abs($tikhonovSVN)]"
	    }
	} elseif $tikhonovBeta {
	    lappend inverseOptions "-tikhonov=beta=[expr abs($tikhonovBeta)]"
	}
    }
    if [lsearch -exact [APSGetSDDSNames -fileName $tmpRoot.monFlags -class column] Weight]!=-1 {
        lappend inverseOptions "-weights=$tmpRoot.monFlags,name=Name,value=Weight"
    }
    #puts stderr "corr= $correctorNames"
    if $SVDanalysis {
        set tmpOutput /tmp/[APSTmpString]
        APSAddToTmpFileList -ID APSSRGenerateOrbCorrFiles -fileList $tmpOutput
        if [catch {eval exec sddsconvert $referenceMatrix -pipe=out \
                     -retain=column,BPMName,[join $correctorNames ,] \
                     | sddsprocess -pipe $monitorNameMatchOption \
                     | sddspseudoinverse -pipe=in $tmpOutput $inverseOptions \
                     -umatrix=$outputRoot/u \
                     -vmatrix=$outputRoot/v \
                     -sfile=$outputRoot/s \
                 } result] {
            return -code error "APSSRGenerateOrbCorrFiles(svd): Error possibly caused by non-existent inverse. Check your configuration.\nProcessing command returns:\n$result"
        }
        set convertOption -retain=col,OldColumnNames
        for {set i 0} {$i<$singularValues} {incr i} {
            append convertOption ,SV[format %03d $i]
        }
        if [catch {exec sddsconvert $outputRoot/v $tmpOutput.v $convertOption} result] {
            return -code error "APSSRGenerateOrbCorrFiles(svd): $result:`"
        }
        set returnList [exec tksddsplot $tmpOutput.v -col=OldColumnNames,SV* -sep \
                          -enum=interval=20 -selectFrames]
        set deleteVectors ""
        set index 0
        foreach selected $returnList {
            if {!$selected} {
                lappend deleteVectors $index
            }
            incr index
        }
        global ${rootname}DeleteModes
        set ${rootname}DeleteModes $deleteVectors
        APSSetVarAndUpdate ${rootname}ConfigStatus "SVD analysis done."
        return
    }
    global ${rootname}DeleteModes
    if ![string length $deleteVectors] {
        if {[info exists ${rootname}DeleteModes] && 
            [llength [set ${rootname}DeleteModes]]} {
            set deleteVectors [set ${rootname}DeleteModes]
        }
    }
    if [llength $deleteVectors] {
        lappend inverseOptions -deleteVectors=[join $deleteVectors ,]
    } 
    if [catch {eval exec sddsconvert $referenceMatrix -pipe=out \
                   -retain=column,BPMName,[join $correctorNames ,] \
                   | sddsprocess -pipe $monitorNameMatchOption \
                   | tee $tmpRoot.pseu.input \
                   | sddspseudoinverse -pipe $inverseOptions \
                   | sddsconvert -pipe -rename=column,OldColumnNames=Actuators \
                   | sddsprocess -pipe \
                   -print=parameter,ConfigurationFile,$configFile \
                   -print=parameter,ReferenceMatrix,$origRefMatrix \
                   | sddsconvert -pipe=in $outputRoot/irm \
                   {-editnames=column,S*,ei\\:mswAve:x:RfErrorM\\}} result] {
        return -code error "APSBoosterGenerateOrbCorrFiles: Error possibly caused by non-existent inverse. Check your configuration.\nProcessing command returns:\n$result"
    }
    catch {file delete  -force $outputRoot/irm~ } 
    if [catch {exec sdds2stream -param=ConditionNumber $outputRoot/irm} condNumber] {
        return -code error "APSBoosterGenerateOrbCorrFiles: error getting condition number"
    }
    set ${rootname}ConfigStatus "Done.  Condition number is $condNumber ."
    update
}

proc APSBoosterPlaneOrbitConfig {widget args} {    
    set rootname ""
    set bpmCorrTogether 0
    set corrector 1
    set bpm 1
    set plane h
    set bpmItemList ""
    set bpmItemLabelList ""
    set corrItemList ""
    set corrItemLabelList ""
    set parent ""
    set fileFrame 1
    set application BoosterOrbitCorrection
    APSParseArguments {rootname bpm corrector plane bpmItemList bpmItemLabelList \
                               corrItemList corrItemLabelList parent fileFrame application bpmCorrTogether}
    
    global ${rootname}ConfigStatus
    set ${rootname}ConfigStatus ""
    set frameWidth 320
    set frameHeight 320
    
    APSFrame $widget -parent $parent
    APSScrolledStatus .scrolled -parent $parent$widget.frame \
      -textVariable ${rootname}ConfigStatus \
      -width 85 -height 3 -lineLimit 1000 -label ""
    set tabList ""
    if $bpm {
        lappend tabList Monitors
    }
    if $corrector {
        lappend tabList Correctors
    }
    set label1 ""
    set label2 ""
    set sectorList ""
    for {set b 1} {$b<5} {incr b} {
	for {set c 0} {$c<10} {incr c} {
	    lappend sectorList B${b}C$c
	}
    }
    
    set w1 $parent$widget
    set w2 $parent$widget
    set label1 "Choose BPM Monitors"
    set label2 "Choose Correctors"
    if !$bpmCorrTogether {
	if $bpm {
	    if ![string length $bpmItemLabelList] {
		set bpmItemLabelList $bpmItemList
	    }
	    set bpmItemList {P1 P2}
	    APSSRSectorButtons .bpm -parent $w1 -rootname $rootname \
		-label $label1 -sectorList $sectorList -orientation horizontal \
		-itemList $bpmItemList -itemLabelList $bpmItemList -description "booster $plane bpms" \
		-sectorControl 1 -packOption "-side top" 
	} 
	if $corrector {
	    if ![string length $corrItemLabelList] {
		set corrItemLabelList $corrItemList
	    }
	    APSSRSectorButtons .corr -parent $w2 -rootname $rootname \
		-label $label2 -sectorList $sectorList \
		-itemList $corrItemList -itemLabelList $corrItemLabelList -description "boostesr $plane correctors" \
		-orientation horizontal -sectorControl 0 -packOption "-side top"  -missingList {B2C9V}  
	}
    } else {
	#put bpm and corrector together
	APSSRSectorButtons .bpmcorr -parent $w1 -rootname $rootname  \
	    -label "Select $plane BPM/correctors (\"[string toupper $plane]\" represents corrector)" -sectorList $sectorList  \
	    -itemList [list P1 P2 [string toupper $plane]] \
	    -itemLabelList [list P1 P2 [string toupper $plane]] \
	    -description "boostesr $plane" -separateCountButton 1 \
	    -orientation horizontal -sectorControl 1 -packOption "-side top"  -missingList {B2C9V B3C2P1 B3C2P2} 
    }
    if $fileFrame {
        #make frames for read, write, ect. controls
        set frameWidth 800
        set frameHeight 200
        set labelList [list Config... Read... Write... \
                         {Generate controllaw files...} ]
        set commandList [list {} {} \
                           "APSSetVarAndUpdate ${rootname}WriteDir \"\"" \
                           {}]
        set widgetList [APSTabFrame .fileops -parent $parent$widget -label "" \
                          -labelList $labelList \
                          -commandList $commandList \
                          -height $frameHeight -width $frameWidth]
        global ${rootname}Lattice ${rootname}MainDir ${rootname}LatSubDir
        set ${rootname}Lattice default
        set ${rootname}MainDir /home/helios/oagData/booster/orbitControllaw
        set ${rootname}LatSubDir lattices
       
        set wConfig [lindex $widgetList 0]
        set wRead [lindex $widgetList 1]
        set wWrite [lindex $widgetList 2]
        set wGenerate [lindex $widgetList 3]
        
        APSFrame .lattice -parent $wConfig  -label "Lattice" \
          -width $frameWidth -height $frameHeight -contextHelp \
          "Use this frame to specify the lattice directory name and main directory area.You may also change the default lattice from here."
        set w0 $wConfig.lattice.frame
        APSLabeledEntry .maindir -parent $w0 -label "Main directory: " \
          -textVariable ${rootname}MainDir -width 60 -contextHelp \
          "Enter the name of the main directory for the orbit correction system."
        APSFileSelectWidget .config -parent $w0 -label "Lattice: " \
          -pathVariableList [list ${rootname}MainDir ${rootname}LatSubDir] -mode directory -width 60 \
          -variable ${rootname}Lattice -incrementButtons 0 -contextHelp \
          "Enter the name of the lattice with which to work."
        #comment out this default button because it is dangerous to change the default lattice and it is not needed in this application, since we have another software for SR managers to change the default lattice. We had an occasion that it was pressed by a non-familiar person which caused the orbit correction failure and almost dumped the beam.
       # APSButton .default -parent $w0.config -text D -size small \
       #   -contextHelp "Makes the named file into the default lattice." \
        #  -command "APSMakeLink -confirm 1 -confirmMessage {Change default lattice? It is dangerous to change default lattice during operations because it changes the orbit correction configuration, Are you sure to change default lattice?} -local 1 -log 1 -permissions 00775 -filename \[subst \$${rootname}MainDir/\$${rootname}LatSubDir/\$${rootname}Lattice\] -linkname \[subst \$${rootname}MainDir/\$${rootname}LatSubDir/default\]; set ${rootname}Lattice default"
        
        global ${rootname}refMatrices ${rootname}RefMatrix  ${rootname}Plane ${rootname}FilterEnd1
        set ${rootname}RefMatrix $plane.default
        set ${rootname}refMatrices refMatrices
        set ${rootname}Plane $plane
        set ${rootname}FilterEnd1 .*
        APSFileSelectWidget .${plane}ref -parent $w0 -mode file \
          -label "Reference matrix: " -width 60 \
          -variable ${rootname}RefMatrix \
          -pathVariableList [list ${rootname}MainDir ${rootname}LatSubDir ${rootname}Lattice ${rootname}refMatrices] \
          -filterVariableList [list ${rootname}Plane ${rootname}FilterEnd1] \
          -contextHelp \
          "Enter the name of the reference response matrix file for the $plane plane."
       
       # bind $w0.${plane}ref.entry <Return> "APSUpdateTimeRegion -rootname $rootname"
       # trace variable ${rootname}RefMatrix w "APSUpdateTimeRegion -rootname $rootname"
        #update the region when reference matrix changes
        
        #APSButton .default -parent $w0.${plane}ref -text D -size small \
        #  -contextHelp "Makes the named file into the default $plane-plane reference matrix." \
         # -command "APSMakeLink -confirm 1 -confirmMessage {Change reference matrix? Are you sure?} -local 1 -log 1 -permissions 00664 -filename \[subst \$${rootname}MainDir/\$${rootname}LatSubDir/\$${rootname}Lattice/\$${rootname}refMatrices/\$${rootname}RefMatrix\] -linkname \[subst \$${rootname}MainDir/\$${rootname}LatSubDir/\$${rootname}Lattice/\$${rootname}refMatrices/$plane.default\]; set ${rootname}RefMatrix $plane.default"

        # Make configuration-read frame.
        global ${rootname}ReadFile ${rootname}ReadDescription
        set ${rootname}ReadFile $plane.default
        set ${rootname}ReadDescription ""
        APSFrame .read -parent $wRead -label "Read configuration" \
          -width $frameWidth -height $frameHeight -contextHelp \
          "Use this frame to read combined monitor and corrector configurations."
        set w0 $wRead.read.frame
	
        APSFileSelectWidget .file -parent $w0 -variable ${rootname}ReadFile -label "Config: " \
          -pathVariableList [list ${rootname}MainDir ${rootname}LatSubDir ${rootname}Lattice] \
          -mode directory -filterVariableList \
          [list ${rootname}Plane ${rootname}FilterEnd1] -width 60 \
          -incrementButtons 1 -contextHelp \
          "Enter the name of the configuration file to read."
        APSLabeledOutput .descrip -parent $w0 -label "Description: " -width 80 -packOption "-side top -anchor w" \
          -textVariable ${rootname}ReadDescription -contextHelp \
          "Shows the description of the last-read configuration file."
       
        APSFrame .bf -parent $w0 -relief flat -label "" -packOption "-side top -anchor w"
        set w1 $w0.bf.frame
        APSButton .io0 -parent $w1 -text Read(replace) -packOption "-side left -anchor n" -size small -command \
	    "APSReadOrbitCorrectionConfig -booster 1 -sectorCount 40  -rootname $rootname -filename \$${rootname}MainDir/\$${rootname}LatSubDir/\$${rootname}Lattice/\$${rootname}ReadFile/config -logic replace " \
          -contextHelp "Press to read data to replace the existing configuration, using the named configuration file."
        APSButton .io1 -parent $w1 -text Read(or) -packOption "-side left -anchor n" -size small -command \
	    "APSReadOrbitCorrectionConfig -booster 1 -sectorCount 40 -rootname $rootname -filename \$${rootname}MainDir/\$${rootname}LatSubDir/\$${rootname}Lattice/\$${rootname}ReadFile/config -logic or " \
          -contextHelp "Press to read data to or with the existing configuration, using the named configuration file."
        APSButton .io2 -parent $w1 -text Read(and) -packOption "-side left -anchor n" -size small -command \
	    "APSReadOrbitCorrectionConfig -booster 1 -sectorCount 40 -rootname $rootname -filename \$${rootname}MainDir/\$${rootname}LatSubDir/\$${rootname}Lattice/\$${rootname}ReadFile/config -logic and " \
          -contextHelp "Press to read data to and with the existing configuration, using the named configuration file."
        APSButton .io3 -parent $w1 -text Read(not) -packOption "-side left -anchor n" -size small -command \
	    "APSReadOrbitCorrectionConfig -booster 1 -sectorCount 40 -rootname $rootname -filename \$${rootname}MainDir/\$${rootname}LatSubDir/\$${rootname}Lattice/\$${rootname}ReadFile/config -logic not " \
          -contextHelp "Press to read data specifying elements to turn off, using the named configuration file."
        APSButton .io4 -parent $w1 -text "Refresh good/bad" -packOption "-side left -anchor n" -size small -command \
          "APSRescanBadOrbitDevices -rootname $rootname -plane $plane -booster 1 "
       

        # Make the write-configuration frame
        global ${rootname}WriteDir 
        set ${rootname}StartRampTime 160
	set ${rootname}EndRampTim 220
        APSFrame .write -parent $wWrite -label "Write configuration" \
          -width $frameWidth -height $frameHeight -contextHelp \
          "Use this frame to write combined monitor and corrector configurations."
        set w0 $wWrite.write.frame
        set ${rootname}WriteDir h.[clock format [clock seconds] -format %Y-%m%d].00
        APSFileSelectWidget .file -parent $w0 -variable ${rootname}WriteDir \
          -pathVariableList [list ${rootname}MainDir ${rootname}LatSubDir ${rootname}Lattice] \
          -label "Config: " -noSelect 0 -mode directory -incrementButtons 1 -width 60 -contextHelp \
          "Enter the name of the configuration to write." \
          -filterVariableList [list ${rootname}Plane ${rootname}FilterEnd1]
        APSButton .genname -parent $w0.file -text G -size small -command \
          "set ${rootname}WriteDir \[APSNextGenerationedName -directory \$${rootname}MainDir/\$${rootname}LatSubDir/\$${rootname}Lattice -name \$${rootname}Plane.\[clock format \[clock seconds\] -format %Y-%m%d\].00 -newFile 1 -separator .\]"
        APSLabeledEntry .descrip -parent $w0 -label "Description: " -width 60 \
          -textVariable ${rootname}WriteDescription -contextHelp \
          "Use to enter a description for the configuration to be written."
	
#	set rampTimeList [exec sddsconvert  /home/helios/oagData/booster/ramps/correctors/lattices/default/HVCorr.ramp \
#			      -toPage=1 -pipe=out \
#			      | sddsprocess -pipe -clip=1,1 \
#			      | sddsprintout -pipe -col=RampTime,format=%.0f -noTitle -noLabels]
#	set itemList ""
	#for {set i 0} {$i<[expr [llength $rampTimeList] -1]} {incr i 1} {
	#    lappend itemList "[lindex $rampTimeList $i]-[lindex $rampTimeList [expr $i+1]]"
	#}
      #  set itemList {region0 region1 region2 region3 region4 region5 region6 region7 region8 region9}
#	set ${rootname}RampTimeRange [lindex $itemList 1]
#	APSComboboxFrame .ramp -parent $w0 -label "BPM/Corrector Time Region:" -editable 0 \
	#    -width 40 -textVariable ${rootname}RampTimeRange -itemList $itemList
	
        APSButton .io -parent $w0 -text Write -size small -command \
	    "APSSRWritePlaneOrbitCorrectionConfig -sectorCount 40 -booster 1 -interactive 1 -sectorList [list $sectorList] -rootname $rootname -filename \$${rootname}MainDir/\$${rootname}LatSubDir/\$${rootname}Lattice/\$${rootname}WriteDir/config -description \$${rootname}WriteDescription  -configName \$${rootname}WriteDir -plane $plane" \
          -contextHelp "Press to write data, using the named configuration file."
        
        
        # Make the frame for computing the matrix and installing it.
        global ${rootname}Plane ${rootname}SingValues ${rootname}SVDanalysis ${rootname}SetupOutputDir
	global ${rootname}TikhonovFilter ${rootname}TikhonovSVN ${rootname}TikhonovBeta ${rootname}TikhonovType
        global  ${rootname}DeleteModes
        APSFrame .comp -parent $wGenerate -label "Compute matrix" \
          -width $frameWidth -height $frameHeight -contextHelp \
          "Use this frame to generate the matrix for orbit correction from an existing configuration."
        set w0 $wGenerate.comp.frame
        
        set ${rootname}SingValues 20
        set ${rootname}SVDanalysis 0
        set ${rootname}DeleteModes ""
	set ${rootname}TikhonovFilter 0
	set ${rootname}TikhonovSVN 0
	set ${rootname}TikhonovBeta 0
	set ${rootname}TikhonovType SVN
        APSFileSelectWidget .file -parent $w0 -variable ${rootname}WriteDir \
          -pathVariableList [list ${rootname}MainDir ${rootname}LatSubDir ${rootname}Lattice] -filter "h.* v.*" \
          -label "Config: " -noSelect 0 -mode directory -incrementButtons 1 -width 60 -contextHelp \
          "Enter the name of the configuration to use." \
          -filterVariableList [list ${rootname}Plane ${rootname}FilterEnd1] 
        APSButton .genname -parent $w0.file -text G -size small -command \
          "set ${rootname}WriteDir \[APSNextGenerationedName -directory \$${rootname}MainDir/\$${rootname}LatSubDir/\$${rootname}Lattice -name \$${rootname}Plane.\[clock format \[clock seconds\] -format %Y-%m%d\].00 -newFile 1 -separator .\]"
        
        frame $w0.f1 
        pack $w0.f1 -fill x
        APSLabeledEntry .le1 -parent $w0.f1 -packOption "-side left" \
          -textVariable ${rootname}SingValues \
          -label "Number of singular values: " -width 8 -contextHelp \
          "Enter the number of singular values to keep."
        APSButton .svd -parent $w0.f1 -packOption "-side left" -size small \
            -text "SVD Analysis" -contextHelp "Removes DC vectors from singular values decomposition. May help in horizontal plane convergence. Not recommended for vertical plane." \
            -command "APSBoosterGenerateOrbCorrFiles -rootname $rootname -generate 1 -configFile \$${rootname}MainDir/\$${rootname}LatSubDir/\$${rootname}Lattice/\$${rootname}WriteDir/config -plane \$${rootname}Plane -referenceMatrix \$${rootname}MainDir/\$${rootname}LatSubDir/\$${rootname}Lattice/refMatrices/\$${rootname}RefMatrix -outputRoot \$${rootname}MainDir/\$${rootname}LatSubDir/\$${rootname}Lattice/\$${rootname}WriteDir/ -singularValues \$${rootname}SingValues -SVDanalysis 1"
        APSButton .gen -parent $w0.f1 -text Compute -size small -packOption "-side left" -command \
          "APSBoosterGenerateOrbCorrFiles -rootname $rootname -generate 1 -configFile \$${rootname}MainDir/\$${rootname}LatSubDir/\$${rootname}Lattice/\$${rootname}WriteDir/config -plane \$${rootname}Plane -referenceMatrix \$${rootname}MainDir/\$${rootname}LatSubDir/\$${rootname}Lattice/refMatrices/\$${rootname}RefMatrix -outputRoot \$${rootname}MainDir/\$${rootname}LatSubDir/\$${rootname}Lattice/\$${rootname}WriteDir/ -singularValues \$${rootname}SingValues -SVDanalysis 0"
        APSButton .default -parent $w0.f1 -text "Make Default" -size small -packOption "-side left" \
          -contextHelp \
          "Makes the named configuration into the default corrector configuration for chosen plane." \
          -command "APSSRInstallOrbCorrFiles -rootname $rootname -application $application -booster 1"
        APSLabeledEntry .deletemodes -parent $w0 -textVariable ${rootname}DeleteModes \
	    -label "Mode to delete: " \
	    -contextHelp "a list of modes to be deleted from SVD analysis" -width 80
	
	APSRadioButtonFrame .tik -parent $w0 -label "Use tikhonov filter?" -buttonList {Yes No} \
	    -valueList {1 0} -variable ${rootname}TikhonovFilter -orientation horizontal
	APSRadioButtonEntryFrame .par -parent $w0.tik -orientation horizontal -label "Tikhonov filter type:" \
	    -variable ${rootname}TikhonovType -buttonList {SVN_Number Beta} -orientation horizontal \
	    -valueList {SVN Beta} -commandList [list "set ${rootname}TikhonovBeta 0" "set ${rootname}TikhonovSVN 0"] \
	    -entryVariableList [list ${rootname}TikhonovSVN ${rootname}TikhonovBeta] \
	    -entryWidth 10
	if {0} {
	APSLabeledEntryFrame .alpha -parent $w0.tik  -orientation horizontal  \
	    -label "  Tikhonov parameters: SVN/Beta:" -variableList [list ${rootname}TikhonovSVN ${rootname}TikhonovBeta] -width 15 \
	    -contextHelp "provide the SVN number or beta (fractional alpha) of the tikhonov filter, the singular value of the provided SVN number will be used as alpha of the tikhonov filter."
	}
    }
    
}

proc APSGetVariableNameOfSRSectorButtons {args} {
    set arrayName ""
    set sectorList ""
    set itemList ""
    set rootname ""
    APSParseArguments {arrayName sectorList itemList rootname}
    
    set sectorCount [llength $sectorList]
    if !$sectorCount {
        return -code error "APSGetVariableNameOfSRSectorButtons: The sectorList is not provided!"
    }
    global $arrayName
    for {set i 0} {$i<$sectorCount} {incr i} {
        foreach item $itemList {
            set ${arrayName}([lindex $sectorList $i]$item) ${rootname}S[expr $i +1]$item
        }
    }
}

proc APSWriteSelectionArrayConfig {args} {
    set filename ""
    set suffixLists ""
    set sectorCount 40
    set sectorList ""
    set rootname ""
    set NameTypeList ""
    set PVTypeList ""
    APSStrictParseArguments {rootname sectorCount filename NameTypeList PVTypeList suffixLists sectorList}
    
    if [llength $sectorList] {
        set sectorCount [llength $sectorList]
    }
    if ![string length $filename] {
        return -code error "APSWriteSelectionArrayConfig: filename is not given!"
    }
    if ![llength $NameTypeList] {
        return -code error "APSWriteSelectionArrayConfig: NameTypeList is not provided!"
    }
    set nameTypeIndex -1
    set fileList ""
    foreach NameType $NameTypeList PVType $PVTypeList {
        incr nameTypeIndex
        set names ""
        set sectors ""
        set itemList [lindex $suffixLists $nameTypeIndex]
        for {set i 1} {$i<=$sectorCount} {incr i} {
            foreach item $itemList {
                set name ${rootname}S${i}$item
                global $name
                if [set $name] {
                    if [llength $sectorList] {
                        lappend names [lindex $sectorList [expr $i -1]]$item
                    } else {
                        lappend names $name
                    }
                    lappend sectors $i
                }
            }
        }
        if ![llength $names] {
            return -code error "APSWriteSelectionArrayConfig: No $NameType PVs are selected!"
        }
        if [catch {exec sddsmakedataset $filename.$nameTypeIndex -defaultType=string \
                     -par=NameType -data=$NameType \
                     -par=PVType -data=$PVType \
                     -col=Name -data=[join $names ,] \
                     -col=Sector,type=long -data=[join $sectors ,] } result] {
            return -code error "APSWriteSelectionArrayConfig: $result"
        }
        lappend fileList $filename.$nameTypeIndex
    }
    APSAddToTmpFileList -ID APSWriteSelectionArrayConfig -fileList $fileList
    if [catch {eval exec sddscombine $fileList $filename -overwrite} result] {
        return -code error "APSWriteSelectionArrayConfig: $result"
    }
}

proc APSReadSelectionArrayConfig {args} {
    set filename ""
    set suffixList ""
    set sectorList ""
    set rootname ""
    set sectorCount 40
    set mode replace
    #mode: and, or, replace
    APSStrictParseArguments {rootname sectorCount suffixList filename mode sectorList}
    
    if ![file exist $filename] {
        return -code error "APSReadGeneralConfig: config file $filename does not exist!"
    }
    
    if [llength $sectorList] {
        set sectorCount [llength $sectorList]
    }

    if [catch {sdds load $filename configData} result] {
        return -code error "APSReadGeneralConfig: $result"
    }
    set pages [llength $configData(Parameter.NameType)]
   
    set OnNameList ""
    for {set i 0} {$i<$pages} {incr i} {
        set names [lindex $configData(Column.Name) $i]
        set sectors [lindex $configData(Column.Sector) $i]
        foreach name $names sector $sectors {
            if [llength $sectorList] {
                set repl [lindex $sectorList [expr $sector -1]]
                regsub $repl $name "" newName
                set name S${sector}$newName
            }
            lappend OnNameList ${rootname}$name
        }
    }
    switch $mode {
        or {
            foreach name $OnNameList {
                global $name
                set $name 1
            }
        }
        and {
            for {set sector 1} {$sector<=$sectorCount} {incr sector} {
                foreach item $suffixList {
                    set name ${rootname}S${sector}$item
                    if [lsearch $OnNameList $name]==-1 {
                        global $name
                        if {![info exists $name] || [set ${name}]} {
                            set $name 0
                        }
                    }
                } 
            }
        }
        not {
            foreach name $OnNameList {
                global $name
                set $name 0
            }
        }
        default {
            #replace
            foreach name $OnNameList {
                global $name
                set $name 1
            }
            for {set sector 1} {$sector<=$sectorCount} {incr sector} {
                foreach item $suffixList {
                    set name ${rootname}S${sector}$item
                    if [lsearch $OnNameList $name]==-1 {
                        global $name
                        set $name 0
                    }
                } 
            }
        }
    }
}

proc APSUpdateConfigDescriptionDatabase {args} {
    set dataDir ""
    set newConfig ""
    set plane ""
    set linkConfig ""
    set update 0
    set booster 0
    APSStrictParseArguments {dataDir newConfig plane linkConfig update booster}
    if $booster {
	if [catch {APSUpdateBoosterOrbitCorrectionConfig -dataDir $dataDir -newConfig $newConfig} result] {
	    return -code error $result
	}
	return
    }
    if ![file exist $dataDir] {
        return -code error "APSUpdateConfigDescriptionDatabase: $dataDir does not exist!"
    }
    
    set oldDir [pwd]
    cd $dataDir
  
    if {![string length $newConfig] && ![string length $linkConfig]} {
        switch $plane {
            h -
            v {
            }
            default {
                return -code error "APSUpdateConfigDescriptionDatabase: invalid plane given!"
            }
        }
        set configFile ${plane}configDesc.sdds
    } else {
        if [string length $newConfig] {
            set newConfig0 $newConfig
        } elseif [string length $linkConfig] {
            set newConfig0 $linkConfig
        } else {
            return -code error "APSUpdateConfigDescriptionDatabase: either plane or newConfig or linkConfig has to be provided."
        }
        switch -regexp $newConfig0 {
            h {
                set plane h
                set configFile hconfigDesc.sdds
            }
            v {
                set plane v
                set configFile vconfigDesc.sdds
            }
            default {
                #return -code error "APSUpdateConfigDescriptionDatabase3: invalid config - $newConfig provided."
		#do not return error to work for other cases
		return
            }
        }
    }
    set tmpRoot /tmp/[APSTmpString]
    if {![file exist $configFile] || $update} {
        set configList [lsort -decreasing [glob -nocomplain ${plane}.*/config]]
        if ![llength $configList] {
            if [file exist $configFile] {
                exec rm $configFile
            }
            cd $oldDir
            return
        }
        set linkList ""
        set otherList ""
        set linkDescList ""
        set isXrayList ""
        set isLinkList ""
        foreach config $configList  {
            set dir [file dirname $config]
            if [catch {file readlink $dir} result] {
                lappend otherList $config
            } else {
                lappend linkList $dir
                lappend linkDescList "$dir --> $result"
                if [regexp {XR} $dir] {
                    lappend isXrayList 1
                } else {
                    lappend isXrayList 0
                }
                lappend isLinkList 1
            }
        }
        if [catch {eval exec sddscombine $otherList -pipe=out \
                     | sddsprocess -pipe -match=par,NameType=MonitorNames \
                     -nowarnings \"-match=col,Name=*ID*,Name=*BM*,|\" -nowarnings \
                     | sddsprocess -pipe -nowarnings \
                     \"-define=par,IsXray,n_rows 0 == pop pop ? 0 : 1 $,type=short\" \
                     | sddscollapse -pipe \
                     | sddsprocess -pipe \
                     -reedit=col,Filename,%/\/config// \
                     \"-reprint=col,Description,%s --> %s,Filename,Description\" \
                     -define=col,IsLink,0 \
                     | sddsconvert -pipe -retain=col,Filename,Description,IsLink,IsXray,KeepDays,PVType,CreationTime \
                     | sddssort -pipe=in -col=Filename,decreasing $configFile} result] {
            cd $oldDir
            return -code error "APSUpdateConfigDescriptionDatabase1.$plane: $result"
        }
        if [llength $linkList] {
            exec cp $configFile $tmpRoot.1
            if [catch {exec sddsmakedataset $tmpRoot.2 -col=Filename,type=string -data=[join $linkList ,] \
                           -col=Description,type=string "-data=[join $linkDescList ,]" \
                           -col=IsXray,type=short -data=[join $isXrayList ,] \
                           -col=IsLink,type=short -data=[join $isLinkList ,] 
                exec sddscombine $tmpRoot.2 $tmpRoot.1 -merge $configFile -overwrite} result] {
                cd $oldDir
                return -code error "APSUpdateConfigDescriptionDatabase1.$plane: $result"
            }
            catch {file delete -force $tmpRoot.1 $tmpRoot.2}
        }
    } else {
        if [string length $newConfig] {
            if ![file exist $newConfig/config] {
                return -code error "APSUpdateConfigDescriptionDatabase2: $newConfig/config does not exit."
            }
            set tmpfile /tmp/[APSTmpString] 
            if [catch {exec sddsprocess $configFile $tmpfile.config -nowarnings \
                           -match=col,Filename=$newConfig,!} result] {
                return -code error "APSUpdateConfigDescriptionDatabase4: $result"
            }
            APSAddToTmpFileList -ID updateconfigdesc -fileList $tmpfile.config
            if [catch {exec sddsprocess $newConfig/config -pipe=out -match=par,NameType=MonitorNames \
                         | sddsprocess -pipe \
                         "-match=col,Name=*ID*,Name=*BM*" -nowarnings \
                         "-define=par,IsXray,n_rows 0 == ? 0 : 1 $ " \
                         | sddscollapse -pipe \
                         | sddsprocess -pipe=in $tmpfile -reprint=col,Filename,$newConfig \
                         "-reprint=col,Description,%s --> %s,Filename,Description" } result] {
                cd $oldDir
                return -code error "APSUpdateConfigDescriptionDatabase5: $result"
            }
            APSAddToTmpFileList -ID updateconfigdesc -fileList $tmpfile 
            if [catch {exec sddscombine $tmpfile $tmpfile.config -merge -pipe=out \
                         | sddsconvert -pipe  -retain=col,Filename,Description,IsLink,IsXray,KeepDays,PVType,CreationTime \
                           | sddssort -pipe=in -col=Filename,decreasing -unique $configFile} result] {
                cd $oldDir
                return -code error "APSUpdateConfigDescriptionDatabase6: $result"
            }
        } elseif [string length $linkConfig] { 
            if [catch {file readlink $linkConfig} linkedConfig] {
                return -code error "APSUpdateConfigDescriptionDatabase7: $linkedConfig"
            }
	   
            set xray [regexp {XR} $linkConfig]
            if [catch {exec sddsmakedataset $tmpRoot.1 -col=Filename,type=string -data=$linkConfig \
                           -col=IsXray,type=short -data=$xray \
                           -col=Description,type=string "-data=$linkConfig --> $linkedConfig" \
                           -col=IsLink,type=short -data=1 
                exec sddsprocess $configFile $tmpRoot.2 -nowarnings -match=col,Filename=$linkConfig,! 
                exec sddscombine $tmpRoot.1 $tmpRoot.2 -merge -pipe=out \
                         | sddsconvert -pipe  -retain=col,Filename,Description,IsLink,IsXray,KeepDays,PVType,CreationTime \
                         | sddssort -pipe=in -col=Filename,decreasing  $configFile } result] {
                return -code error $result
            }
            catch {file delete -force $tmpRoot.1 $tmpRoot.2}
        }
    }
    set columns [exec sddsquery -col $configFile]
    if [lsearch $columns "KeepDays"]<0 {
        if [catch {exec sddsprocess $configFile -nowarnings \
                       "-redefine=col,KeepDays,-1,type=long" \
                       "-redefine=col,CreationTime,0,type=long" } result] {
            return -code error $result
        }   
    }
    cd $oldDir
}

proc APSUpdateBoosterOrbitCorrectionConfig {args} {
    set dataDir ""
    set newConfig ""
    APSStrictParseArguments {dataDir newConfig}
    if ![file exist $dataDir] {
        return -code error "APSUpdateBoostserConfigDescriptionDatabase: $dataDir does not exist!"
    }
    set plane [string index $newConfig 0]
    if {$plane!="h" && $plane!="v"} {
	return -code error "APSUpdateBoostserConfigDescriptionDatabase: invalid config - $newConfig provided."
    }
    
    set oldDir [pwd]
    cd $dataDir
    set dirs [lsort -decreasing [glob ${plane}.*]]
    set files ""
    set nameList ""
    set descList ""
    foreach dir $dirs {
	if [regexp {default} $dir] {
	    lappend nameList $dir
	    lappend descList "$dir      --> [file readlink $dir]"
	} else {
	    if [file exist $dir/config] {
		lappend files $dir/config
	    } else {
		catch {exec rm -r $dir}
	    }
	}
    }
    if ![llength $files] {
	return -code error "APSUpdateBoostserConfigDescriptionDatabase1: No configs found."
    }
    set tmpRoot /tmp/[APSTmpString]
    if [catch {exec sddsmakedataset $tmpRoot.1 -col=Filename,type=string -data=[join $nameList ,] \
		   -col=Description,type=string "-data=[join $descList ,]" } result] {
	return -code error $result
    }
    if ![llength $files] {
	return -code error "APSUpdateBoostserConfigDescriptionDatabase2: No configs found."
    }
    if [catch {eval exec sddscombine $files -pipe=out \
		   | sddscollapse -pipe \
		   | sddsconvert -pipe -retain=col,Filename,Description \
		   | sddssort -pipe -col=Filename,decreasing -unique \
		   | sddsprocess -reedit=col,Filename,%//config// \
		   -pipe=in $tmpRoot.2 \"-reprint=col,Description,%s --> %s,Filename,Description\" \
	       } result] {
	return -code error "APSUpdateBoostserConfigDescriptionDatabase3: $result"
    }
    if [catch {exec sddscombine $tmpRoot.1 $tmpRoot.2 -merge ${plane}configDesc.sdds -overwrite} result] {
	return -code error "APSUpdateBoostserConfigDescriptionDatabase4: $result"
    }
    catch {file delete -force $tmpRoot.1 $tmpRoot.2}
}

proc ComputeBoosterBPMTiming {args} {
    set startRamp ""
    APSParseArguments {startRamp}
    if [catch {exec cavget -list=BRF:S:Hp8657RefFreqAO -pend=30} rf] {
	return -code error "Error in reading rf freq: $rf"
    }
    #T0 in us seconds units
    #startRamp is ms,
    set T0 [expr 432.0/$rf*1e6]
    set time [expr 1000*int($startRamp/4/$T0)+1000]
    return $time
}
